!!
!!  File interfaceAD.F90 is part of COLLIER
!!  - A Complex One-Loop Library In Extended Regularizations
!!
!!  Copyright (C) 2015, 2016   Ansgar Denner, Stefan Dittmaier, Lars Hofer
!!
!!  COLLIER is licenced under the GNU GPL version 3, see COPYING for details.
!!

!#define RACOON
#define COLLIERTEST
!#define NOINTERFACE


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!  ************************
!  *  module interfaceAD  *
!  *    by Lars Hofer     *
!  ************************ 
! 
!  functions and subroutines:
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



!module interfaceAD
!
!  use COLLIER
!
!  implicit none
!
!
!contains


  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !  subroutine cBp12345(p10,m02,m12,
  !  &                B0,B1,B2,B3,B4,B5,B6,rank,switchin)
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#ifdef COLLIERTEST  
  subroutine cBp12345_if(p10,m02,m12,B0,B1,B2,B3,B4,B5,B6,rank,switchin,Berr)
#endif
#ifdef RACOON
  subroutine cBp12345(p10,m02,m12,B0,B1,B2,B3,B4,B5,B6,rank,switchin)
#endif

    use COLLIER

#ifdef RACOON
    entry cBp123(p10,m02,m12,B0,B1,B2,B3,rank)
#endif

    implicit none
    double complex, intent(in) :: p10,m02,m12
    integer, intent(in) :: rank, switchin
#ifdef COLLIERTEST  
    double precision, optional, intent(out) :: Berr(0:6)
#endif
    double complex, intent(out) :: B0,B1,B2(0:1,0:1),B3(0:1,0:1,0:1),B4(0:1,0:1,0:1,0:1)
    double complex, intent(out) :: B5(0:1,0:1,0:1,0:1,0:1),B6(0:1,0:1,0:1,0:1,0:1,0:1)
    double complex :: B0123456(0:rank/2,0:rank), B0123456uv(0:rank/2,0:rank)

#ifdef COLLIERTEST  
#ifdef NOINTERFACE
    if(present(Berr)) then
      call B_cll(B0123456,B0123456uv,p10,m02,m12,rank,Berr(0:rank))
    else
      call B_cll(B0123456,B0123456uv,p10,m02,m12,rank)
    endif
#else
    if(present(Berr)) then
      call B_cll(B0123456,B0123456uv,p10,m02,m12,rank,Berr(0:rank))
    else
      call B_cll(B0123456,B0123456uv,p10,m02,m12,rank)
    endif
#endif     
#endif     
   
#ifdef RACOON
#ifdef NOINTERFACE
      call B_cll(B0123456,B0123456uv,p10,m02,m12,rank)
#else
      call B_cll(B0123456,B0123456uv,p10,m02,m12,rank)
#endif     
#endif     
   
    B0 = B0123456(0,0)
    if (rank.eq.0) return

    B1 = B0123456(0,1)
    if (rank.eq.1) return

    B2(0,0) = B0123456(1,0)
    B2(1,1) = B0123456(0,2)
    if (rank.eq.2) return

    B3(0,0,1) = B0123456(1,1)
    B3(1,1,1) = B0123456(0,3)
    if (rank.eq.3) return

    B4(0,0,0,0) = B0123456(2,0)
    B4(0,0,1,1) = B0123456(1,2)
    B4(1,1,1,1) = B0123456(0,4)
    if (rank.eq.4) return
  
    B5(0,0,0,0,1) = B0123456(2,1)
    B5(0,0,1,1,1) = B0123456(1,3)
    B5(1,1,1,1,1) = B0123456(0,5)
    if (rank.eq.5) return

    B6(0,0,0,0,0,0) = B0123456(3,0)
    B6(0,0,0,0,1,1) = B0123456(2,2)
    B6(0,0,1,1,1,1) = B0123456(1,4)
    B6(1,1,1,1,1,1) = B0123456(0,6)

#ifdef COLLIERTEST  
  end subroutine cBp12345_if
#endif
#ifdef RACOON
  end subroutine cBp12345
#endif





  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !  subroutine cCp12345(p10,p21,p20,m02,m12,m22,
  !  &                C0,C1,C2,C3,C4,C5,rank)
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
#ifdef COLLIERTEST  
  subroutine cCp12345_if(p10,p21,p20,m02,m12,m22,C0,C1,C2,C3,C4,C5,C6,rank,Cerr,Cerr2)
#endif
#ifdef RACOON
  subroutine cCp12345(p10,p21,p20,m02,m12,m22,C0,C1,C2,C3,C4,C5,C6,rank)
#endif
    use COLLIER

    implicit none
    double complex, intent(in) :: p10,p21,p20,m02,m12,m22
    integer, intent(in)        :: rank
#ifdef COLLIERTEST
    double precision, optional, intent(out) :: Cerr(0:6),Cerr2(0:6)
    double precision :: Cerraux(0:6),Cerr2aux(0:6)
#endif
    double complex, intent(out) :: C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,0:2)
    double complex, intent(out) :: C4(0:2,0:2,0:2,0:2),C5(0:2,0:2,0:2,0:2,0:2)
    double complex, intent(out) :: C6(0:2,0:2,0:2,0:2,0:2,0:2)
    double complex :: C012345(0:rank/2,0:rank,0:rank),C012345uv(0:rank/2,0:rank,0:rank)

#ifdef COLLIERTEST
#ifdef NOINTERFACE
!    if(present(Cerr)) then
!      call C_main_cll(C012345,C012345uv,p10,p21,p20,m02,m12,m22,rank,Cerr(0:rank))
!    else
!      call C_main_cll(C012345,C012345uv,p10,p21,p20,m02,m12,m22,rank)
!    endif
 call C_main_cll(C012345,C012345uv,p10,p21,p20,m02,m12,m22,rank,Cerraux(0:rank),Cerr2=Cerr2aux(0:rank))
#else
!    if(present(Cerr)) then
!      call C_cll(C012345,C012345uv,p10,p21,p20,m02,m12,m22,rank,Cerr(0:rank))
!    else
!      call C_cll(C012345,C012345uv,p10,p21,p20,m02,m12,m22,rank)
!    endif
 call C_cll(C012345,C012345uv,p10,p21,p20,m02,m12,m22,rank,Cerraux(0:rank),Cerr2=Cerr2aux(0:rank))
#endif 
    if(present(Cerr))  Cerr(0:rank)=Cerraux(0:rank)    
    if(present(Cerr2)) Cerr2(0:rank)=Cerr2aux(0:rank)         
#endif
      
#ifdef RACOON
#ifdef NOINTERFACE
      call C_main_cll(C012345,C012345uv,p10,p21,p20,m02,m12,m22,rank)
#else
      call C_cll(C012345,C012345uv,p10,p21,p20,m02,m12,m22,rank)
#endif     
#endif
        
    C0 = C012345(0,0,0)
    if (rank.eq.0) return

    C1(1) = C012345(0,1,0)
    C1(2) = C012345(0,0,1)
    if (rank.eq.1) return

    C2(0,0) = C012345(1,0,0)
    C2(1,1) = C012345(0,2,0)
    C2(1,2) = C012345(0,1,1)
    C2(2,2) = C012345(0,0,2)
    if (rank.eq.2) return

    C3(0,0,1) = C012345(1,1,0)
    C3(0,0,2) = C012345(1,0,1)
    C3(1,1,1) = C012345(0,3,0)
    C3(1,1,2) = C012345(0,2,1)
    C3(1,2,2) = C012345(0,1,2)
    C3(2,2,2) = C012345(0,0,3)
    if (rank.eq.3) return

    C4(0,0,0,0) = C012345(2,0,0)
    C4(0,0,1,1) = C012345(1,2,0)
    C4(0,0,1,2) = C012345(1,1,1)
    C4(0,0,2,2) = C012345(1,0,2)
    C4(1,1,1,1) = C012345(0,4,0)
    C4(1,1,1,2) = C012345(0,3,1)
    C4(1,1,2,2) = C012345(0,2,2)
    C4(1,2,2,2) = C012345(0,1,3)
    C4(2,2,2,2) = C012345(0,0,4)
    if (rank.eq.4) return
  
    C5(0,0,0,0,1) = C012345(2,1,0)
    C5(0,0,0,0,2) = C012345(2,0,1)
    C5(0,0,1,1,1) = C012345(1,3,0)
    C5(0,0,1,1,2) = C012345(1,2,1)
    C5(0,0,1,2,2) = C012345(1,1,2)
    C5(0,0,2,2,2) = C012345(1,0,3)
    C5(1,1,1,1,1) = C012345(0,5,0)
    C5(1,1,1,1,2) = C012345(0,4,1)
    C5(1,1,1,2,2) = C012345(0,3,2)
    C5(1,1,2,2,2) = C012345(0,2,3)
    C5(1,2,2,2,2) = C012345(0,1,4)
    C5(2,2,2,2,2) = C012345(0,0,5)
    if (rank.eq.5) return
  
    C6(0,0,0,0,0,0) = C012345(3,0,0)
    C6(0,0,0,0,1,1) = C012345(2,2,0)
    C6(0,0,0,0,1,2) = C012345(2,1,1)
    C6(0,0,0,0,2,2) = C012345(2,0,2)
    C6(0,0,1,1,1,1) = C012345(1,4,0)
    C6(0,0,1,1,1,2) = C012345(1,3,1)
    C6(0,0,1,1,2,2) = C012345(1,2,2)
    C6(0,0,1,2,2,2) = C012345(1,1,3)
    C6(0,0,2,2,2,2) = C012345(1,0,4)
    C6(1,1,1,1,1,1) = C012345(0,6,0)
    C6(1,1,1,1,1,2) = C012345(0,5,1)
    C6(1,1,1,1,2,2) = C012345(0,4,2)
    C6(1,1,1,2,2,2) = C012345(0,3,3)
    C6(1,1,2,2,2,2) = C012345(0,2,4)
    C6(1,2,2,2,2,2) = C012345(0,1,5)
    C6(2,2,2,2,2,2) = C012345(0,0,6)

#ifdef COLLIERTEST  
  end subroutine cCp12345_if
#endif
#ifdef RACOON
  end subroutine cCp12345
#endif





  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  !  subroutine cDp12345(p10,p21,p32,p30,p20,p31,m02,m12,m22,m32,
  !   &              D0,D1,D2,D3,D4,D5,rank,eswitch)
  !
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
#ifdef COLLIERTEST  
  subroutine cDp12345_if(p10,p21,p32,p30,p20,p31,m02,m12,m22,m32,   & 
                         D0,D1,D2,D3,D4,D5,rank,eswitch,Derr,Derr2)
#endif
#ifdef RACOON
  subroutine cDp12345(p10,p21,p32,p30,p20,p31,m02,m12,m22,m32,   & 
                         D0,D1,D2,D3,D4,D5,rank,eswitch)
#endif

    use COLLIER

    implicit none
    double complex, intent(in) :: p10,p21,p32,p30,p20,p31,m02,m12,m22,m32
    integer, intent(in)        :: rank, eswitch
    double complex, intent(out) :: D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,0:3)
    double complex, intent(out) :: D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,0:3)
#ifdef COLLIERTEST  
    double precision, optional, intent(out) :: Derr(0:5),Derr2(0:5)
    double precision :: Derraux(0:5),Derr2aux(0:5)
#endif
    double complex :: D012345(0:rank/2,0:rank,0:rank,0:rank)
    double complex :: D012345uv(0:rank/2,0:rank,0:rank,0:rank)

!    write(*,*)  'cDp12345 in:',p10,p21,p32,p30,p20,p31,m02,m12,m22,m32,rank,eswitch

#ifdef COLLIERTEST  
#ifdef NOINTERFACE
!    if(present(Derr))then
!      call D_main_cll(D012345,D012345uv,p10,p21,p32,p30,p20,p31,m02,m12,m22,m32,rank,Derr(0:rank))
!    else
!      call D_main_cll(D012345,D012345uv,p10,p21,p32,p30,p20,p31,m02,m12,m22,m32,rank)
!    endif
     call D_main_cll(D012345,D012345uv,p10,p21,p32,p30,p20,p31,m02,m12,m22,m32,rank,Derraux(0:rank),Derr2=Derr2aux(0:rank))
#else
!    if(present(Derr))then
!      call D_cll(D012345,D012345uv,p10,p21,p32,p30,p20,p31,m02,m12,m22,m32,rank,Derr(0:rank))
!    else
!      call D_cll(D012345,D012345uv,p10,p21,p32,p30,p20,p31,m02,m12,m22,m32,rank)
     call D_cll(D012345,D012345uv,p10,p21,p32,p30,p20,p31,m02,m12,m22,m32,rank,Derraux(0:rank),Derr2=Derr2aux(0:rank))
!    endif
#endif     
    if(present(Derr))  Derr(0:rank)=Derraux(0:rank)    
    if(present(Derr2)) Derr2(0:rank)=Derr2aux(0:rank)    

!    if(present(Derr))     write(*,*) ' cDp12345_if Derr ',Derr
!    if(present(Derr2))    write(*,*) ' cDp12345_if Derr2',Derr2


#endif     
        
#ifdef RACOON
#ifdef NOINTERFACE
      call D_main_cll(D012345,D012345uv,p10,p21,p32,p30,p20,p31,m02,m12,m22,m32,rank)
#else
      call D_cll(D012345,D012345uv,p10,p21,p32,p30,p20,p31,m02,m12,m22,m32,rank)
#endif     
#endif     
        
    D0 = D012345(0,0,0,0)
    if (rank.eq.0) return

    D1(1) = D012345(0,1,0,0)
    D1(2) = D012345(0,0,1,0)
    D1(3) = D012345(0,0,0,1)
    if (rank.eq.1) return
    
    D2(0,0) = D012345(1,0,0,0)
    D2(1,1) = D012345(0,2,0,0)
    D2(1,2) = D012345(0,1,1,0)
    D2(1,3) = D012345(0,1,0,1)
    D2(2,2) = D012345(0,0,2,0)
    D2(2,3) = D012345(0,0,1,1)
    D2(3,3) = D012345(0,0,0,2)
    if (rank.eq.2) return

    D3(0,0,1) = D012345(1,1,0,0)
    D3(0,0,2) = D012345(1,0,1,0)
    D3(0,0,3) = D012345(1,0,0,1)
    D3(1,1,1) = D012345(0,3,0,0)
    D3(1,1,2) = D012345(0,2,1,0)
    D3(1,1,3) = D012345(0,2,0,1)
    D3(1,2,2) = D012345(0,1,2,0)
    D3(1,2,3) = D012345(0,1,1,1)
    D3(1,3,3) = D012345(0,1,0,2)
    D3(2,2,2) = D012345(0,0,3,0)
    D3(2,2,3) = D012345(0,0,2,1)
    D3(2,3,3) = D012345(0,0,1,2)
    D3(3,3,3) = D012345(0,0,0,3)
    if (rank.eq.3) return

    D4(0,0,0,0) = D012345(2,0,0,0)
    D4(0,0,1,1) = D012345(1,2,0,0)
    D4(0,0,1,2) = D012345(1,1,1,0)
    D4(0,0,1,3) = D012345(1,1,0,1)
    D4(0,0,2,2) = D012345(1,0,2,0)
    D4(0,0,2,3) = D012345(1,0,1,1)
    D4(0,0,3,3) = D012345(1,0,0,2) 
    D4(1,1,1,1) = D012345(0,4,0,0)
    D4(1,1,1,2) = D012345(0,3,1,0)
    D4(1,1,1,3) = D012345(0,3,0,1)
    D4(1,1,2,2) = D012345(0,2,2,0)
    D4(1,1,2,3) = D012345(0,2,1,1)
    D4(1,1,3,3) = D012345(0,2,0,2) 
    D4(1,2,2,2) = D012345(0,1,3,0)
    D4(1,2,2,3) = D012345(0,1,2,1)
    D4(1,2,3,3) = D012345(0,1,1,2)
    D4(1,3,3,3) = D012345(0,1,0,3)
    D4(2,2,2,2) = D012345(0,0,4,0)
    D4(2,2,2,3) = D012345(0,0,3,1)
    D4(2,2,3,3) = D012345(0,0,2,2)
    D4(2,3,3,3) = D012345(0,0,1,3)
    D4(3,3,3,3) = D012345(0,0,0,4)
    if (rank.eq.4) return

    D5(0,0,0,0,1) = D012345(2,1,0,0)
    D5(0,0,0,0,2) = D012345(2,0,1,0)
    D5(0,0,0,0,3) = D012345(2,0,0,1)
    D5(0,0,1,1,1) = D012345(1,3,0,0)
    D5(0,0,1,1,2) = D012345(1,2,1,0)
    D5(0,0,1,1,3) = D012345(1,2,0,1)
    D5(0,0,1,2,2) = D012345(1,1,2,0)
    D5(0,0,1,2,3) = D012345(1,1,1,1)
    D5(0,0,1,3,3) = D012345(1,1,0,2)
    D5(0,0,2,2,2) = D012345(1,0,3,0)
    D5(0,0,2,2,3) = D012345(1,0,2,1)
    D5(0,0,2,3,3) = D012345(1,0,1,2)
    D5(0,0,3,3,3) = D012345(1,0,0,3)
    D5(1,1,1,1,1) = D012345(0,5,0,0)
    D5(1,1,1,1,2) = D012345(0,4,1,0)
    D5(1,1,1,1,3) = D012345(0,4,0,1)
    D5(1,1,1,2,2) = D012345(0,3,2,0)
    D5(1,1,1,2,3) = D012345(0,3,1,1)
    D5(1,1,1,3,3) = D012345(0,3,0,2)
    D5(1,1,2,2,2) = D012345(0,2,3,0)
    D5(1,1,2,2,3) = D012345(0,2,2,1)
    D5(1,1,2,3,3) = D012345(0,2,1,2)
    D5(1,1,3,3,3) = D012345(0,2,0,3)
    D5(1,2,2,2,2) = D012345(0,1,4,0)
    D5(1,2,2,2,3) = D012345(0,1,3,1)
    D5(1,2,2,3,3) = D012345(0,1,2,2)
    D5(1,2,3,3,3) = D012345(0,1,1,3)
    D5(1,3,3,3,3) = D012345(0,1,0,4)
    D5(2,2,2,2,2) = D012345(0,0,5,0)
    D5(2,2,2,2,3) = D012345(0,0,4,1)
    D5(2,2,2,3,3) = D012345(0,0,3,2)
    D5(2,2,3,3,3) = D012345(0,0,2,3)
    D5(2,3,3,3,3) = D012345(0,0,1,4)
    D5(3,3,3,3,3) = D012345(0,0,0,5)

#ifdef COLLIERTEST  
  end subroutine cDp12345_if
#endif
#ifdef RACOON
  end subroutine cDp12345
#endif




#ifdef COLLIERTEST  
  subroutine cEp12345_if(p10,p21,p32,p43,p40,p20,p31,p42,p30,p41, &
       m02,m12,m22,m32,m42, &
       E0,E1,E2,E3,E4,E5,rank,Eerr,Eerr2)
#endif
#ifdef RACOON
  subroutine cEp12345(p10,p21,p32,p43,p40,p20,p31,p42,p30,p41, &
                                          m02,m12,m22,m32,m42, &
                         E0,E1,E2,E3,E4,E5,rank)
#endif

    use COLLIER

#ifdef RACOON
      entry cEp1234(p10,p21,p32,p43,p40,p20,p31,p42,p30,p41,   &
                                          m02,m12,m22,m32,m42, &
                         E0,E1,E2,E3,E4,rank)
#endif

    implicit none
    double complex, intent(in) :: p10,p21,p32,p43,p40,p20,p31,p42,p30,p41
    double complex, intent(in) :: m02,m12,m22,m32,m42
    integer, intent(in)        :: rank
#ifdef COLLIERTEST  
    double precision, optional, intent(out) :: Eerr(0:5),Eerr2(0:5)
    double precision :: Eerraux(0:5),Eerr2aux(0:5)
#endif
    double complex, intent(out) :: E0,E1(4),E2(0:4,0:4),E3(0:4,0:4,0:4)
    double complex, intent(out) :: E4(0:4,0:4,0:4,0:4),E5(0:4,0:4,0:4,0:4,0:4)
    double complex :: E012345(0:rank/2,0:rank,0:rank,0:rank,0:rank)
    double complex :: E012345uv(0:rank/2,0:rank,0:rank,0:rank,0:rank)

#ifdef COLLIERTEST  
#ifdef NOINTERFACE
!    if(present(Eerr)) then
!      call E_main_cll(E012345,E012345uv,p10,p21,p32,p43,p40,p20,p31,p42,p30,p41,m02,m12,m22,m32,m42,rank,Eerr(0:rank))
!    else
!      call E_main_cll(E012345,E012345uv,p10,p21,p32,p43,p40,p20,p31,p42,p30,p41,m02,m12,m22,m32,m42,rank)
!    endif
    call E_main_cll(E012345,E012345uv,p10,p21,p32,p43,p40,p20,p31,p42,p30,p41,m02,m12,m22,m32,m42,        &
        rank,Eerraux(0:rank),Eerr2=Eerr2aux(0:rank))
#else
!    if(present(Eerr)) then
!      call E_cll(E012345,E012345uv,p10,p21,p32,p43,p40,p20,p31,p42,p30,p41,m02,m12,m22,m32,m42,rank,Eerr(0:rmax))
!    else
!      call E_cll(E012345,E012345uv,p10,p21,p32,p43,p40,p20,p31,p42,p30,p41,m02,m12,m22,m32,m42,rank)
!    endif
    call E_cll(E012345,E012345uv,p10,p21,p32,p43,p40,p20,p31,p42,p30,p41,m02,m12,m22,m32,m42,      &
        rank,Eerraux(0:rank),Eerr2=Eerr2aux(0:rank))
#endif     
    if(present(Eerr))  Eerr(0:rank)=Eerraux(0:rank)    
    if(present(Eerr2)) Eerr2(0:rank)=Eerr2aux(0:rank)    
#endif     

#ifdef RACOON
#ifdef NOINTERFACE
      call E_main_cll(E012345,E012345uv,p10,p21,p32,p43,p40,p20,p31,p42,p30,p41,m02,m12,m22,m32,m42,rank)
#else
      call E_cll(E012345,E012345uv,p10,p21,p32,p43,p40,p20,p31,p42,p30,p41,m02,m12,m22,m32,m42,rank)
#endif     
#endif     

    E0 = E012345(0,0,0,0,0)
    if (rank.eq.0) return
    
    E1(1) = E012345(0,1,0,0,0)
    E1(2) = E012345(0,0,1,0,0)
    E1(3) = E012345(0,0,0,1,0)
    E1(4) = E012345(0,0,0,0,1)
    if (rank.eq.1) return

    E2(0,0) = E012345(1,0,0,0,0)
    E2(1,1) = E012345(0,2,0,0,0)
    E2(1,2) = E012345(0,1,1,0,0)
    E2(1,3) = E012345(0,1,0,1,0)
    E2(1,4) = E012345(0,1,0,0,1)
    E2(2,2) = E012345(0,0,2,0,0)
    E2(2,3) = E012345(0,0,1,1,0)
    E2(2,4) = E012345(0,0,1,0,1)
    E2(3,3) = E012345(0,0,0,2,0)
    E2(3,4) = E012345(0,0,0,1,1)
    E2(4,4) = E012345(0,0,0,0,2)
    if (rank.eq.2) return

    E3(0,0,1) = E012345(1,1,0,0,0)
    E3(0,0,2) = E012345(1,0,1,0,0)
    E3(0,0,3) = E012345(1,0,0,1,0)
    E3(0,0,4) = E012345(1,0,0,0,1)
    E3(1,1,1) = E012345(0,3,0,0,0)
    E3(1,1,2) = E012345(0,2,1,0,0)
    E3(1,1,3) = E012345(0,2,0,1,0)
    E3(1,1,4) = E012345(0,2,0,0,1)
    E3(1,2,2) = E012345(0,1,2,0,0)
    E3(1,2,3) = E012345(0,1,1,1,0)
    E3(1,2,4) = E012345(0,1,1,0,1)
    E3(1,3,3) = E012345(0,1,0,2,0)
    E3(1,3,4) = E012345(0,1,0,1,1)
    E3(1,4,4) = E012345(0,1,0,0,2)
    E3(2,2,2) = E012345(0,0,3,0,0)
    E3(2,2,3) = E012345(0,0,2,1,0)
    E3(2,2,4) = E012345(0,0,2,0,1)
    E3(2,3,3) = E012345(0,0,1,2,0)
    E3(2,3,4) = E012345(0,0,1,1,1)
    E3(2,4,4) = E012345(0,0,1,0,2)
    E3(3,3,3) = E012345(0,0,0,3,0)
    E3(3,3,4) = E012345(0,0,0,2,1)
    E3(3,4,4) = E012345(0,0,0,1,2)
    E3(4,4,4) = E012345(0,0,0,0,3)
    if (rank.eq.3) return

    E4(0,0,0,0) = E012345(2,0,0,0,0)
    E4(0,0,1,1) = E012345(1,2,0,0,0)
    E4(0,0,1,2) = E012345(1,1,1,0,0)
    E4(0,0,1,3) = E012345(1,1,0,1,0)
    E4(0,0,1,4) = E012345(1,1,0,0,1)
    E4(0,0,2,2) = E012345(1,0,2,0,0)
    E4(0,0,2,3) = E012345(1,0,1,1,0)
    E4(0,0,2,4) = E012345(1,0,1,0,1)
    E4(0,0,3,3) = E012345(1,0,0,2,0)
    E4(0,0,3,4) = E012345(1,0,0,1,1)
    E4(0,0,4,4) = E012345(1,0,0,0,2)
    E4(1,1,1,1) = E012345(0,4,0,0,0)
    E4(1,1,1,2) = E012345(0,3,1,0,0)
    E4(1,1,1,3) = E012345(0,3,0,1,0)
    E4(1,1,1,4) = E012345(0,3,0,0,1)
    E4(1,1,2,2) = E012345(0,2,2,0,0)
    E4(1,1,2,3) = E012345(0,2,1,1,0)
    E4(1,1,2,4) = E012345(0,2,1,0,1)
    E4(1,1,3,3) = E012345(0,2,0,2,0)
    E4(1,1,3,4) = E012345(0,2,0,1,1)
    E4(1,1,4,4) = E012345(0,2,0,0,2)
    E4(1,2,2,2) = E012345(0,1,3,0,0)
    E4(1,2,2,3) = E012345(0,1,2,1,0)
    E4(1,2,2,4) = E012345(0,1,2,0,1)
    E4(1,2,3,3) = E012345(0,1,1,2,0)
    E4(1,2,3,4) = E012345(0,1,1,1,1)
    E4(1,2,4,4) = E012345(0,1,1,0,2)
    E4(1,3,3,3) = E012345(0,1,0,3,0)
    E4(1,3,3,4) = E012345(0,1,0,2,1)
    E4(1,3,4,4) = E012345(0,1,0,1,2)
    E4(1,4,4,4) = E012345(0,1,0,0,3)
    E4(2,2,2,2) = E012345(0,0,4,0,0)
    E4(2,2,2,3) = E012345(0,0,3,1,0)
    E4(2,2,2,4) = E012345(0,0,3,0,1)
    E4(2,2,3,3) = E012345(0,0,2,2,0)
    E4(2,2,3,4) = E012345(0,0,2,1,1)
    E4(2,2,4,4) = E012345(0,0,2,0,2)
    E4(2,3,3,3) = E012345(0,0,1,3,0)
    E4(2,3,3,4) = E012345(0,0,1,2,1)
    E4(2,3,4,4) = E012345(0,0,1,1,2)
    E4(2,4,4,4) = E012345(0,0,1,0,3)
    E4(3,3,3,3) = E012345(0,0,0,4,0)
    E4(3,3,3,4) = E012345(0,0,0,3,1)
    E4(3,3,4,4) = E012345(0,0,0,2,2)
    E4(3,4,4,4) = E012345(0,0,0,1,3)
    E4(4,4,4,4) = E012345(0,0,0,0,4)
    if (rank.eq.4) return

    E5(0,0,0,0,1) = E012345(2,1,0,0,0)
    E5(0,0,0,0,2) = E012345(2,0,1,0,0)
    E5(0,0,0,0,3) = E012345(2,0,0,1,0)
    E5(0,0,0,0,4) = E012345(2,0,0,0,1)
    E5(0,0,1,1,1) = E012345(1,3,0,0,0)
    E5(0,0,1,1,2) = E012345(1,2,1,0,0)
    E5(0,0,1,1,3) = E012345(1,2,0,1,0)
    E5(0,0,1,1,4) = E012345(1,2,0,0,1)
    E5(0,0,1,2,2) = E012345(1,1,2,0,0)
    E5(0,0,1,2,3) = E012345(1,1,1,1,0)
    E5(0,0,1,2,4) = E012345(1,1,1,0,1)
    E5(0,0,1,3,3) = E012345(1,1,0,2,0)
    E5(0,0,1,3,4) = E012345(1,1,0,1,1)
    E5(0,0,1,4,4) = E012345(1,1,0,0,2)
    E5(0,0,2,2,2) = E012345(1,0,3,0,0)
    E5(0,0,2,2,3) = E012345(1,0,2,1,0)
    E5(0,0,2,2,4) = E012345(1,0,2,0,1)
    E5(0,0,2,3,3) = E012345(1,0,1,2,0)
    E5(0,0,2,3,4) = E012345(1,0,1,1,1)
    E5(0,0,2,4,4) = E012345(1,0,1,0,2)
    E5(0,0,3,3,3) = E012345(1,0,0,3,0)
    E5(0,0,3,3,4) = E012345(1,0,0,2,1)
    E5(0,0,3,4,4) = E012345(1,0,0,1,2)
    E5(0,0,4,4,4) = E012345(1,0,0,0,3)
    E5(1,1,1,1,1) = E012345(0,5,0,0,0)
    E5(1,1,1,1,2) = E012345(0,4,1,0,0)
    E5(1,1,1,1,3) = E012345(0,4,0,1,0)
    E5(1,1,1,1,4) = E012345(0,4,0,0,1)
    E5(1,1,1,2,2) = E012345(0,3,2,0,0)
    E5(1,1,1,2,3) = E012345(0,3,1,1,0)
    E5(1,1,1,2,4) = E012345(0,3,1,0,1)
    E5(1,1,1,3,3) = E012345(0,3,0,2,0)
    E5(1,1,1,3,4) = E012345(0,3,0,1,1)
    E5(1,1,1,4,4) = E012345(0,3,0,0,2)
    E5(1,1,2,2,2) = E012345(0,2,3,0,0)
    E5(1,1,2,2,3) = E012345(0,2,2,1,0)
    E5(1,1,2,2,4) = E012345(0,2,2,0,1)
    E5(1,1,2,3,3) = E012345(0,2,1,2,0)
    E5(1,1,2,3,4) = E012345(0,2,1,1,1)
    E5(1,1,2,4,4) = E012345(0,2,1,0,2)
    E5(1,1,3,3,3) = E012345(0,2,0,3,0)
    E5(1,1,3,3,4) = E012345(0,2,0,2,1)
    E5(1,1,3,4,4) = E012345(0,2,0,1,2)
    E5(1,1,4,4,4) = E012345(0,2,0,0,3)
    E5(1,2,2,2,2) = E012345(0,1,4,0,0)
    E5(1,2,2,2,3) = E012345(0,1,3,1,0)
    E5(1,2,2,2,4) = E012345(0,1,3,0,1)
    E5(1,2,2,3,3) = E012345(0,1,2,2,0)
    E5(1,2,2,3,4) = E012345(0,1,2,1,1)
    E5(1,2,2,4,4) = E012345(0,1,2,0,2)
    E5(1,2,3,3,3) = E012345(0,1,1,3,0)
    E5(1,2,3,3,4) = E012345(0,1,1,2,1)
    E5(1,2,3,4,4) = E012345(0,1,1,1,2)
    E5(1,2,4,4,4) = E012345(0,1,1,0,3)
    E5(1,3,3,3,3) = E012345(0,1,0,4,0)
    E5(1,3,3,3,4) = E012345(0,1,0,3,1)
    E5(1,3,3,4,4) = E012345(0,1,0,2,2)
    E5(1,3,4,4,4) = E012345(0,1,0,1,3)
    E5(1,4,4,4,4) = E012345(0,1,0,0,4)
    E5(2,2,2,2,2) = E012345(0,0,5,0,0)
    E5(2,2,2,2,3) = E012345(0,0,4,1,0)
    E5(2,2,2,2,4) = E012345(0,0,4,0,1)
    E5(2,2,2,3,3) = E012345(0,0,3,2,0)
    E5(2,2,2,3,4) = E012345(0,0,3,1,1)
    E5(2,2,2,4,4) = E012345(0,0,3,0,2)
    E5(2,2,3,3,3) = E012345(0,0,2,3,0)
    E5(2,2,3,3,4) = E012345(0,0,2,2,1)
    E5(2,2,3,4,4) = E012345(0,0,2,1,2)
    E5(2,2,4,4,4) = E012345(0,0,2,0,3)
    E5(2,3,3,3,3) = E012345(0,0,1,4,0)
    E5(2,3,3,3,4) = E012345(0,0,1,3,1)
    E5(2,3,3,4,4) = E012345(0,0,1,2,2)
    E5(2,3,4,4,4) = E012345(0,0,1,1,3)
    E5(2,4,4,4,4) = E012345(0,0,1,0,4)
    E5(3,3,3,3,3) = E012345(0,0,0,5,0)
    E5(3,3,3,3,4) = E012345(0,0,0,4,1)
    E5(3,3,3,4,4) = E012345(0,0,0,3,2)
    E5(3,3,4,4,4) = E012345(0,0,0,2,3)
    E5(3,4,4,4,4) = E012345(0,0,0,1,4)
    E5(4,4,4,4,4) = E012345(0,0,0,0,5)

#ifdef COLLIERTEST  
  end subroutine cEp12345_if
#endif
#ifdef RACOON
  end subroutine cEp12345
#endif





#ifdef COLLIERTEST  
  subroutine cFp12345_if(p10,p21,p32,p43,p54,p50,p20,p31,p42,  &
                      p53,p40,p51,p30,p41,p52,m02,m12,m22,m32,m42,m52,  &
                      F0,F1,F2,F3,F4,F5,rank,Ferr,Ferr2)
#endif
#ifdef RACOON
  subroutine cFp12345(p10,p21,p32,p43,p54,p50,p20,p31,p42,  &
                      p53,p40,p51,p30,p41,p52,m02,m12,m22,m32,m42,m52,  &
                      F0,F1,F2,F3,F4,F5,rank)
#endif

    use COLLIER

#ifdef RACOON
      entry cFp1234(p10,p21,p32,p43,p54,p50,p20,p31,p42,  &
                    p53,p40,p51,p30,p41,p52,m02,m12,m22,m32,m42,m52,  &
                    F0,F1,F2,F3,F4,rank)
#endif

    implicit none
    double complex, intent(in) :: p10,p21,p32,p43,p54,p50,p20,p31,p42
    double complex, intent(in) :: p53,p40,p51,p30,p41,p52
    double complex, intent(in) :: m02,m12,m22,m32,m42,m52
    integer, intent(in)        :: rank
#ifdef COLLIERTEST  
    double precision, optional, intent(out) :: Ferr(0:5),Ferr2(0:5)
#endif
    double complex, intent(out) :: F0,F1(5),F2(0:5,0:5),F3(0:5,0:5,0:5)
    double complex, intent(out) :: F4(0:5,0:5,0:5,0:5),F5(0:5,0:5,0:5,0:5,0:5)
    double complex :: F012345(0:rank/2,0:rank,0:rank,0:rank,0:rank,0:rank)
    double complex :: F012345uv(0:rank/2,0:rank,0:rank,0:rank,0:rank,0:rank)

#ifdef COLLIERTEST  
#ifdef NOINTERFACE
    if(present(Ferr)) then
      if(present(Ferr2)) then
        call F_main_cll(F012345,F012345uv,p10,p21,p32,p43,p54,p50,p20,p31,p42,p53,p40,  &
                             p51,p30,p41,p52,m02,m12,m22,m32,m42,m52,rank,Ferr(0:rank),Ferr2=Ferr2(0:rank))
      else
        call F_main_cll(F012345,F012345uv,p10,p21,p32,p43,p54,p50,p20,p31,p42,p53,p40,  &
                             p51,p30,p41,p52,m02,m12,m22,m32,m42,m52,rank,Ferr(0:rank))
      endif
    else
      call F_main_cll(F012345,F012345uv,p10,p21,p32,p43,p54,p50,p20,p31,p42,p53,p40,  &
                             p51,p30,p41,p52,m02,m12,m22,m32,m42,m52,rank)
    endif
#else
    if(present(Ferr)) then
      if(present(Ferr2)) then
        call F_cll(F012345,F012345uv,p10,p21,p32,p43,p54,p50,p20,p31,p42,p53,p40, &
                             p51,p30,p41,p52,m02,m12,m22,m32,m42,m52,rank,Ferr(0:rank),Ferr2=Ferr2(0:rank))
      else
        call F_cll(F012345,F012345uv,p10,p21,p32,p43,p54,p50,p20,p31,p42,p53,p40, &
                             p51,p30,p41,p52,m02,m12,m22,m32,m42,m52,rank,Ferr(0:rank))
      end if
    else
      call F_cll(F012345,F012345uv,p10,p21,p32,p43,p54,p50,p20,p31,p42,p53,p40, &
                             p51,p30,p41,p52,m02,m12,m22,m32,m42,m52,rank)
    endif
#endif     
#endif     


#ifdef RACOON
#ifdef NOINTERFACE
      call F_main_cll(F012345,F012345uv,p10,p21,p32,p43,p54,p50,p20,p31,p42,p53,p40,  &
                             p51,p30,p41,p52,m02,m12,m22,m32,m42,m52,rank)
#else
      call F_cll(F012345,F012345uv,p10,p21,p32,p43,p54,p50,p20,p31,p42,p53,p40, &
                             p51,p30,p41,p52,m02,m12,m22,m32,m42,m52,rank)
#endif     
#endif     


    F0 = F012345(0,0,0,0,0,0)
    if (rank.eq.0) return
    
    F1(1) = F012345(0,1,0,0,0,0)
    F1(2) = F012345(0,0,1,0,0,0)
    F1(3) = F012345(0,0,0,1,0,0)
    F1(4) = F012345(0,0,0,0,1,0)
    F1(5) = F012345(0,0,0,0,0,1)
    if (rank.eq.1) return

    F2(0,0) = F012345(1,0,0,0,0,0)
    F2(1,1) = F012345(0,2,0,0,0,0)
    F2(1,2) = F012345(0,1,1,0,0,0)
    F2(1,3) = F012345(0,1,0,1,0,0)
    F2(1,4) = F012345(0,1,0,0,1,0)
    F2(1,5) = F012345(0,1,0,0,0,1)
    F2(2,2) = F012345(0,0,2,0,0,0)
    F2(2,3) = F012345(0,0,1,1,0,0)
    F2(2,4) = F012345(0,0,1,0,1,0)
    F2(2,5) = F012345(0,0,1,0,0,1)
    F2(3,3) = F012345(0,0,0,2,0,0)
    F2(3,4) = F012345(0,0,0,1,1,0)
    F2(3,5) = F012345(0,0,0,1,0,1)
    F2(4,4) = F012345(0,0,0,0,2,0)
    F2(4,5) = F012345(0,0,0,0,1,1)
    F2(5,5) = F012345(0,0,0,0,0,2)
    if (rank.eq.2) return

    F3(0,0,1) = F012345(1,1,0,0,0,0)
    F3(0,0,2) = F012345(1,0,1,0,0,0)
    F3(0,0,3) = F012345(1,0,0,1,0,0)
    F3(0,0,4) = F012345(1,0,0,0,1,0)
    F3(0,0,5) = F012345(1,0,0,0,0,1)
    F3(1,1,1) = F012345(0,3,0,0,0,0)
    F3(1,1,2) = F012345(0,2,1,0,0,0)
    F3(1,1,3) = F012345(0,2,0,1,0,0)
    F3(1,1,4) = F012345(0,2,0,0,1,0)
    F3(1,1,5) = F012345(0,2,0,0,0,1)
    F3(1,2,2) = F012345(0,1,2,0,0,0)
    F3(1,2,3) = F012345(0,1,1,1,0,0)
    F3(1,2,4) = F012345(0,1,1,0,1,0)
    F3(1,2,5) = F012345(0,1,1,0,0,1)
    F3(1,3,3) = F012345(0,1,0,2,0,0)
    F3(1,3,4) = F012345(0,1,0,1,1,0)
    F3(1,3,5) = F012345(0,1,0,1,0,1)
    F3(1,4,4) = F012345(0,1,0,0,2,0)
    F3(1,4,5) = F012345(0,1,0,0,1,1)
    F3(1,5,5) = F012345(0,1,0,0,0,2)
    F3(2,2,2) = F012345(0,0,3,0,0,0)
    F3(2,2,3) = F012345(0,0,2,1,0,0)
    F3(2,2,4) = F012345(0,0,2,0,1,0)
    F3(2,2,5) = F012345(0,0,2,0,0,1)
    F3(2,3,3) = F012345(0,0,1,2,0,0)
    F3(2,3,4) = F012345(0,0,1,1,1,0)
    F3(2,3,5) = F012345(0,0,1,1,0,1)
    F3(2,4,4) = F012345(0,0,1,0,2,0)
    F3(2,4,5) = F012345(0,0,1,0,1,1)
    F3(2,5,5) = F012345(0,0,1,0,0,2)
    F3(3,3,3) = F012345(0,0,0,3,0,0)
    F3(3,3,4) = F012345(0,0,0,2,1,0)
    F3(3,3,5) = F012345(0,0,0,2,0,1)
    F3(3,4,4) = F012345(0,0,0,1,2,0)
    F3(3,4,5) = F012345(0,0,0,1,1,1)
    F3(3,5,5) = F012345(0,0,0,1,0,2)
    F3(4,4,4) = F012345(0,0,0,0,3,0)
    F3(4,4,5) = F012345(0,0,0,0,2,1)
    F3(4,5,5) = F012345(0,0,0,0,1,2)
    F3(5,5,5) = F012345(0,0,0,0,0,3)
    if (rank.eq.3) return

    F4(0,0,0,0) = F012345(2,0,0,0,0,0)
    F4(0,0,1,1) = F012345(1,2,0,0,0,0)
    F4(0,0,1,2) = F012345(1,1,1,0,0,0)
    F4(0,0,1,3) = F012345(1,1,0,1,0,0)
    F4(0,0,1,4) = F012345(1,1,0,0,1,0)
    F4(0,0,1,5) = F012345(1,1,0,0,0,1)
    F4(0,0,2,2) = F012345(1,0,2,0,0,0)
    F4(0,0,2,3) = F012345(1,0,1,1,0,0)
    F4(0,0,2,4) = F012345(1,0,1,0,1,0)
    F4(0,0,2,5) = F012345(1,0,1,0,0,1)
    F4(0,0,3,3) = F012345(1,0,0,2,0,0)
    F4(0,0,3,4) = F012345(1,0,0,1,1,0)
    F4(0,0,3,5) = F012345(1,0,0,1,0,1)
    F4(0,0,4,4) = F012345(1,0,0,0,2,0)
    F4(0,0,4,5) = F012345(1,0,0,0,1,1)
    F4(0,0,5,5) = F012345(1,0,0,0,0,2)
    F4(1,1,1,1) = F012345(0,4,0,0,0,0)
    F4(1,1,1,2) = F012345(0,3,1,0,0,0)
    F4(1,1,1,3) = F012345(0,3,0,1,0,0)
    F4(1,1,1,4) = F012345(0,3,0,0,1,0)
    F4(1,1,1,5) = F012345(0,3,0,0,0,1)
    F4(1,1,2,2) = F012345(0,2,2,0,0,0)
    F4(1,1,2,3) = F012345(0,2,1,1,0,0)
    F4(1,1,2,4) = F012345(0,2,1,0,1,0)
    F4(1,1,2,5) = F012345(0,2,1,0,0,1)
    F4(1,1,3,3) = F012345(0,2,0,2,0,0)
    F4(1,1,3,4) = F012345(0,2,0,1,1,0)
    F4(1,1,3,5) = F012345(0,2,0,1,0,1)
    F4(1,1,4,4) = F012345(0,2,0,0,2,0)
    F4(1,1,4,5) = F012345(0,2,0,0,1,1)
    F4(1,1,5,5) = F012345(0,2,0,0,0,2)
    F4(1,2,2,2) = F012345(0,1,3,0,0,0)
    F4(1,2,2,3) = F012345(0,1,2,1,0,0)
    F4(1,2,2,4) = F012345(0,1,2,0,1,0)
    F4(1,2,2,5) = F012345(0,1,2,0,0,1)
    F4(1,2,3,3) = F012345(0,1,1,2,0,0)
    F4(1,2,3,4) = F012345(0,1,1,1,1,0)
    F4(1,2,3,5) = F012345(0,1,1,1,0,1)
    F4(1,2,4,4) = F012345(0,1,1,0,2,0)
    F4(1,2,4,5) = F012345(0,1,1,0,1,1)
    F4(1,2,5,5) = F012345(0,1,1,0,0,2)
    F4(1,3,3,3) = F012345(0,1,0,3,0,0)
    F4(1,3,3,4) = F012345(0,1,0,2,1,0)
    F4(1,3,3,5) = F012345(0,1,0,2,0,1)
    F4(1,3,4,4) = F012345(0,1,0,1,2,0)
    F4(1,3,4,5) = F012345(0,1,0,1,1,1)
    F4(1,3,5,5) = F012345(0,1,0,1,0,2)
    F4(1,4,4,4) = F012345(0,1,0,0,3,0)
    F4(1,4,4,5) = F012345(0,1,0,0,2,1)
    F4(1,4,5,5) = F012345(0,1,0,0,1,2)
    F4(1,5,5,5) = F012345(0,1,0,0,0,3)
    F4(2,2,2,2) = F012345(0,0,4,0,0,0)
    F4(2,2,2,3) = F012345(0,0,3,1,0,0)
    F4(2,2,2,4) = F012345(0,0,3,0,1,0)
    F4(2,2,2,5) = F012345(0,0,3,0,0,1)
    F4(2,2,3,3) = F012345(0,0,2,2,0,0)
    F4(2,2,3,4) = F012345(0,0,2,1,1,0)
    F4(2,2,3,5) = F012345(0,0,2,1,0,1)
    F4(2,2,4,4) = F012345(0,0,2,0,2,0)
    F4(2,2,4,5) = F012345(0,0,2,0,1,1)
    F4(2,2,5,5) = F012345(0,0,2,0,0,2)
    F4(2,3,3,3) = F012345(0,0,1,3,0,0)
    F4(2,3,3,4) = F012345(0,0,1,2,1,0)
    F4(2,3,3,5) = F012345(0,0,1,2,0,1)
    F4(2,3,4,4) = F012345(0,0,1,1,2,0)
    F4(2,3,4,5) = F012345(0,0,1,1,1,1)
    F4(2,3,5,5) = F012345(0,0,1,1,0,2)
    F4(2,4,4,4) = F012345(0,0,1,0,3,0)
    F4(2,4,4,5) = F012345(0,0,1,0,2,1)
    F4(2,4,5,5) = F012345(0,0,1,0,1,2)
    F4(2,5,5,5) = F012345(0,0,1,0,0,3)
    F4(3,3,3,3) = F012345(0,0,0,4,0,0)
    F4(3,3,3,4) = F012345(0,0,0,3,1,0)
    F4(3,3,3,5) = F012345(0,0,0,3,0,1)
    F4(3,3,4,4) = F012345(0,0,0,2,2,0)
    F4(3,3,4,5) = F012345(0,0,0,2,1,1)
    F4(3,3,5,5) = F012345(0,0,0,2,0,2)
    F4(3,4,4,4) = F012345(0,0,0,1,3,0)
    F4(3,4,4,5) = F012345(0,0,0,1,2,1)
    F4(3,4,5,5) = F012345(0,0,0,1,1,2)
    F4(3,5,5,5) = F012345(0,0,0,1,0,3)
    F4(4,4,4,4) = F012345(0,0,0,0,4,0)
    F4(4,4,4,5) = F012345(0,0,0,0,3,1)
    F4(4,4,5,5) = F012345(0,0,0,0,2,2)
    F4(4,5,5,5) = F012345(0,0,0,0,1,3)
    F4(5,5,5,5) = F012345(0,0,0,0,0,4)
    if (rank.eq.4) return

    F5(0,0,0,0,1) = F012345(2,1,0,0,0,0)
    F5(0,0,0,0,2) = F012345(2,0,1,0,0,0)
    F5(0,0,0,0,3) = F012345(2,0,0,1,0,0)
    F5(0,0,0,0,4) = F012345(2,0,0,0,1,0)
    F5(0,0,0,0,5) = F012345(2,0,0,0,0,1)
    F5(0,0,1,1,1) = F012345(1,3,0,0,0,0)
    F5(0,0,1,1,2) = F012345(1,2,1,0,0,0)
    F5(0,0,1,1,3) = F012345(1,2,0,1,0,0)
    F5(0,0,1,1,4) = F012345(1,2,0,0,1,0)
    F5(0,0,1,1,5) = F012345(1,2,0,0,0,1)
    F5(0,0,1,2,2) = F012345(1,1,2,0,0,0)
    F5(0,0,1,2,3) = F012345(1,1,1,1,0,0)
    F5(0,0,1,2,4) = F012345(1,1,1,0,1,0)
    F5(0,0,1,2,5) = F012345(1,1,1,0,0,1)
    F5(0,0,1,3,3) = F012345(1,1,0,2,0,0)
    F5(0,0,1,3,4) = F012345(1,1,0,1,1,0)
    F5(0,0,1,3,5) = F012345(1,1,0,1,0,1)
    F5(0,0,1,4,4) = F012345(1,1,0,0,2,0)
    F5(0,0,1,4,5) = F012345(1,1,0,0,1,1)
    F5(0,0,1,5,5) = F012345(1,1,0,0,0,2)
    F5(0,0,2,2,2) = F012345(1,0,3,0,0,0)
    F5(0,0,2,2,3) = F012345(1,0,2,1,0,0)
    F5(0,0,2,2,4) = F012345(1,0,2,0,1,0)
    F5(0,0,2,2,5) = F012345(1,0,2,0,0,1)
    F5(0,0,2,3,3) = F012345(1,0,1,2,0,0)
    F5(0,0,2,3,4) = F012345(1,0,1,1,1,0)
    F5(0,0,2,3,5) = F012345(1,0,1,1,0,1)
    F5(0,0,2,4,4) = F012345(1,0,1,0,2,0)
    F5(0,0,2,4,5) = F012345(1,0,1,0,1,1)
    F5(0,0,2,5,5) = F012345(1,0,1,0,0,2)
    F5(0,0,3,3,3) = F012345(1,0,0,3,0,0)
    F5(0,0,3,3,4) = F012345(1,0,0,2,1,0)
    F5(0,0,3,3,5) = F012345(1,0,0,2,0,1)
    F5(0,0,3,4,4) = F012345(1,0,0,1,2,0)
    F5(0,0,3,4,5) = F012345(1,0,0,1,1,1)
    F5(0,0,3,5,5) = F012345(1,0,0,1,0,2)
    F5(0,0,4,4,4) = F012345(1,0,0,0,3,0)
    F5(0,0,4,4,5) = F012345(1,0,0,0,2,1)
    F5(0,0,4,5,5) = F012345(1,0,0,0,1,2)
    F5(0,0,5,5,5) = F012345(1,0,0,0,0,3)
    F5(1,1,1,1,1) = F012345(0,5,0,0,0,0)
    F5(1,1,1,1,2) = F012345(0,4,1,0,0,0)
    F5(1,1,1,1,3) = F012345(0,4,0,1,0,0)
    F5(1,1,1,1,4) = F012345(0,4,0,0,1,0)
    F5(1,1,1,1,5) = F012345(0,4,0,0,0,1)
    F5(1,1,1,2,2) = F012345(0,3,2,0,0,0)
    F5(1,1,1,2,3) = F012345(0,3,1,1,0,0)
    F5(1,1,1,2,4) = F012345(0,3,1,0,1,0)
    F5(1,1,1,2,5) = F012345(0,3,1,0,0,1)
    F5(1,1,1,3,3) = F012345(0,3,0,2,0,0)
    F5(1,1,1,3,4) = F012345(0,3,0,1,1,0)
    F5(1,1,1,3,5) = F012345(0,3,0,1,0,1)
    F5(1,1,1,4,4) = F012345(0,3,0,0,2,0)
    F5(1,1,1,4,5) = F012345(0,3,0,0,1,1)
    F5(1,1,1,5,5) = F012345(0,3,0,0,0,2)
    F5(1,1,2,2,2) = F012345(0,2,3,0,0,0)
    F5(1,1,2,2,3) = F012345(0,2,2,1,0,0)
    F5(1,1,2,2,4) = F012345(0,2,2,0,1,0)
    F5(1,1,2,2,5) = F012345(0,2,2,0,0,1)
    F5(1,1,2,3,3) = F012345(0,2,1,2,0,0)
    F5(1,1,2,3,4) = F012345(0,2,1,1,1,0)
    F5(1,1,2,3,5) = F012345(0,2,1,1,0,1)
    F5(1,1,2,4,4) = F012345(0,2,1,0,2,0)
    F5(1,1,2,4,5) = F012345(0,2,1,0,1,1)
    F5(1,1,2,5,5) = F012345(0,2,1,0,0,2)
    F5(1,1,3,3,3) = F012345(0,2,0,3,0,0)
    F5(1,1,3,3,4) = F012345(0,2,0,2,1,0)
    F5(1,1,3,3,5) = F012345(0,2,0,2,0,1)
    F5(1,1,3,4,4) = F012345(0,2,0,1,2,0)
    F5(1,1,3,4,5) = F012345(0,2,0,1,1,1)
    F5(1,1,3,5,5) = F012345(0,2,0,1,0,2)
    F5(1,1,4,4,4) = F012345(0,2,0,0,3,0)
    F5(1,1,4,4,5) = F012345(0,2,0,0,2,1)
    F5(1,1,4,5,5) = F012345(0,2,0,0,1,2)
    F5(1,1,5,5,5) = F012345(0,2,0,0,0,3)
    F5(1,2,2,2,2) = F012345(0,1,4,0,0,0)
    F5(1,2,2,2,3) = F012345(0,1,3,1,0,0)
    F5(1,2,2,2,4) = F012345(0,1,3,0,1,0)
    F5(1,2,2,2,5) = F012345(0,1,3,0,0,1)
    F5(1,2,2,3,3) = F012345(0,1,2,2,0,0)
    F5(1,2,2,3,4) = F012345(0,1,2,1,1,0)
    F5(1,2,2,3,5) = F012345(0,1,2,1,0,1)
    F5(1,2,2,4,4) = F012345(0,1,2,0,2,0)
    F5(1,2,2,4,5) = F012345(0,1,2,0,1,1)
    F5(1,2,2,5,5) = F012345(0,1,2,0,0,2)
    F5(1,2,3,3,3) = F012345(0,1,1,3,0,0)
    F5(1,2,3,3,4) = F012345(0,1,1,2,1,0)
    F5(1,2,3,3,5) = F012345(0,1,1,2,0,1)
    F5(1,2,3,4,4) = F012345(0,1,1,1,2,0)
    F5(1,2,3,4,5) = F012345(0,1,1,1,1,1)
    F5(1,2,3,5,5) = F012345(0,1,1,1,0,2)
    F5(1,2,4,4,4) = F012345(0,1,1,0,3,0)
    F5(1,2,4,4,5) = F012345(0,1,1,0,2,1)
    F5(1,2,4,5,5) = F012345(0,1,1,0,1,2)
    F5(1,2,5,5,5) = F012345(0,1,1,0,0,3)
    F5(1,3,3,3,3) = F012345(0,1,0,4,0,0)
    F5(1,3,3,3,4) = F012345(0,1,0,3,1,0)
    F5(1,3,3,3,5) = F012345(0,1,0,3,0,1)
    F5(1,3,3,4,4) = F012345(0,1,0,2,2,0)
    F5(1,3,3,4,5) = F012345(0,1,0,2,1,1)
    F5(1,3,3,5,5) = F012345(0,1,0,2,0,2)
    F5(1,3,4,4,4) = F012345(0,1,0,1,3,0)
    F5(1,3,4,4,5) = F012345(0,1,0,1,2,1)
    F5(1,3,4,5,5) = F012345(0,1,0,1,1,2)
    F5(1,3,5,5,5) = F012345(0,1,0,1,0,3)
    F5(1,4,4,4,4) = F012345(0,1,0,0,4,0)
    F5(1,4,4,4,5) = F012345(0,1,0,0,3,1)
    F5(1,4,4,5,5) = F012345(0,1,0,0,2,2)
    F5(1,4,5,5,5) = F012345(0,1,0,0,1,3)
    F5(1,5,5,5,5) = F012345(0,1,0,0,0,4)
    F5(2,2,2,2,2) = F012345(0,0,5,0,0,0)
    F5(2,2,2,2,3) = F012345(0,0,4,1,0,0)
    F5(2,2,2,2,4) = F012345(0,0,4,0,1,0)
    F5(2,2,2,2,5) = F012345(0,0,4,0,0,1)
    F5(2,2,2,3,3) = F012345(0,0,3,2,0,0)
    F5(2,2,2,3,4) = F012345(0,0,3,1,1,0)
    F5(2,2,2,3,5) = F012345(0,0,3,1,0,1)
    F5(2,2,2,4,4) = F012345(0,0,3,0,2,0)
    F5(2,2,2,4,5) = F012345(0,0,3,0,1,1)
    F5(2,2,2,5,5) = F012345(0,0,3,0,0,2)
    F5(2,2,3,3,3) = F012345(0,0,2,3,0,0)
    F5(2,2,3,3,4) = F012345(0,0,2,2,1,0)
    F5(2,2,3,3,5) = F012345(0,0,2,2,0,1)
    F5(2,2,3,4,4) = F012345(0,0,2,1,2,0)
    F5(2,2,3,4,5) = F012345(0,0,2,1,1,1)
    F5(2,2,3,5,5) = F012345(0,0,2,1,0,2)
    F5(2,2,4,4,4) = F012345(0,0,2,0,3,0)
    F5(2,2,4,4,5) = F012345(0,0,2,0,2,1)
    F5(2,2,4,5,5) = F012345(0,0,2,0,1,2)
    F5(2,2,5,5,5) = F012345(0,0,2,0,0,3)
    F5(2,3,3,3,3) = F012345(0,0,1,4,0,0)
    F5(2,3,3,3,4) = F012345(0,0,1,3,1,0)
    F5(2,3,3,3,5) = F012345(0,0,1,3,0,1)
    F5(2,3,3,4,4) = F012345(0,0,1,2,2,0)
    F5(2,3,3,4,5) = F012345(0,0,1,2,1,1)
    F5(2,3,3,5,5) = F012345(0,0,1,2,0,2)
    F5(2,3,4,4,4) = F012345(0,0,1,1,3,0)
    F5(2,3,4,4,5) = F012345(0,0,1,1,2,1)
    F5(2,3,4,5,5) = F012345(0,0,1,1,1,2)
    F5(2,3,5,5,5) = F012345(0,0,1,1,0,3)
    F5(2,4,4,4,4) = F012345(0,0,1,0,4,0)
    F5(2,4,4,4,5) = F012345(0,0,1,0,3,1)
    F5(2,4,4,5,5) = F012345(0,0,1,0,2,2)
    F5(2,4,5,5,5) = F012345(0,0,1,0,1,3)
    F5(2,5,5,5,5) = F012345(0,0,1,0,0,4)
    F5(3,3,3,3,3) = F012345(0,0,0,5,0,0)
    F5(3,3,3,3,4) = F012345(0,0,0,4,1,0)
    F5(3,3,3,3,5) = F012345(0,0,0,4,0,1)
    F5(3,3,3,4,4) = F012345(0,0,0,3,2,0)
    F5(3,3,3,4,5) = F012345(0,0,0,3,1,1)
    F5(3,3,3,5,5) = F012345(0,0,0,3,0,2)
    F5(3,3,4,4,4) = F012345(0,0,0,2,3,0)
    F5(3,3,4,4,5) = F012345(0,0,0,2,2,1)
    F5(3,3,4,5,5) = F012345(0,0,0,2,1,2)
    F5(3,3,5,5,5) = F012345(0,0,0,2,0,3)
    F5(3,4,4,4,4) = F012345(0,0,0,1,4,0)
    F5(4,4,4,4,4) = F012345(0,0,0,0,5,0)
    F5(4,4,4,4,5) = F012345(0,0,0,0,4,1)
    F5(4,4,4,5,5) = F012345(0,0,0,0,3,2)
    F5(4,4,5,5,5) = F012345(0,0,0,0,2,3)
    F5(4,5,5,5,5) = F012345(0,0,0,0,1,4)
    F5(5,5,5,5,5) = F012345(0,0,0,0,0,5)

#ifdef COLLIERTEST  
  end subroutine cFp12345_if
#endif
#ifdef RACOON
  end subroutine cFp12345
#endif


#ifdef COLLIERTEST  
  subroutine defcoli_if
#endif
#ifdef RACOON
  subroutine defcoli
#endif

    use COLLIER

!    call initcoli
    call Init_cll(6)
    call SwitchOffErrStop_cll()
    call SetMode_cll(1)            ! COLI
    call SetCheckAcc_cll(1d0)
    call SetCritAcc_cll(1d-2)
    call SetReqAcc_cll(1d-8)
!    call SetMode_cll(2)           ! DDlib
!    call setcminf2(dcmplx(1d-20))  ! to ensure correct calculation 
!                           of singular integrals in width
    call InitMonitoring_cll()

#ifdef COLLIERTEST  
  end subroutine defcoli_if
#endif
#ifdef RACOON
  end subroutine defcoli
#endif


#ifdef COLLIERTEST  
  subroutine setmphoton2_if(m2)
#endif
#ifdef RACOON
  subroutine setmphoton2(m2)
#endif

    use COLLIER

    implicit none
    double precision, intent(in) :: m2

    call SetMuIR2_cll(m2)

#ifdef COLLIERTEST  
  end subroutine setmphoton2_if
#endif
#ifdef RACOON
  end subroutine setmphoton2
#endif


#ifdef COLLIERTEST  
  subroutine setmudim2_if(m2)
#endif
#ifdef RACOON
  subroutine setmudim2(m2)
#endif

    use COLLIER

    implicit none
    double precision, intent(in) :: m2

    call SetMuUV2_cll(m2)

#ifdef COLLIERTEST  
  end subroutine setmudim2_if
#endif
#ifdef RACOON
  end subroutine setmudim2
#endif


#ifdef COLLIERTEST  
  subroutine setminf2_if(m2)
#endif
#ifdef RACOON
  subroutine setcminf2(m2)
#endif

    use COLLIER

    implicit none
    double complex, intent(in) :: m2

    call addminf2_cll(m2)

#ifdef COLLIERTEST  
  end subroutine setminf2_if
#endif
#ifdef RACOON
  end subroutine setcminf2
#endif


#ifdef COLLIERTEST  
  subroutine clearcoliminf2_if
!#endif
!#ifdef RACOON
!  subroutine clearcoliminf2
!#endif

    use COLLIER

    implicit none

    call clearminf2_cll

!#ifdef COLLIERTEST  
  end subroutine clearcoliminf2_if
#endif
!#ifdef RACOON
!  end subroutine clearcoliminf2
!#endif

#ifdef COLLIERTEST  
  subroutine setminfscale2_if(m2)
#endif
#ifdef RACOON
  subroutine setcminfscale2(m2)
#endif

    use COLLIER

    implicit none
    double precision, intent(in) :: m2

    return

#ifdef COLLIERTEST  
  end subroutine setminfscale2_if
#endif
#ifdef RACOON
  end subroutine setcminfscale2
#endif


#ifdef COLLIERTEST  
  function cA0f_if(m02)
#endif
#ifdef RACOON
  function cA0f(m02)
#endif

    implicit none
    double complex             :: cA0f,cA0f_if
    double complex, intent(in) :: m02
    double complex             :: A0_coli

#ifdef COLLIERTEST  
    cA0f_if=A0_coli(m02)
#endif
#ifdef RACOON  
    cA0f=A0_coli(m02)
#endif

#ifdef COLLIERTEST  
  end function cA0f_if
#endif
#ifdef RACOON
  end function cA0f
#endif

#ifdef COLLIERTEST  
  function cB0f_if(p,m02,m12)
#endif
#ifdef RACOON
  function cB0f(p,m02,m12)
#endif

    implicit none
    double complex             :: cB0f,cB0f_if
    double complex, intent(in) :: p,m02,m12
    double complex             :: B0_coli

#ifdef COLLIERTEST  
    cB0f_if=B0_coli(p,m02,m12)
#endif
#ifdef RACOON  
    cB0f=B0_coli(p,m02,m12)
#endif

#ifdef COLLIERTEST  
  end function cB0f_if
#endif
#ifdef RACOON
  end function cB0f
#endif

#ifdef COLLIERTEST  
  function cDB0f_if(p,m02,m12)
#endif
#ifdef RACOON
  function cDB0f(p,m02,m12)
#endif

    implicit none
    double complex             :: cDB0f,cDB0f_if
    double complex, intent(in) :: p,m02,m12
    double complex             :: DB0_coli

#ifdef COLLIERTEST  
    cDB0f_if=DB0_coli(p,m02,m12)
#endif
#ifdef RACOON  
    cDB0f=DB0_coli(p,m02,m12)
#endif

#ifdef COLLIERTEST  
  end function cDB0f_if
#endif
#ifdef RACOON
  end function cDB0f
#endif

#ifdef COLLIERTEST  
  function cB1f_if(p,m02,m12)
#endif
#ifdef RACOON
  function cB1f(p,m02,m12)
#endif

    implicit none
    double complex             :: cB1f,cB1f_if
    double complex, intent(in) :: p,m02,m12
    double complex             :: B1_coli

#ifdef COLLIERTEST  
    cB1f_if=B1_coli(p,m02,m12)
#endif
#ifdef RACOON  
    cB1f=B1_coli(p,m02,m12)
#endif

#ifdef COLLIERTEST  
  end function cB1f_if
#endif
#ifdef RACOON
  end function cB1f
#endif

#ifdef COLLIERTEST  
  function cDB1f_if(p,m02,m12)
#endif
#ifdef RACOON
  function cDB1f(p,m02,m12)
#endif

    implicit none
    double complex             :: cDB1f,cDB1f_if
    double complex, intent(in) :: p,m02,m12
    double complex             :: DB1_coli

#ifdef COLLIERTEST  
    cDB1f_if=DB1_coli(p,m02,m12)
#endif
#ifdef RACOON  
    cDB1f=DB1_coli(p,m02,m12)
#endif

#ifdef COLLIERTEST  
  end function cDB1f_if
#endif
#ifdef RACOON
  end function cDB1f
#endif

#ifdef COLLIERTEST  
  function cB00f_if(p,m02,m12)
#endif
#ifdef RACOON
  function cB00f(p,m02,m12)
#endif

    implicit none
    double complex             :: cB00f,cB00f_if
    double complex, intent(in) :: p,m02,m12
    double complex             :: B00_coli

#ifdef COLLIERTEST  
    cB00f_if=B00_coli(p,m02,m12)
#endif
#ifdef RACOON  
    cB00f=B00_coli(p,m02,m12)
#endif

#ifdef COLLIERTEST  
  end function cB00f_if
#endif
#ifdef RACOON
  end function cB00f
#endif


#ifdef COLLIERTEST  
  function cC0f_if(q12,q23,q13,m12,m22,m32)
#endif
#ifdef RACOON
  function cC0f(q12,q23,q13,m12,m22,m32)
#endif

    implicit none
    double complex             :: cC0f,cC0f_if
    double complex, intent(in) :: q12,q23,q13,m12,m22,m32
    double complex             :: C0_coli

#ifdef COLLIERTEST  
    cC0f_if=C0_coli(q12,q23,q13,m12,m22,m32)
#endif
#ifdef RACOON  
    cC0f=C0_coli(q12,q23,q13,m12,m22,m32)
#endif


#ifdef COLLIERTEST  
  end function cC0f_if
#endif
#ifdef RACOON
  end function cC0f
#endif


#ifdef COLLIERTEST  
  subroutine cacheon_if
#endif
#ifdef RACOON
  subroutine cacheon
#endif

    use COLLIER
    use cache

!   call SwitchOnCacheSystem
    call InitCacheSystem_cll(1,6)
!   call InitCacheSystem_cll(2,6)

#ifdef COLLIERTEST  
  end subroutine  cacheon_if
#endif
#ifdef RACOON
  end subroutine cacheon
#endif



#ifdef COLLIERTEST  
  subroutine cacheinit_if(nout)
#endif
#ifdef RACOON
  subroutine cacheinit(nout)
#endif

    use COLLIER
    use cache

    integer, intent(in)        :: nout

    call InitEvent_cll(1)
!   call InitEvent_cll(2)

#ifdef COLLIERTEST  
  end subroutine cacheinit_if
#endif
#ifdef RACOON
  end subroutine cacheinit
#endif




#ifdef COLLIERTEST  
  subroutine countinit_if(nout)
#endif
#ifdef RACOON
  subroutine countinit(nout)
#endif

    use COLLIER
    use coli_stat

    integer, intent(in)        :: nout

    call InitStatisticsa_coli

#ifdef COLLIERTEST  
  end subroutine countinit_if
#endif
#ifdef RACOON
  end subroutine countinit
#endif



#ifdef COLLIERTEST  
  subroutine writecount_if(nout)
#endif
#ifdef RACOON
  subroutine writecount(nout)
#endif

    use COLLIER
    use coli_stat

    integer, intent(in)        :: nout

#ifdef CritPointsCOLI
    call PrintStatisticscoli_cll(nout)
#endif
    call PrintStatistics_cll
#ifdef CritPoints2
    call PrintStatistics2_cll
#endif 

#ifdef COLLIERTEST  
  end subroutine writecount_if
#endif
#ifdef RACOON
  end subroutine writecount
#endif




!end module interfaceAD  
