      SUBROUTINE COEF_CONSTRUCTION_1(P,NHEL,H,IC)
C     
C     Modules
C     
      USE POLYNOMIAL_CONSTANTS
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=4)
      INTEGER    NCOMB
      PARAMETER (NCOMB=16)
      INTEGER NBORNAMPS
      PARAMETER (NBORNAMPS=1)
      INTEGER    NLOOPS, NLOOPGROUPS, NCTAMPS
      PARAMETER (NLOOPS=35, NLOOPGROUPS=25, NCTAMPS=15)
      INTEGER    NLOOPAMPS
      PARAMETER (NLOOPAMPS=50)
      INTEGER    NWAVEFUNCS,NLOOPWAVEFUNCS
      PARAMETER (NWAVEFUNCS=6,NLOOPWAVEFUNCS=73)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
      REAL*16     MP__ZERO
      PARAMETER (MP__ZERO=0.0E0_16)
C     These are constants related to the split orders
      INTEGER    NSO, NSQUAREDSO, NAMPSO
      PARAMETER (NSO=2, NSQUAREDSO=1, NAMPSO=2)
C     
C     ARGUMENTS
C     
      REAL*8 P(0:3,NEXTERNAL)
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
      INTEGER H
C     
C     LOCAL VARIABLES
C     
      INTEGER I,J,K
      COMPLEX*16 COEFS(MAXLWFSIZE,0:VERTEXMAXCOEFS-1,MAXLWFSIZE)

      LOGICAL DUMMYFALSE
      DATA DUMMYFALSE/.FALSE./
C     
C     GLOBAL VARIABLES
C     
      INCLUDE 'coupl.inc'
      INCLUDE 'mp_coupl.inc'

      INTEGER HELOFFSET
      INTEGER GOODHEL(NCOMB)
      LOGICAL GOODAMP(NSQUAREDSO,NLOOPGROUPS)
      COMMON/FILTERS/GOODAMP,GOODHEL,HELOFFSET

      LOGICAL CHECKPHASE
      LOGICAL HELDOUBLECHECKED
      COMMON/INIT/CHECKPHASE, HELDOUBLECHECKED

      INTEGER SQSO_TARGET
      COMMON/SOCHOICE/SQSO_TARGET

      LOGICAL UVCT_REQ_SO_DONE,MP_UVCT_REQ_SO_DONE,CT_REQ_SO_DONE
     $ ,MP_CT_REQ_SO_DONE,LOOP_REQ_SO_DONE,MP_LOOP_REQ_SO_DONE
     $ ,CTCALL_REQ_SO_DONE,FILTER_SO
      COMMON/SO_REQS/UVCT_REQ_SO_DONE,MP_UVCT_REQ_SO_DONE
     $ ,CT_REQ_SO_DONE,MP_CT_REQ_SO_DONE,LOOP_REQ_SO_DONE
     $ ,MP_LOOP_REQ_SO_DONE,CTCALL_REQ_SO_DONE,FILTER_SO

      INTEGER I_SO
      COMMON/I_SO/I_SO
      INTEGER I_LIB
      COMMON/I_LIB/I_LIB

      COMPLEX*16 AMP(NBORNAMPS)
      COMMON/AMPS/AMP
      COMPLEX*16 W(20,NWAVEFUNCS)
      COMMON/W/W

      COMPLEX*16 WL(MAXLWFSIZE,0:LOOPMAXCOEFS-1,MAXLWFSIZE,
     $ -1:NLOOPWAVEFUNCS)
      COMPLEX*16 PL(0:3,-1:NLOOPWAVEFUNCS)
      COMMON/WL/WL,PL

      COMPLEX*16 AMPL(3,NCTAMPS)
      COMMON/AMPL/AMPL

C     
C     ----------
C     BEGIN CODE
C     ----------

C     The target squared split order contribution is already reached
C      if true.
      IF (FILTER_SO.AND.LOOP_REQ_SO_DONE) THEN
        GOTO 1001
      ENDIF

C     Coefficient construction for loop diagram with ID 2
      CALL VVV1L1P0_3(PL(0,0),W(1,5),GC_4,DCMPLX(CMASS_MDL_MW),PL(0,1)
     $ ,COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,1))
      CALL VVV1L2P0_1(PL(0,1),W(1,6),GC_4,DCMPLX(ZERO),PL(0,2),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,1),4,COEFS,4,4,WL(1,0,1,2))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,2),2,4,1,1,1,16,H)
C     Coefficient construction for loop diagram with ID 3
      CALL VVS1L1_3(PL(0,0),W(1,5),-GC_93,DCMPLX(CMASS_MDL_MW),PL(0,3)
     $ ,COEFS)
      CALL UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1,3))
      CALL VVS1L3P0_1(PL(0,3),W(1,6),GC_93,DCMPLX(ZERO),PL(0,4),COEFS)
      CALL UPDATE_WL_0_0(WL(1,0,1,3),4,COEFS,1,4,WL(1,0,1,4))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,4),0,4,1,1,1,17,H)
C     Coefficient construction for loop diagram with ID 4
      CALL FFV2L3_1(PL(0,0),W(1,3),GC_67,DCMPLX(ZERO),PL(0,5),COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,5))
      CALL FFV1L2P0_3(PL(0,5),W(1,4),-GC_4,DCMPLX(ZERO),PL(0,6),COEFS)
      CALL UPDATE_WL_1_0(WL(1,0,1,5),4,COEFS,4,4,WL(1,0,1,6))
      CALL VVV1L1P0_3(PL(0,6),W(1,5),GC_4,DCMPLX(CMASS_MDL_MW),PL(0,7)
     $ ,COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,6),4,COEFS,4,4,WL(1,0,1,7))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,7),2,4,2,1,1,18,H)
C     Coefficient construction for loop diagram with ID 5
      CALL FFV1L1P0_3(PL(0,0),W(1,1),GC_1,DCMPLX(ZERO),PL(0,8),COEFS)
      CALL UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,8))
      CALL FFV1L3_2(PL(0,8),W(1,2),GC_2,DCMPLX(ZERO),PL(0,9),COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,8),4,COEFS,4,4,WL(1,0,1,9))
      CALL FFV2L1_2(PL(0,9),W(1,6),GC_67,DCMPLX(ZERO),PL(0,10),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,9),4,COEFS,4,4,WL(1,0,1,10))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,10),2,4,3,1,1,19,H)
C     Coefficient construction for loop diagram with ID 6
      CALL FFV1L3_1(PL(0,0),W(1,1),GC_1,DCMPLX(ZERO),PL(0,11),COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,11))
      CALL FFV2L2P0_3(PL(0,11),W(1,2),GC_67,DCMPLX(CMASS_MDL_MW),PL(0
     $ ,12),COEFS)
      CALL UPDATE_WL_1_0(WL(1,0,1,11),4,COEFS,4,4,WL(1,0,1,12))
      CALL VVV1L2P0_1(PL(0,12),W(1,6),GC_4,DCMPLX(ZERO),PL(0,13),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,12),4,COEFS,4,4,WL(1,0,1,13))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,13),2,4,4,1,1,20,H)
C     Coefficient construction for loop diagram with ID 7
      CALL FFV2L3_1(PL(0,12),W(1,3),GC_67,DCMPLX(ZERO),PL(0,14),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,12),4,COEFS,4,4,WL(1,0,1,14))
      CALL FFV1L2P0_3(PL(0,14),W(1,4),-GC_4,DCMPLX(ZERO),PL(0,15)
     $ ,COEFS)
      CALL UPDATE_WL_2_0(WL(1,0,1,14),4,COEFS,4,4,WL(1,0,1,15))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,15),2,4,5,1,1,21,H)
C     Coefficient construction for loop diagram with ID 8
      CALL FFV2L3_1(PL(0,0),W(1,1),GC_67,DCMPLX(ZERO),PL(0,16),COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,16))
      CALL FFV1L2P0_3(PL(0,16),W(1,2),GC_2,DCMPLX(ZERO),PL(0,17),COEFS)
      CALL UPDATE_WL_1_0(WL(1,0,1,16),4,COEFS,4,4,WL(1,0,1,17))
      CALL VVV1L1P0_2(PL(0,17),W(1,6),GC_4,DCMPLX(CMASS_MDL_MW),PL(0
     $ ,18),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,17),4,COEFS,4,4,WL(1,0,1,18))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,18),2,4,6,1,1,22,H)
C     Coefficient construction for loop diagram with ID 9
      CALL FFV1L3_2(PL(0,17),W(1,4),-GC_4,DCMPLX(ZERO),PL(0,19),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,17),4,COEFS,4,4,WL(1,0,1,19))
      CALL FFV2L1P0_3(PL(0,19),W(1,3),GC_67,DCMPLX(CMASS_MDL_MW),PL(0
     $ ,20),COEFS)
      CALL UPDATE_WL_2_0(WL(1,0,1,19),4,COEFS,4,4,WL(1,0,1,20))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,20),2,4,7,1,1,23,H)
C     Coefficient construction for loop diagram with ID 10
      CALL VVVV2L4P0_3(PL(0,0),W(1,5),W(1,6),GC_54,DCMPLX(CMASS_MDL_MZ)
     $ ,PL(0,21),COEFS)
      CALL UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,21))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,21),0,4,8,2,1,24,H)
C     Coefficient construction for loop diagram with ID 11
      CALL VVV1L3P0_2(PL(0,0),W(1,5),GC_71,DCMPLX(CMASS_MDL_MW),PL(0
     $ ,22),COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,22))
      CALL VVV1L1P0_3(PL(0,22),W(1,6),GC_71,DCMPLX(CMASS_MDL_MZ),PL(0
     $ ,23),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,22),4,COEFS,4,4,WL(1,0,1,23))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,23),2,4,9,1,1,25,H)
C     Coefficient construction for loop diagram with ID 12
      CALL VVS1L2_3(PL(0,0),W(1,5),-GC_84,DCMPLX(CMASS_MDL_MW),PL(0,24)
     $ ,COEFS)
      CALL UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1,24))
      CALL VVS1L3P0_2(PL(0,24),W(1,6),GC_84,DCMPLX(CMASS_MDL_MZ),PL(0
     $ ,25),COEFS)
      CALL UPDATE_WL_0_0(WL(1,0,1,24),4,COEFS,1,4,WL(1,0,1,25))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,25),0,4,9,1,1,26,H)
C     Coefficient construction for loop diagram with ID 13
      CALL FFV2L3_1(PL(0,0),W(1,3),GC_80,DCMPLX(ZERO),PL(0,26),COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,26))
      CALL FFV2L2P0_3(PL(0,26),W(1,4),GC_67,DCMPLX(CMASS_MDL_MW),PL(0
     $ ,27),COEFS)
      CALL UPDATE_WL_1_0(WL(1,0,1,26),4,COEFS,4,4,WL(1,0,1,27))
      CALL VVV1L2P0_3(PL(0,27),W(1,5),GC_71,DCMPLX(CMASS_MDL_MZ),PL(0
     $ ,28),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,27),4,COEFS,4,4,WL(1,0,1,28))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,28),2,4,10,1,1,27,H)
C     Coefficient construction for loop diagram with ID 14
      CALL FFV2L1P0_3(PL(0,0),W(1,3),GC_80,DCMPLX(CMASS_MDL_MZ),PL(0
     $ ,29),COEFS)
      CALL UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,29))
      CALL FFV2_4L3_2(PL(0,29),W(1,4),GC_68,GC_77,DCMPLX(ZERO),PL(0,30)
     $ ,COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,29),4,COEFS,4,4,WL(1,0,1,30))
      CALL FFV2L1_2(PL(0,30),W(1,5),GC_67,DCMPLX(ZERO),PL(0,31),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,30),4,COEFS,4,4,WL(1,0,1,31))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,31),2,4,11,1,1,28,H)
C     Coefficient construction for loop diagram with ID 15
      CALL FFV2_4L2P0_3(PL(0,5),W(1,4),GC_68,GC_77,DCMPLX(CMASS_MDL_MZ)
     $ ,PL(0,32),COEFS)
      CALL UPDATE_WL_1_0(WL(1,0,1,5),4,COEFS,4,4,WL(1,0,1,32))
      CALL VVV1L3P0_2(PL(0,32),W(1,5),GC_71,DCMPLX(CMASS_MDL_MW),PL(0
     $ ,33),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,32),4,COEFS,4,4,WL(1,0,1,33))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,33),2,4,12,1,1,29,H)
C     Coefficient construction for loop diagram with ID 16
      CALL FFV2_3L1P0_3(PL(0,0),W(1,1),GC_68,GC_76,DCMPLX(CMASS_MDL_MZ)
     $ ,PL(0,34),COEFS)
      CALL UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,34))
      CALL FFV2_5L3_2(PL(0,34),W(1,2),-GC_68,GC_76,DCMPLX(ZERO),PL(0
     $ ,35),COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,34),4,COEFS,4,4,WL(1,0,1,35))
      CALL FFV2L1_2(PL(0,35),W(1,6),GC_67,DCMPLX(ZERO),PL(0,36),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,35),4,COEFS,4,4,WL(1,0,1,36))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,36),2,4,13,1,1,30,H)
C     Coefficient construction for loop diagram with ID 17
      CALL FFV2_3L3_1(PL(0,0),W(1,1),GC_68,GC_76,DCMPLX(ZERO),PL(0,37)
     $ ,COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,37))
      CALL FFV2L2P0_3(PL(0,37),W(1,2),GC_67,DCMPLX(CMASS_MDL_MW),PL(0
     $ ,38),COEFS)
      CALL UPDATE_WL_1_0(WL(1,0,1,37),4,COEFS,4,4,WL(1,0,1,38))
      CALL VVV1L1P0_3(PL(0,38),W(1,6),GC_71,DCMPLX(CMASS_MDL_MZ),PL(0
     $ ,39),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,38),4,COEFS,4,4,WL(1,0,1,39))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,39),2,4,14,1,1,31,H)
C     Coefficient construction for loop diagram with ID 18
      CALL FFV2L3_2(PL(0,38),W(1,4),GC_67,DCMPLX(ZERO),PL(0,40),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,38),4,COEFS,4,4,WL(1,0,1,40))
      CALL FFV2L1P0_3(PL(0,40),W(1,3),GC_80,DCMPLX(CMASS_MDL_MZ),PL(0
     $ ,41),COEFS)
      CALL UPDATE_WL_2_0(WL(1,0,1,40),4,COEFS,4,4,WL(1,0,1,41))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,41),2,4,15,1,1,32,H)
C     Coefficient construction for loop diagram with ID 19
      CALL FFV2L3_1(PL(0,38),W(1,3),GC_67,DCMPLX(ZERO),PL(0,42),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,38),4,COEFS,4,4,WL(1,0,1,42))
      CALL FFV2_4L2P0_3(PL(0,42),W(1,4),GC_68,GC_77
     $ ,DCMPLX(CMASS_MDL_MZ),PL(0,43),COEFS)
      CALL UPDATE_WL_2_0(WL(1,0,1,42),4,COEFS,4,4,WL(1,0,1,43))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,43),2,4,16,1,1,33,H)
C     Coefficient construction for loop diagram with ID 20
      CALL FFV2_5L2P0_3(PL(0,16),W(1,2),-GC_68,GC_76
     $ ,DCMPLX(CMASS_MDL_MZ),PL(0,44),COEFS)
      CALL UPDATE_WL_1_0(WL(1,0,1,16),4,COEFS,4,4,WL(1,0,1,44))
      CALL VVV1L3P0_1(PL(0,44),W(1,6),GC_71,DCMPLX(CMASS_MDL_MW),PL(0
     $ ,45),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,44),4,COEFS,4,4,WL(1,0,1,45))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,45),2,4,17,1,1,34,H)
C     Coefficient construction for loop diagram with ID 21
      CALL FFV2L3_1(PL(0,44),W(1,3),GC_80,DCMPLX(ZERO),PL(0,46),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,44),4,COEFS,4,4,WL(1,0,1,46))
      CALL FFV2L2P0_3(PL(0,46),W(1,4),GC_67,DCMPLX(CMASS_MDL_MW),PL(0
     $ ,47),COEFS)
      CALL UPDATE_WL_2_0(WL(1,0,1,46),4,COEFS,4,4,WL(1,0,1,47))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,47),2,4,18,1,1,35,H)
C     Coefficient construction for loop diagram with ID 22
      CALL FFV2_4L3_2(PL(0,44),W(1,4),GC_68,GC_77,DCMPLX(ZERO),PL(0,48)
     $ ,COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,44),4,COEFS,4,4,WL(1,0,1,48))
      CALL FFV2L1P0_3(PL(0,48),W(1,3),GC_67,DCMPLX(CMASS_MDL_MW),PL(0
     $ ,49),COEFS)
      CALL UPDATE_WL_2_0(WL(1,0,1,48),4,COEFS,4,4,WL(1,0,1,49))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,49),2,4,19,1,1,36,H)
C     Coefficient construction for loop diagram with ID 23
      CALL VVSS1L4_3(PL(0,0),W(1,5),W(1,6),GC_52,DCMPLX(CMASS_MDL_MH)
     $ ,PL(0,50),COEFS)
      CALL UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,50))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,50),0,1,20,2,1,37,H)
C     Coefficient construction for loop diagram with ID 24
      CALL VSS1L3_2(PL(0,0),W(1,5),GC_55,DCMPLX(CMASS_MDL_MW),PL(0,51)
     $ ,COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,51))
      CALL VSS1L2_3(PL(0,51),W(1,6),GC_55,DCMPLX(CMASS_MDL_MH),PL(0,52)
     $ ,COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,51),1,COEFS,1,1,WL(1,0,1,52))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,52),2,1,21,1,1,38,H)
C     Coefficient construction for loop diagram with ID 25
      CALL VVS1L2_3(PL(0,0),W(1,5),GC_90,DCMPLX(CMASS_MDL_MH),PL(0,53)
     $ ,COEFS)
      CALL UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1,53))
      CALL VVS1L3P0_1(PL(0,53),W(1,6),GC_90,DCMPLX(CMASS_MDL_MW),PL(0
     $ ,54),COEFS)
      CALL UPDATE_WL_0_0(WL(1,0,1,53),4,COEFS,1,4,WL(1,0,1,54))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,54),0,4,22,1,1,39,H)
C     Coefficient construction for loop diagram with ID 26
      CALL VVSS1L4_3(PL(0,0),W(1,5),W(1,6),GC_52,DCMPLX(CMASS_MDL_MZ)
     $ ,PL(0,55),COEFS)
      CALL UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,55))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,55),0,1,8,2,1,40,H)
C     Coefficient construction for loop diagram with ID 27
      CALL VSS1L2_3(PL(0,0),W(1,5),GC_57,DCMPLX(CMASS_MDL_MW),PL(0,56)
     $ ,COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,56))
      CALL VSS1L3_2(PL(0,56),W(1,6),-GC_57,DCMPLX(CMASS_MDL_MZ),PL(0
     $ ,57),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,56),1,COEFS,1,1,WL(1,0,1,57))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,57),2,1,9,1,1,41,H)
C     Coefficient construction for loop diagram with ID 28
      CALL VVVV2L3P0_1(PL(0,0),W(1,5),W(1,6),GC_53,DCMPLX(CMASS_MDL_MW)
     $ ,PL(0,58),COEFS)
      CALL UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,58))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,58),0,4,23,1,1,42,H)
C     Coefficient construction for loop diagram with ID 29
      CALL VVSS1L4_3(PL(0,0),W(1,5),W(1,6),GC_52,DCMPLX(CMASS_MDL_MW)
     $ ,PL(0,59),COEFS)
      CALL UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,59))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,59),0,1,23,1,1,43,H)
C     Coefficient construction for loop diagram with ID 30
      CALL UUV1L1_2(PL(0,0),W(1,5),-GC_4,DCMPLX(MDL_MW),PL(0,60),COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,60))
      CALL UUV1L1_2(PL(0,60),W(1,6),-GC_4,DCMPLX(ZERO),PL(0,61),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,60),1,COEFS,1,1,WL(1,0,1,61))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,61),2,1,1,1,1,44,H)
C     Coefficient construction for loop diagram with ID 31
      CALL UUV1L2_1(PL(0,0),W(1,5),GC_4,DCMPLX(MDL_MW),PL(0,62),COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,62))
      CALL UUV1L2_1(PL(0,62),W(1,6),GC_4,DCMPLX(ZERO),PL(0,63),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,62),1,COEFS,1,1,WL(1,0,1,63))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,63),2,1,1,1,1,45,H)
C     Coefficient construction for loop diagram with ID 32
      CALL UUV1L1_2(PL(0,0),W(1,5),-GC_71,DCMPLX(MDL_MW),PL(0,64)
     $ ,COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,64))
      CALL UUV1L1_2(PL(0,64),W(1,6),-GC_71,DCMPLX(MDL_MZ),PL(0,65)
     $ ,COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,64),1,COEFS,1,1,WL(1,0,1,65))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,65),2,1,9,1,1,46,H)
C     Coefficient construction for loop diagram with ID 33
      CALL UUV1L2_1(PL(0,0),W(1,5),GC_71,DCMPLX(MDL_MW),PL(0,66),COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,66))
      CALL UUV1L2_1(PL(0,66),W(1,6),GC_71,DCMPLX(MDL_MZ),PL(0,67)
     $ ,COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,66),1,COEFS,1,1,WL(1,0,1,67))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,67),2,1,9,1,1,47,H)
C     Coefficient construction for loop diagram with ID 34
      CALL FFV2L1_2(PL(0,0),W(1,5),GC_67,DCMPLX(ZERO),PL(0,68),COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,68))
      CALL FFV2L1_2(PL(0,68),W(1,6),GC_67,DCMPLX(ZERO),PL(0,69),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,68),4,COEFS,4,4,WL(1,0,1,69))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,69),2,4,24,1,2,48,H)
C     Coefficient construction for loop diagram with ID 35
      CALL FFV2L1_2(PL(0,0),W(1,5),GC_67,DCMPLX(CMASS_MDL_MT),PL(0,70)
     $ ,COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,70))
      CALL FFV2L1_2(PL(0,70),W(1,6),GC_67,DCMPLX(ZERO),PL(0,71),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,70),4,COEFS,4,4,WL(1,0,1,71))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,71),2,4,25,1,1,49,H)
C     Coefficient construction for loop diagram with ID 36
      CALL FFV2L1_2(PL(0,0),W(1,5),GC_67,DCMPLX(ZERO),PL(0,72),COEFS)
      CALL UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,72))
      CALL FFV2L1_2(PL(0,72),W(1,6),GC_67,DCMPLX(ZERO),PL(0,73),COEFS)
      CALL UPDATE_WL_1_1(WL(1,0,1,72),4,COEFS,4,4,WL(1,0,1,73))
      CALL CREATE_LOOP_COEFS(WL(1,0,1,73),2,4,24,1,3,50,H)
C     At this point, all loop coefficients needed for (QCD=0 QED=6),
C      i.e. of split order ID=1, are computed.
      IF(FILTER_SO.AND.SQSO_TARGET.EQ.1) GOTO 4000

      GOTO 1001
 4000 CONTINUE
      LOOP_REQ_SO_DONE=.TRUE.
 1001 CONTINUE
      END

