      SUBROUTINE MP_COEF_CONSTRUCTION_1(P,NHEL,H,IC)
C     
      USE POLYNOMIAL_CONSTANTS
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=4)
      INTEGER    NCOMB
      PARAMETER (NCOMB=16)

      INTEGER NBORNAMPS
      PARAMETER (NBORNAMPS=1)
      INTEGER    NLOOPS, NLOOPGROUPS, NCTAMPS
      PARAMETER (NLOOPS=35, NLOOPGROUPS=25, NCTAMPS=15)
      INTEGER    NLOOPAMPS
      PARAMETER (NLOOPAMPS=50)
      INTEGER    NWAVEFUNCS,NLOOPWAVEFUNCS
      PARAMETER (NWAVEFUNCS=6,NLOOPWAVEFUNCS=73)
      REAL*16     ZERO
      PARAMETER (ZERO=0.0E0_16)
      COMPLEX*32     IZERO
      PARAMETER (IZERO=CMPLX(0.0E0_16,0.0E0_16,KIND=16))
C     These are constants related to the split orders
      INTEGER    NSO, NSQUAREDSO, NAMPSO
      PARAMETER (NSO=2, NSQUAREDSO=1, NAMPSO=2)
C     
C     ARGUMENTS
C     
      REAL*16 P(0:3,NEXTERNAL)
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
      INTEGER H
C     
C     LOCAL VARIABLES
C     
      INTEGER I,J,K
      COMPLEX*32 COEFS(MAXLWFSIZE,0:VERTEXMAXCOEFS-1,MAXLWFSIZE)
C     
C     GLOBAL VARIABLES
C     
      INCLUDE 'mp_coupl_same_name.inc'

      INTEGER GOODHEL(NCOMB)
      LOGICAL GOODAMP(NSQUAREDSO,NLOOPGROUPS)
      COMMON/FILTERS/GOODAMP,GOODHEL

      INTEGER SQSO_TARGET
      COMMON/SOCHOICE/SQSO_TARGET

      LOGICAL UVCT_REQ_SO_DONE,MP_UVCT_REQ_SO_DONE,CT_REQ_SO_DONE
     $ ,MP_CT_REQ_SO_DONE,LOOP_REQ_SO_DONE,MP_LOOP_REQ_SO_DONE
     $ ,CTCALL_REQ_SO_DONE,FILTER_SO
      COMMON/SO_REQS/UVCT_REQ_SO_DONE,MP_UVCT_REQ_SO_DONE
     $ ,CT_REQ_SO_DONE,MP_CT_REQ_SO_DONE,LOOP_REQ_SO_DONE
     $ ,MP_LOOP_REQ_SO_DONE,CTCALL_REQ_SO_DONE,FILTER_SO

      COMPLEX*32 AMP(NBORNAMPS)
      COMMON/MP_AMPS/AMP
      COMPLEX*32 W(20,NWAVEFUNCS)
      COMMON/MP_W/W

      COMPLEX*32 WL(MAXLWFSIZE,0:LOOPMAXCOEFS-1,MAXLWFSIZE,
     $ -1:NLOOPWAVEFUNCS)
      COMPLEX*32 PL(0:3,-1:NLOOPWAVEFUNCS)
      COMMON/MP_WL/WL,PL

      COMPLEX*32 AMPL(3,NCTAMPS)
      COMMON/MP_AMPL/AMPL

C     
C     ----------
C     BEGIN CODE
C     ----------

C     The target squared split order contribution is already reached
C      if true.
      IF (FILTER_SO.AND.MP_LOOP_REQ_SO_DONE) THEN
        GOTO 1001
      ENDIF

C     Coefficient construction for loop diagram with ID 2
      CALL MP_VVV1L1P0_3(PL(0,0),W(1,5),GC_4,CMPLX(CMASS_MDL_MW
     $ ,KIND=16),PL(0,1),COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,1))
      CALL MP_VVV1L2P0_1(PL(0,1),W(1,6),GC_4,CMPLX(ZERO,KIND=16),PL(0
     $ ,2),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,1),4,COEFS,4,4,WL(1,0,1,2))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,2),2,4,1,1,1,16,H)
C     Coefficient construction for loop diagram with ID 3
      CALL MP_VVS1L1_3(PL(0,0),W(1,5),-GC_93,CMPLX(CMASS_MDL_MW
     $ ,KIND=16),PL(0,3),COEFS)
      CALL MP_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1,3))
      CALL MP_VVS1L3P0_1(PL(0,3),W(1,6),GC_93,CMPLX(ZERO,KIND=16),PL(0
     $ ,4),COEFS)
      CALL MP_UPDATE_WL_0_0(WL(1,0,1,3),4,COEFS,1,4,WL(1,0,1,4))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,4),0,4,1,1,1,17,H)
C     Coefficient construction for loop diagram with ID 4
      CALL MP_FFV2L3_1(PL(0,0),W(1,3),GC_67,CMPLX(ZERO,KIND=16),PL(0,5)
     $ ,COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,5))
      CALL MP_FFV1L2P0_3(PL(0,5),W(1,4),-GC_4,CMPLX(ZERO,KIND=16),PL(0
     $ ,6),COEFS)
      CALL MP_UPDATE_WL_1_0(WL(1,0,1,5),4,COEFS,4,4,WL(1,0,1,6))
      CALL MP_VVV1L1P0_3(PL(0,6),W(1,5),GC_4,CMPLX(CMASS_MDL_MW
     $ ,KIND=16),PL(0,7),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,6),4,COEFS,4,4,WL(1,0,1,7))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,7),2,4,2,1,1,18,H)
C     Coefficient construction for loop diagram with ID 5
      CALL MP_FFV1L2P0_3(PL(0,0),W(1,1),GC_2,CMPLX(ZERO,KIND=16),PL(0
     $ ,8),COEFS)
      CALL MP_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,8))
      CALL MP_FFV1L3_1(PL(0,8),W(1,2),GC_1,CMPLX(ZERO,KIND=16),PL(0,9)
     $ ,COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,8),4,COEFS,4,4,WL(1,0,1,9))
      CALL MP_FFV2L2_1(PL(0,9),W(1,6),GC_67,CMPLX(ZERO,KIND=16),PL(0
     $ ,10),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,9),4,COEFS,4,4,WL(1,0,1,10))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,10),2,4,3,1,1,19,H)
C     Coefficient construction for loop diagram with ID 6
      CALL MP_FFV1L3_2(PL(0,0),W(1,1),GC_2,CMPLX(ZERO,KIND=16),PL(0,11)
     $ ,COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,11))
      CALL MP_FFV2L1P0_3(PL(0,11),W(1,2),GC_67,CMPLX(CMASS_MDL_MW
     $ ,KIND=16),PL(0,12),COEFS)
      CALL MP_UPDATE_WL_1_0(WL(1,0,1,11),4,COEFS,4,4,WL(1,0,1,12))
      CALL MP_VVV1L2P0_1(PL(0,12),W(1,6),GC_4,CMPLX(ZERO,KIND=16),PL(0
     $ ,13),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,12),4,COEFS,4,4,WL(1,0,1,13))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,13),2,4,4,1,1,20,H)
C     Coefficient construction for loop diagram with ID 7
      CALL MP_FFV2L3_1(PL(0,12),W(1,3),GC_67,CMPLX(ZERO,KIND=16),PL(0
     $ ,14),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,12),4,COEFS,4,4,WL(1,0,1,14))
      CALL MP_FFV1L2P0_3(PL(0,14),W(1,4),-GC_4,CMPLX(ZERO,KIND=16)
     $ ,PL(0,15),COEFS)
      CALL MP_UPDATE_WL_2_0(WL(1,0,1,14),4,COEFS,4,4,WL(1,0,1,15))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,15),2,4,5,1,1,21,H)
C     Coefficient construction for loop diagram with ID 8
      CALL MP_FFV2L3_2(PL(0,0),W(1,1),GC_67,CMPLX(ZERO,KIND=16),PL(0
     $ ,16),COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,16))
      CALL MP_FFV1L1P0_3(PL(0,16),W(1,2),GC_1,CMPLX(ZERO,KIND=16),PL(0
     $ ,17),COEFS)
      CALL MP_UPDATE_WL_1_0(WL(1,0,1,16),4,COEFS,4,4,WL(1,0,1,17))
      CALL MP_VVV1L1P0_2(PL(0,17),W(1,6),GC_4,CMPLX(CMASS_MDL_MW
     $ ,KIND=16),PL(0,18),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,17),4,COEFS,4,4,WL(1,0,1,18))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,18),2,4,6,1,1,22,H)
C     Coefficient construction for loop diagram with ID 9
      CALL MP_FFV1L3_2(PL(0,17),W(1,4),-GC_4,CMPLX(ZERO,KIND=16),PL(0
     $ ,19),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,17),4,COEFS,4,4,WL(1,0,1,19))
      CALL MP_FFV2L1P0_3(PL(0,19),W(1,3),GC_67,CMPLX(CMASS_MDL_MW
     $ ,KIND=16),PL(0,20),COEFS)
      CALL MP_UPDATE_WL_2_0(WL(1,0,1,19),4,COEFS,4,4,WL(1,0,1,20))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,20),2,4,7,1,1,23,H)
C     Coefficient construction for loop diagram with ID 10
      CALL MP_VVVV2L4P0_3(PL(0,0),W(1,5),W(1,6),GC_54
     $ ,CMPLX(CMASS_MDL_MZ,KIND=16),PL(0,21),COEFS)
      CALL MP_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,21))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,21),0,4,8,2,1,24,H)
C     Coefficient construction for loop diagram with ID 11
      CALL MP_VVV1L3P0_2(PL(0,0),W(1,5),GC_71,CMPLX(CMASS_MDL_MW
     $ ,KIND=16),PL(0,22),COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,22))
      CALL MP_VVV1L1P0_3(PL(0,22),W(1,6),GC_71,CMPLX(CMASS_MDL_MZ
     $ ,KIND=16),PL(0,23),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,22),4,COEFS,4,4,WL(1,0,1,23))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,23),2,4,9,1,1,25,H)
C     Coefficient construction for loop diagram with ID 12
      CALL MP_VVS1L2_3(PL(0,0),W(1,5),-GC_84,CMPLX(CMASS_MDL_MW
     $ ,KIND=16),PL(0,24),COEFS)
      CALL MP_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1,24))
      CALL MP_VVS1L3P0_2(PL(0,24),W(1,6),GC_84,CMPLX(CMASS_MDL_MZ
     $ ,KIND=16),PL(0,25),COEFS)
      CALL MP_UPDATE_WL_0_0(WL(1,0,1,24),4,COEFS,1,4,WL(1,0,1,25))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,25),0,4,9,1,1,26,H)
C     Coefficient construction for loop diagram with ID 13
      CALL MP_FFV2L3_1(PL(0,0),W(1,3),GC_80,CMPLX(ZERO,KIND=16),PL(0
     $ ,26),COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,26))
      CALL MP_FFV2L2P0_3(PL(0,26),W(1,4),GC_67,CMPLX(CMASS_MDL_MW
     $ ,KIND=16),PL(0,27),COEFS)
      CALL MP_UPDATE_WL_1_0(WL(1,0,1,26),4,COEFS,4,4,WL(1,0,1,27))
      CALL MP_VVV1L2P0_3(PL(0,27),W(1,5),GC_71,CMPLX(CMASS_MDL_MZ
     $ ,KIND=16),PL(0,28),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,27),4,COEFS,4,4,WL(1,0,1,28))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,28),2,4,10,1,1,27,H)
C     Coefficient construction for loop diagram with ID 14
      CALL MP_FFV2L1P0_3(PL(0,0),W(1,3),GC_80,CMPLX(CMASS_MDL_MZ
     $ ,KIND=16),PL(0,29),COEFS)
      CALL MP_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,29))
      CALL MP_FFV2_4L3_2(PL(0,29),W(1,4),GC_68,GC_77,CMPLX(ZERO
     $ ,KIND=16),PL(0,30),COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,29),4,COEFS,4,4,WL(1,0,1,30))
      CALL MP_FFV2L1_2(PL(0,30),W(1,5),GC_67,CMPLX(ZERO,KIND=16),PL(0
     $ ,31),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,30),4,COEFS,4,4,WL(1,0,1,31))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,31),2,4,11,1,1,28,H)
C     Coefficient construction for loop diagram with ID 15
      CALL MP_FFV2_4L2P0_3(PL(0,5),W(1,4),GC_68,GC_77
     $ ,CMPLX(CMASS_MDL_MZ,KIND=16),PL(0,32),COEFS)
      CALL MP_UPDATE_WL_1_0(WL(1,0,1,5),4,COEFS,4,4,WL(1,0,1,32))
      CALL MP_VVV1L3P0_2(PL(0,32),W(1,5),GC_71,CMPLX(CMASS_MDL_MW
     $ ,KIND=16),PL(0,33),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,32),4,COEFS,4,4,WL(1,0,1,33))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,33),2,4,12,1,1,29,H)
C     Coefficient construction for loop diagram with ID 16
      CALL MP_FFV2_5L2P0_3(PL(0,0),W(1,1),-GC_68,GC_76
     $ ,CMPLX(CMASS_MDL_MZ,KIND=16),PL(0,34),COEFS)
      CALL MP_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,34))
      CALL MP_FFV2_3L3_1(PL(0,34),W(1,2),GC_68,GC_76,CMPLX(ZERO
     $ ,KIND=16),PL(0,35),COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,34),4,COEFS,4,4,WL(1,0,1,35))
      CALL MP_FFV2L2_1(PL(0,35),W(1,6),GC_67,CMPLX(ZERO,KIND=16),PL(0
     $ ,36),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,35),4,COEFS,4,4,WL(1,0,1,36))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,36),2,4,13,1,1,30,H)
C     Coefficient construction for loop diagram with ID 17
      CALL MP_FFV2_5L3_2(PL(0,0),W(1,1),-GC_68,GC_76,CMPLX(ZERO
     $ ,KIND=16),PL(0,37),COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,37))
      CALL MP_FFV2L1P0_3(PL(0,37),W(1,2),GC_67,CMPLX(CMASS_MDL_MW
     $ ,KIND=16),PL(0,38),COEFS)
      CALL MP_UPDATE_WL_1_0(WL(1,0,1,37),4,COEFS,4,4,WL(1,0,1,38))
      CALL MP_VVV1L1P0_3(PL(0,38),W(1,6),GC_71,CMPLX(CMASS_MDL_MZ
     $ ,KIND=16),PL(0,39),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,38),4,COEFS,4,4,WL(1,0,1,39))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,39),2,4,14,1,1,31,H)
C     Coefficient construction for loop diagram with ID 18
      CALL MP_FFV2L3_2(PL(0,38),W(1,4),GC_67,CMPLX(ZERO,KIND=16),PL(0
     $ ,40),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,38),4,COEFS,4,4,WL(1,0,1,40))
      CALL MP_FFV2L1P0_3(PL(0,40),W(1,3),GC_80,CMPLX(CMASS_MDL_MZ
     $ ,KIND=16),PL(0,41),COEFS)
      CALL MP_UPDATE_WL_2_0(WL(1,0,1,40),4,COEFS,4,4,WL(1,0,1,41))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,41),2,4,15,1,1,32,H)
C     Coefficient construction for loop diagram with ID 19
      CALL MP_FFV2L3_1(PL(0,38),W(1,3),GC_67,CMPLX(ZERO,KIND=16),PL(0
     $ ,42),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,38),4,COEFS,4,4,WL(1,0,1,42))
      CALL MP_FFV2_4L2P0_3(PL(0,42),W(1,4),GC_68,GC_77
     $ ,CMPLX(CMASS_MDL_MZ,KIND=16),PL(0,43),COEFS)
      CALL MP_UPDATE_WL_2_0(WL(1,0,1,42),4,COEFS,4,4,WL(1,0,1,43))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,43),2,4,16,1,1,33,H)
C     Coefficient construction for loop diagram with ID 20
      CALL MP_FFV2_3L1P0_3(PL(0,16),W(1,2),GC_68,GC_76
     $ ,CMPLX(CMASS_MDL_MZ,KIND=16),PL(0,44),COEFS)
      CALL MP_UPDATE_WL_1_0(WL(1,0,1,16),4,COEFS,4,4,WL(1,0,1,44))
      CALL MP_VVV1L3P0_1(PL(0,44),W(1,6),GC_71,CMPLX(CMASS_MDL_MW
     $ ,KIND=16),PL(0,45),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,44),4,COEFS,4,4,WL(1,0,1,45))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,45),2,4,17,1,1,34,H)
C     Coefficient construction for loop diagram with ID 21
      CALL MP_FFV2L3_1(PL(0,44),W(1,3),GC_80,CMPLX(ZERO,KIND=16),PL(0
     $ ,46),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,44),4,COEFS,4,4,WL(1,0,1,46))
      CALL MP_FFV2L2P0_3(PL(0,46),W(1,4),GC_67,CMPLX(CMASS_MDL_MW
     $ ,KIND=16),PL(0,47),COEFS)
      CALL MP_UPDATE_WL_2_0(WL(1,0,1,46),4,COEFS,4,4,WL(1,0,1,47))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,47),2,4,18,1,1,35,H)
C     Coefficient construction for loop diagram with ID 22
      CALL MP_FFV2_4L3_2(PL(0,44),W(1,4),GC_68,GC_77,CMPLX(ZERO
     $ ,KIND=16),PL(0,48),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,44),4,COEFS,4,4,WL(1,0,1,48))
      CALL MP_FFV2L1P0_3(PL(0,48),W(1,3),GC_67,CMPLX(CMASS_MDL_MW
     $ ,KIND=16),PL(0,49),COEFS)
      CALL MP_UPDATE_WL_2_0(WL(1,0,1,48),4,COEFS,4,4,WL(1,0,1,49))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,49),2,4,19,1,1,36,H)
C     Coefficient construction for loop diagram with ID 23
      CALL MP_VVSS1L4_3(PL(0,0),W(1,5),W(1,6),GC_52,CMPLX(CMASS_MDL_MH
     $ ,KIND=16),PL(0,50),COEFS)
      CALL MP_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,50))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,50),0,1,20,2,1,37,H)
C     Coefficient construction for loop diagram with ID 24
      CALL MP_VSS1L3_2(PL(0,0),W(1,5),GC_55,CMPLX(CMASS_MDL_MW,KIND=16)
     $ ,PL(0,51),COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,51))
      CALL MP_VSS1L2_3(PL(0,51),W(1,6),GC_55,CMPLX(CMASS_MDL_MH
     $ ,KIND=16),PL(0,52),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,51),1,COEFS,1,1,WL(1,0,1,52))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,52),2,1,21,1,1,38,H)
C     Coefficient construction for loop diagram with ID 25
      CALL MP_VVS1L2_3(PL(0,0),W(1,5),GC_90,CMPLX(CMASS_MDL_MH,KIND=16)
     $ ,PL(0,53),COEFS)
      CALL MP_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,1,WL(1,0,1,53))
      CALL MP_VVS1L3P0_1(PL(0,53),W(1,6),GC_90,CMPLX(CMASS_MDL_MW
     $ ,KIND=16),PL(0,54),COEFS)
      CALL MP_UPDATE_WL_0_0(WL(1,0,1,53),4,COEFS,1,4,WL(1,0,1,54))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,54),0,4,22,1,1,39,H)
C     Coefficient construction for loop diagram with ID 26
      CALL MP_VVSS1L4_3(PL(0,0),W(1,5),W(1,6),GC_52,CMPLX(CMASS_MDL_MZ
     $ ,KIND=16),PL(0,55),COEFS)
      CALL MP_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,55))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,55),0,1,8,2,1,40,H)
C     Coefficient construction for loop diagram with ID 27
      CALL MP_VSS1L2_3(PL(0,0),W(1,5),GC_57,CMPLX(CMASS_MDL_MW,KIND=16)
     $ ,PL(0,56),COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,56))
      CALL MP_VSS1L3_2(PL(0,56),W(1,6),-GC_57,CMPLX(CMASS_MDL_MZ
     $ ,KIND=16),PL(0,57),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,56),1,COEFS,1,1,WL(1,0,1,57))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,57),2,1,9,1,1,41,H)
C     Coefficient construction for loop diagram with ID 28
      CALL MP_VVVV2L3P0_1(PL(0,0),W(1,5),W(1,6),GC_53
     $ ,CMPLX(CMASS_MDL_MW,KIND=16),PL(0,58),COEFS)
      CALL MP_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,58))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,58),0,4,23,1,1,42,H)
C     Coefficient construction for loop diagram with ID 29
      CALL MP_VVSS1L4_3(PL(0,0),W(1,5),W(1,6),GC_52,CMPLX(CMASS_MDL_MW
     $ ,KIND=16),PL(0,59),COEFS)
      CALL MP_UPDATE_WL_0_0(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,59))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,59),0,1,23,1,1,43,H)
C     Coefficient construction for loop diagram with ID 30
      CALL MP_UUV1L1_2(PL(0,0),W(1,5),-GC_4,CMPLX(MDL_MW,KIND=16),PL(0
     $ ,60),COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,60))
      CALL MP_UUV1L1_2(PL(0,60),W(1,6),-GC_4,CMPLX(ZERO,KIND=16),PL(0
     $ ,61),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,60),1,COEFS,1,1,WL(1,0,1,61))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,61),2,1,1,1,1,44,H)
C     Coefficient construction for loop diagram with ID 31
      CALL MP_UUV1L2_1(PL(0,0),W(1,5),GC_4,CMPLX(MDL_MW,KIND=16),PL(0
     $ ,62),COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,62))
      CALL MP_UUV1L2_1(PL(0,62),W(1,6),GC_4,CMPLX(ZERO,KIND=16),PL(0
     $ ,63),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,62),1,COEFS,1,1,WL(1,0,1,63))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,63),2,1,1,1,1,45,H)
C     Coefficient construction for loop diagram with ID 32
      CALL MP_UUV1L1_2(PL(0,0),W(1,5),-GC_71,CMPLX(MDL_MW,KIND=16)
     $ ,PL(0,64),COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,64))
      CALL MP_UUV1L1_2(PL(0,64),W(1,6),-GC_71,CMPLX(MDL_MZ,KIND=16)
     $ ,PL(0,65),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,64),1,COEFS,1,1,WL(1,0,1,65))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,65),2,1,9,1,1,46,H)
C     Coefficient construction for loop diagram with ID 33
      CALL MP_UUV1L2_1(PL(0,0),W(1,5),GC_71,CMPLX(MDL_MW,KIND=16),PL(0
     $ ,66),COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,66))
      CALL MP_UUV1L2_1(PL(0,66),W(1,6),GC_71,CMPLX(MDL_MZ,KIND=16)
     $ ,PL(0,67),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,66),1,COEFS,1,1,WL(1,0,1,67))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,67),2,1,9,1,1,47,H)
C     Coefficient construction for loop diagram with ID 34
      CALL MP_FFV2L1_2(PL(0,0),W(1,5),GC_67,CMPLX(ZERO,KIND=16),PL(0
     $ ,68),COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,68))
      CALL MP_FFV2L1_2(PL(0,68),W(1,6),GC_67,CMPLX(ZERO,KIND=16),PL(0
     $ ,69),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,68),4,COEFS,4,4,WL(1,0,1,69))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,69),2,4,24,1,2,48,H)
C     Coefficient construction for loop diagram with ID 35
      CALL MP_FFV2L1_2(PL(0,0),W(1,5),GC_67,CMPLX(CMASS_MDL_MT,KIND=16)
     $ ,PL(0,70),COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,70))
      CALL MP_FFV2L1_2(PL(0,70),W(1,6),GC_67,CMPLX(ZERO,KIND=16),PL(0
     $ ,71),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,70),4,COEFS,4,4,WL(1,0,1,71))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,71),2,4,25,1,1,49,H)
C     Coefficient construction for loop diagram with ID 36
      CALL MP_FFV2L1_2(PL(0,0),W(1,5),GC_67,CMPLX(ZERO,KIND=16),PL(0
     $ ,72),COEFS)
      CALL MP_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,72))
      CALL MP_FFV2L1_2(PL(0,72),W(1,6),GC_67,CMPLX(ZERO,KIND=16),PL(0
     $ ,73),COEFS)
      CALL MP_UPDATE_WL_1_1(WL(1,0,1,72),4,COEFS,4,4,WL(1,0,1,73))
      CALL MP_CREATE_LOOP_COEFS(WL(1,0,1,73),2,4,24,1,3,50,H)
C     At this point, all loop coefficients needed for (QCD=0 QED=6),
C      i.e. of split order ID=1, are computed.
      IF(FILTER_SO.AND.SQSO_TARGET.EQ.1) GOTO 4000

      GOTO 1001
 4000 CONTINUE
      MP_LOOP_REQ_SO_DONE=.TRUE.
 1001 CONTINUE
      END

