
################################################################################
#
# This gnuplot file was generated by MadGraph5_aMC@NLO project, a program which 
# automatically generates Feynman diagrams and matrix elements for arbitrary
# high-energy processes in the Standard Model and beyond. It also perform the
# integration and/or generate events for these processes, at LO and NLO accuracy.
#
# For more information, visit madgraph.phys.ucl.ac.be and amcatnlo.web.cern.ch
#
################################################################################
# 
reset

set lmargin 10
set rmargin 0
set terminal postscript portrait enhanced mono dashed lw 1.0 "Helvetica" 9 
set key font ",9"
set key samplen "2"
set output "HistoOut.ps"

# This is the "PODO" color palette of gnuplot v.5, but with the order
# changed: palette of colors selected to be easily distinguishable by
# color-blind individuals with either protanopia or deuteranopia. Bang
# Wong [2011] Nature Methods 8, 441.

set style line  1 lt 1 lc rgb "#009e73" lw 2.5
set style line 11 lt 2 lc rgb "#009e73" lw 2.5
set style line 21 lt 4 lc rgb "#009e73" lw 2.5

set style line  2 lt 1 lc rgb "#0072b2" lw 2.5
set style line 12 lt 2 lc rgb "#0072b2" lw 2.5
set style line 22 lt 4 lc rgb "#0072b2" lw 2.5

set style line  3 lt 1 lc rgb "#d55e00" lw 2.5
set style line 13 lt 2 lc rgb "#d55e00" lw 2.5
set style line 23 lt 4 lc rgb "#d55e00" lw 2.5

set style line  4 lt 1 lc rgb "#f0e442" lw 2.5
set style line 14 lt 2 lc rgb "#f0e442" lw 2.5
set style line 24 lt 4 lc rgb "#f0e442" lw 2.5

set style line  5 lt 1 lc rgb "#56b4e9" lw 2.5
set style line 15 lt 2 lc rgb "#56b4e9" lw 2.5
set style line 25 lt 4 lc rgb "#56b4e9" lw 2.5

set style line  6 lt 1 lc rgb "#cc79a7" lw 2.5
set style line 16 lt 2 lc rgb "#cc79a7" lw 2.5
set style line 26 lt 4 lc rgb "#cc79a7" lw 2.5

set style line  7 lt 1 lc rgb "#e69f00" lw 2.5
set style line 17 lt 2 lc rgb "#e69f00" lw 2.5
set style line 27 lt 4 lc rgb "#e69f00" lw 2.5

set style line  8 lt 1 lc rgb "black" lw 2.5
set style line 18 lt 2 lc rgb "black" lw 2.5
set style line 28 lt 4 lc rgb "black" lw 2.5


set style line 999 lt 1 lc rgb "gray" lw 2.5

safe(x,y,a) = (y == 0.0 ? a : x/y)

set style data histeps



################################################################################
### Rendering of the plot titled 'cphi[l,vl]'
################################################################################

set multiplot
set label "cphi[l,vl]" font ",13" at graph 0.04, graph 1.05
set xrange [-1.0000e+00:1.0000e+00]
set bmargin 0 
set tmargin 0
set xtics nomirror
set ytics nomirror
set mytics 10
set xtics auto
set key horizontal noreverse maxcols 1 width -4 
set label front 'MadGraph5\_aMC\@NLO' font "Courier,11" rotate by 90 at graph 1.02, graph 0.04

#-- rendering subhistograms 'NLO and LO results'

set format y '10^{%%T}'
set yrange [6.8850e+00:1.6262e+04]
set origin 0.0000e+00, 5.0000e-01
set size 1.0000e+00, 4.0000e-01
set mytics 10
set ytics auto
set format x ''
set logscale y
set ylabel "{/Symbol s} per bin [pb]"

plot \
'HistoOut.HwU' index 0 using (($1+$2)/2):3 ls 1 title 'cphi[l,vl], NLO',\
'HistoOut.HwU' index 0 using (($1+$2)/2):5 ls 11 title 'NLO scale variation',\
'HistoOut.HwU' index 0 using (($1+$2)/2):6 ls 11 title '',\
'HistoOut.HwU' index 0 using (($1+$2)/2):7 ls 21 title 'NLO PDF variation',\
'HistoOut.HwU' index 0 using (($1+$2)/2):8 ls 21 title '',\
'HistoOut.HwU' index 1 using (($1+$2)/2):3 ls 2 title 'LO',\
'HistoOut.HwU' index 1 using (($1+$2)/2):5 ls 12 title 'LO scale variation',\
'HistoOut.HwU' index 1 using (($1+$2)/2):6 ls 12 title '',\
'HistoOut.HwU' index 1 using (($1+$2)/2):7 ls 22 title 'LO PDF variation',\
'HistoOut.HwU' index 1 using (($1+$2)/2):8 ls 22 title ''
#-- rendering subhistograms 'Relative scale and PDF uncertainty'
unset label
unset format
set yrange [-4.6811e-01:5.7853e-01]
set origin 0.0000e+00, 3.5000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x ''
unset logscale y
set ylabel "NLO rel.unc."
set label "Relative uncertainties" font ",9" at graph 0.03, graph 0.13
plot \
0.0 ls 999 title '',\
'HistoOut.HwU' index 0 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 0 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 0 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 0 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 1 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 12 title '',\
'HistoOut.HwU' index 1 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 12 title '',\
'HistoOut.HwU' index 1 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 22 title '',\
'HistoOut.HwU' index 1 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 22 title ''
#-- rendering subhistograms '(2)/NLO ratio'
unset label
unset format
set yrange [7.4371e-02:1.1353e-01]
set origin 0.0000e+00, 2.0000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x
unset logscale y
set ylabel "(2)/NLO"
set label "(2)/NLO" font ",9" at graph 0.03, graph 0.13
plot \
1.0 ls 999 title '',\
'HistoOut.HwU' index 2 using (($1+$2)/2):3 ls 2 title '',\
'HistoOut.HwU' index 2 using (($1+$2)/2):5 ls 12 title '',\
'HistoOut.HwU' index 2 using (($1+$2)/2):6 ls 12 title '',\
'HistoOut.HwU' index 2 using (($1+$2)/2):7 ls 22 title '',\
'HistoOut.HwU' index 2 using (($1+$2)/2):8 ls 22 title ''

unset label

################################################################################

################################################################################
### Rendering of the plot titled 'cphi[l,vl] K-factor'
################################################################################

set multiplot
set label "cphi[l,vl] K-factor" font ",13" at graph 0.04, graph 1.05
set xrange [-1.0000e+00:-9.5000e-01]
set bmargin 0 
set tmargin 0
set xtics nomirror
set ytics nomirror
set mytics 10
set xtics auto
set key horizontal noreverse maxcols 1 width -4 
set label front 'MadGraph5\_aMC\@NLO' font "Courier,11" rotate by 90 at graph 1.02, graph 0.04

#-- rendering subhistograms 'single diagram output'

set format y '10^{%%T}'
set yrange [8.3263e+00:1.3597e+02]
set origin 0.0000e+00, 5.0000e-01
set size 1.0000e+00, 4.0000e-01
set mytics 10
set ytics auto
set format x ''
set logscale y
set ylabel "{/Symbol s} per bin [pb]"

plot \
'HistoOut.HwU' index 3 using (($1+$2)/2):3 ls 1 title 'cphi[l,vl] K-factor, NLO',\
'HistoOut.HwU' index 3 using (($1+$2)/2):5 ls 11 title 'NLO scale variation',\
'HistoOut.HwU' index 3 using (($1+$2)/2):6 ls 11 title '',\
'HistoOut.HwU' index 3 using (($1+$2)/2):7 ls 21 title 'NLO PDF variation',\
'HistoOut.HwU' index 3 using (($1+$2)/2):8 ls 21 title ''
#-- rendering subhistograms 'Relative scale and PDF uncertainty'
unset label
unset format
set yrange [-2.0081e-01:2.1998e-01]
set origin 0.0000e+00, 3.5000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x
unset logscale y
set ylabel "NLO rel.unc."
set label "Relative uncertainties" font ",9" at graph 0.03, graph 0.13
plot \
0.0 ls 999 title '',\
'HistoOut.HwU' index 3 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 3 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 3 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 3 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 21 title ''

unset label

################################################################################

################################################################################
### Rendering of the plot titled 'et miss'
################################################################################

set multiplot
set label "et miss" font ",13" at graph 0.04, graph 1.05
set xrange [0.0000e+00:2.0000e+02]
set bmargin 0 
set tmargin 0
set xtics nomirror
set ytics nomirror
set mytics 10
set xtics auto
set key horizontal noreverse maxcols 1 width -4 
set label front 'MadGraph5\_aMC\@NLO' font "Courier,11" rotate by 90 at graph 1.02, graph 0.04

#-- rendering subhistograms 'NLO and LO results'

set format y '10^{%%T}'
set yrange [6.4357e-02:4.9724e+04]
set origin 0.0000e+00, 5.0000e-01
set size 1.0000e+00, 4.0000e-01
set mytics 10
set ytics auto
set format x ''
set logscale y
set ylabel "{/Symbol s} per bin [pb]"

plot \
'HistoOut.HwU' index 4 using (($1+$2)/2):3 ls 1 title 'et miss, NLO',\
'HistoOut.HwU' index 4 using (($1+$2)/2):5 ls 11 title 'NLO scale variation',\
'HistoOut.HwU' index 4 using (($1+$2)/2):6 ls 11 title '',\
'HistoOut.HwU' index 4 using (($1+$2)/2):7 ls 21 title 'NLO PDF variation',\
'HistoOut.HwU' index 4 using (($1+$2)/2):8 ls 21 title '',\
'HistoOut.HwU' index 5 using (($1+$2)/2):3 ls 2 title 'LO',\
'HistoOut.HwU' index 5 using (($1+$2)/2):5 ls 12 title 'LO scale variation',\
'HistoOut.HwU' index 5 using (($1+$2)/2):6 ls 12 title '',\
'HistoOut.HwU' index 5 using (($1+$2)/2):7 ls 22 title 'LO PDF variation',\
'HistoOut.HwU' index 5 using (($1+$2)/2):8 ls 22 title ''
#-- rendering subhistograms 'Relative scale and PDF uncertainty'
unset label
unset format
set yrange [-3.2802e-01:2.9991e-01]
set origin 0.0000e+00, 3.5000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x ''
unset logscale y
set ylabel "NLO rel.unc."
set label "Relative uncertainties" font ",9" at graph 0.03, graph 0.13
plot \
0.0 ls 999 title '',\
'HistoOut.HwU' index 4 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 4 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 4 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 4 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 5 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 12 title '',\
'HistoOut.HwU' index 5 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 12 title '',\
'HistoOut.HwU' index 5 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 22 title '',\
'HistoOut.HwU' index 5 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 22 title ''
#-- rendering subhistograms '(2)/NLO ratio'
unset label
unset format
set yrange [-8.3219e-01:9.2131e-01]
set origin 0.0000e+00, 2.0000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x
unset logscale y
set ylabel "(2)/NLO"
set label "(2)/NLO" font ",9" at graph 0.03, graph 0.13
plot \
1.0 ls 999 title '',\
'HistoOut.HwU' index 6 using (($1+$2)/2):3 ls 2 title '',\
'HistoOut.HwU' index 6 using (($1+$2)/2):5 ls 12 title '',\
'HistoOut.HwU' index 6 using (($1+$2)/2):6 ls 12 title '',\
'HistoOut.HwU' index 6 using (($1+$2)/2):7 ls 22 title '',\
'HistoOut.HwU' index 6 using (($1+$2)/2):8 ls 22 title ''

unset label

################################################################################

################################################################################
### Rendering of the plot titled 'et miss K-factor'
################################################################################

set multiplot
set label "et miss K-factor" font ",13" at graph 0.04, graph 1.05
set xrange [0.0000e+00:1.8000e+02]
set bmargin 0 
set tmargin 0
set xtics nomirror
set ytics nomirror
set mytics 10
set xtics auto
set key horizontal noreverse maxcols 1 width -4 
set label front 'MadGraph5\_aMC\@NLO' font "Courier,11" rotate by 90 at graph 1.02, graph 0.04

#-- rendering subhistograms 'single diagram output'

set format y '10^{%%T}'
set yrange [7.2996e-01:7.2184e+02]
set origin 0.0000e+00, 5.0000e-01
set size 1.0000e+00, 4.0000e-01
set mytics 10
set ytics auto
set format x ''
set logscale y
set ylabel "{/Symbol s} per bin [pb]"

plot \
'HistoOut.HwU' index 7 using (($1+$2)/2):3 ls 1 title 'et miss K-factor, NLO',\
'HistoOut.HwU' index 7 using (($1+$2)/2):5 ls 11 title 'NLO scale variation',\
'HistoOut.HwU' index 7 using (($1+$2)/2):6 ls 11 title '',\
'HistoOut.HwU' index 7 using (($1+$2)/2):7 ls 21 title 'NLO PDF variation',\
'HistoOut.HwU' index 7 using (($1+$2)/2):8 ls 21 title ''
#-- rendering subhistograms 'Relative scale and PDF uncertainty'
unset label
unset format
set yrange [-4.4561e-01:3.2176e-01]
set origin 0.0000e+00, 3.5000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x
unset logscale y
set ylabel "NLO rel.unc."
set label "Relative uncertainties" font ",9" at graph 0.03, graph 0.13
plot \
0.0 ls 999 title '',\
'HistoOut.HwU' index 7 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 7 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 7 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 7 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 21 title ''

unset label

################################################################################

################################################################################
### Rendering of the plot titled 'lep pt'
################################################################################

set multiplot
set label "lep pt" font ",13" at graph 0.04, graph 1.05
set xrange [0.0000e+00:2.0000e+02]
set bmargin 0 
set tmargin 0
set xtics nomirror
set ytics nomirror
set mytics 10
set xtics auto
set key horizontal noreverse maxcols 1 width -4 
set label front 'MadGraph5\_aMC\@NLO' font "Courier,11" rotate by 90 at graph 1.02, graph 0.04

#-- rendering subhistograms 'NLO and LO results'

set format y '10^{%%T}'
set yrange [6.4357e-02:4.9724e+04]
set origin 0.0000e+00, 5.0000e-01
set size 1.0000e+00, 4.0000e-01
set mytics 10
set ytics auto
set format x ''
set logscale y
set ylabel "{/Symbol s} per bin [pb]"

plot \
'HistoOut.HwU' index 8 using (($1+$2)/2):3 ls 1 title 'lep pt, NLO',\
'HistoOut.HwU' index 8 using (($1+$2)/2):5 ls 11 title 'NLO scale variation',\
'HistoOut.HwU' index 8 using (($1+$2)/2):6 ls 11 title '',\
'HistoOut.HwU' index 8 using (($1+$2)/2):7 ls 21 title 'NLO PDF variation',\
'HistoOut.HwU' index 8 using (($1+$2)/2):8 ls 21 title '',\
'HistoOut.HwU' index 9 using (($1+$2)/2):3 ls 2 title 'LO',\
'HistoOut.HwU' index 9 using (($1+$2)/2):5 ls 12 title 'LO scale variation',\
'HistoOut.HwU' index 9 using (($1+$2)/2):6 ls 12 title '',\
'HistoOut.HwU' index 9 using (($1+$2)/2):7 ls 22 title 'LO PDF variation',\
'HistoOut.HwU' index 9 using (($1+$2)/2):8 ls 22 title ''
#-- rendering subhistograms 'Relative scale and PDF uncertainty'
unset label
unset format
set yrange [-3.3763e-01:2.9408e-01]
set origin 0.0000e+00, 3.5000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x ''
unset logscale y
set ylabel "NLO rel.unc."
set label "Relative uncertainties" font ",9" at graph 0.03, graph 0.13
plot \
0.0 ls 999 title '',\
'HistoOut.HwU' index 8 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 8 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 8 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 8 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 9 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 12 title '',\
'HistoOut.HwU' index 9 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 12 title '',\
'HistoOut.HwU' index 9 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 22 title '',\
'HistoOut.HwU' index 9 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 22 title ''
#-- rendering subhistograms '(2)/NLO ratio'
unset label
unset format
set yrange [-3.1770e-01:1.7407e+00]
set origin 0.0000e+00, 2.0000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x
unset logscale y
set ylabel "(2)/NLO"
set label "(2)/NLO" font ",9" at graph 0.03, graph 0.13
plot \
1.0 ls 999 title '',\
'HistoOut.HwU' index 10 using (($1+$2)/2):3 ls 2 title '',\
'HistoOut.HwU' index 10 using (($1+$2)/2):5 ls 12 title '',\
'HistoOut.HwU' index 10 using (($1+$2)/2):6 ls 12 title '',\
'HistoOut.HwU' index 10 using (($1+$2)/2):7 ls 22 title '',\
'HistoOut.HwU' index 10 using (($1+$2)/2):8 ls 22 title ''

unset label

################################################################################

################################################################################
### Rendering of the plot titled 'lep pt K-factor'
################################################################################

set multiplot
set label "lep pt K-factor" font ",13" at graph 0.04, graph 1.05
set xrange [0.0000e+00:1.8000e+02]
set bmargin 0 
set tmargin 0
set xtics nomirror
set ytics nomirror
set mytics 10
set xtics auto
set key horizontal noreverse maxcols 1 width -4 
set label front 'MadGraph5\_aMC\@NLO' font "Courier,11" rotate by 90 at graph 1.02, graph 0.04

#-- rendering subhistograms 'single diagram output'

set format y '10^{%%T}'
set yrange [6.1863e-01:4.3364e+02]
set origin 0.0000e+00, 5.0000e-01
set size 1.0000e+00, 4.0000e-01
set mytics 10
set ytics auto
set format x ''
set logscale y
set ylabel "{/Symbol s} per bin [pb]"

plot \
'HistoOut.HwU' index 11 using (($1+$2)/2):3 ls 1 title 'lep pt K-factor, NLO',\
'HistoOut.HwU' index 11 using (($1+$2)/2):5 ls 11 title 'NLO scale variation',\
'HistoOut.HwU' index 11 using (($1+$2)/2):6 ls 11 title '',\
'HistoOut.HwU' index 11 using (($1+$2)/2):7 ls 21 title 'NLO PDF variation',\
'HistoOut.HwU' index 11 using (($1+$2)/2):8 ls 21 title ''
#-- rendering subhistograms 'Relative scale and PDF uncertainty'
unset label
unset format
set yrange [-5.7446e-01:3.4844e-01]
set origin 0.0000e+00, 3.5000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x
unset logscale y
set ylabel "NLO rel.unc."
set label "Relative uncertainties" font ",9" at graph 0.03, graph 0.13
plot \
0.0 ls 999 title '',\
'HistoOut.HwU' index 11 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 11 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 11 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 11 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 21 title ''

unset label

################################################################################

################################################################################
### Rendering of the plot titled 'lep rapidity'
################################################################################

set multiplot
set label "lep rapidity" font ",13" at graph 0.04, graph 1.05
set xrange [-5.0000e+00:5.0000e+00]
set bmargin 0 
set tmargin 0
set xtics nomirror
set ytics nomirror
set mytics 10
set xtics auto
set key horizontal noreverse maxcols 1 width -4 
set label front 'MadGraph5\_aMC\@NLO' font "Courier,11" rotate by 90 at graph 1.02, graph 0.04

#-- rendering subhistograms 'NLO and LO results'

set format y '10^{%%T}'
set yrange [2.3054e+01:9.7409e+03]
set origin 0.0000e+00, 5.0000e-01
set size 1.0000e+00, 4.0000e-01
set mytics 10
set ytics auto
set format x ''
set logscale y
set ylabel "{/Symbol s} per bin [pb]"

plot \
'HistoOut.HwU' index 12 using (($1+$2)/2):3 ls 1 title 'lep rapidity, NLO',\
'HistoOut.HwU' index 12 using (($1+$2)/2):5 ls 11 title 'NLO scale variation',\
'HistoOut.HwU' index 12 using (($1+$2)/2):6 ls 11 title '',\
'HistoOut.HwU' index 12 using (($1+$2)/2):7 ls 21 title 'NLO PDF variation',\
'HistoOut.HwU' index 12 using (($1+$2)/2):8 ls 21 title '',\
'HistoOut.HwU' index 13 using (($1+$2)/2):3 ls 2 title 'LO',\
'HistoOut.HwU' index 13 using (($1+$2)/2):5 ls 12 title 'LO scale variation',\
'HistoOut.HwU' index 13 using (($1+$2)/2):6 ls 12 title '',\
'HistoOut.HwU' index 13 using (($1+$2)/2):7 ls 22 title 'LO PDF variation',\
'HistoOut.HwU' index 13 using (($1+$2)/2):8 ls 22 title ''
#-- rendering subhistograms 'Relative scale and PDF uncertainty'
unset label
unset format
set yrange [-2.2089e-01:1.9773e-01]
set origin 0.0000e+00, 3.5000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x ''
unset logscale y
set ylabel "NLO rel.unc."
set label "Relative uncertainties" font ",9" at graph 0.03, graph 0.13
plot \
0.0 ls 999 title '',\
'HistoOut.HwU' index 12 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 12 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 12 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 12 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 13 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 12 title '',\
'HistoOut.HwU' index 13 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 12 title '',\
'HistoOut.HwU' index 13 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 22 title '',\
'HistoOut.HwU' index 13 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 22 title ''
#-- rendering subhistograms '(2)/NLO ratio'
unset label
unset format
set yrange [3.8636e-01:1.1202e+00]
set origin 0.0000e+00, 2.0000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x
unset logscale y
set ylabel "(2)/NLO"
set label "(2)/NLO" font ",9" at graph 0.03, graph 0.13
plot \
1.0 ls 999 title '',\
'HistoOut.HwU' index 14 using (($1+$2)/2):3 ls 2 title '',\
'HistoOut.HwU' index 14 using (($1+$2)/2):5 ls 12 title '',\
'HistoOut.HwU' index 14 using (($1+$2)/2):6 ls 12 title '',\
'HistoOut.HwU' index 14 using (($1+$2)/2):7 ls 22 title '',\
'HistoOut.HwU' index 14 using (($1+$2)/2):8 ls 22 title ''

unset label

################################################################################

################################################################################
### Rendering of the plot titled 'lep rapidity K-factor'
################################################################################

set multiplot
set label "lep rapidity K-factor" font ",13" at graph 0.04, graph 1.05
set xrange [-5.0000e+00:5.0000e+00]
set bmargin 0 
set tmargin 0
set xtics nomirror
set ytics nomirror
set mytics 10
set xtics auto
set key horizontal noreverse maxcols 1 width -4 
set label front 'MadGraph5\_aMC\@NLO' font "Courier,11" rotate by 90 at graph 1.02, graph 0.04

#-- rendering subhistograms 'single diagram output'

set format y '10^{%%T}'
set yrange [8.8388e-01:2.1626e+01]
set origin 0.0000e+00, 5.0000e-01
set size 1.0000e+00, 4.0000e-01
set mytics 10
set ytics auto
set format x ''
set logscale y
set ylabel "{/Symbol s} per bin [pb]"

plot \
'HistoOut.HwU' index 15 using (($1+$2)/2):3 ls 1 title 'lep rapidity K-factor, NLO',\
'HistoOut.HwU' index 15 using (($1+$2)/2):5 ls 11 title 'NLO scale variation',\
'HistoOut.HwU' index 15 using (($1+$2)/2):6 ls 11 title '',\
'HistoOut.HwU' index 15 using (($1+$2)/2):7 ls 21 title 'NLO PDF variation',\
'HistoOut.HwU' index 15 using (($1+$2)/2):8 ls 21 title ''
#-- rendering subhistograms 'Relative scale and PDF uncertainty'
unset label
unset format
set yrange [-2.7513e-01:2.9749e-01]
set origin 0.0000e+00, 3.5000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x
unset logscale y
set ylabel "NLO rel.unc."
set label "Relative uncertainties" font ",9" at graph 0.03, graph 0.13
plot \
0.0 ls 999 title '',\
'HistoOut.HwU' index 15 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 15 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 15 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 15 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 21 title ''

unset label

################################################################################

################################################################################
### Rendering of the plot titled 'total rate'
################################################################################

set multiplot
set label "total rate" font ",13" at graph 0.04, graph 1.05
set xrange [5.0000e-01:1.5000e+00]
set bmargin 0 
set tmargin 0
set xtics nomirror
set ytics nomirror
set mytics 10
set xtics auto
set key horizontal noreverse maxcols 1 width -4 
set label front 'MadGraph5\_aMC\@NLO' font "Courier,11" rotate by 90 at graph 1.02, graph 0.04

#-- rendering subhistograms 'NLO and LO results'

set format y '10^{%%T}'
set yrange [5.6798e+03:1.2504e+05]
set origin 0.0000e+00, 5.0000e-01
set size 1.0000e+00, 4.0000e-01
set mytics 10
set ytics auto
set format x ''
set logscale y
set ylabel "{/Symbol s} per bin [pb]"

plot \
'HistoOut.HwU' index 16 using (($1+$2)/2):3 ls 1 title 'total rate, NLO',\
'HistoOut.HwU' index 16 using (($1+$2)/2):5 ls 11 title 'NLO scale variation',\
'HistoOut.HwU' index 16 using (($1+$2)/2):6 ls 11 title '',\
'HistoOut.HwU' index 16 using (($1+$2)/2):7 ls 21 title 'NLO PDF variation',\
'HistoOut.HwU' index 16 using (($1+$2)/2):8 ls 21 title '',\
'HistoOut.HwU' index 17 using (($1+$2)/2):3 ls 2 title 'LO',\
'HistoOut.HwU' index 17 using (($1+$2)/2):5 ls 12 title 'LO scale variation',\
'HistoOut.HwU' index 17 using (($1+$2)/2):6 ls 12 title '',\
'HistoOut.HwU' index 17 using (($1+$2)/2):7 ls 22 title 'LO PDF variation',\
'HistoOut.HwU' index 17 using (($1+$2)/2):8 ls 22 title ''
#-- rendering subhistograms 'Relative scale and PDF uncertainty'
unset label
unset format
set yrange [-1.5678e-01:9.2656e-02]
set origin 0.0000e+00, 3.5000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x ''
unset logscale y
set ylabel "NLO rel.unc."
set label "Relative uncertainties" font ",9" at graph 0.03, graph 0.13
plot \
0.0 ls 999 title '',\
'HistoOut.HwU' index 16 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 16 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 16 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 16 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 17 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 12 title '',\
'HistoOut.HwU' index 17 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 12 title '',\
'HistoOut.HwU' index 17 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 22 title '',\
'HistoOut.HwU' index 17 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 22 title ''
#-- rendering subhistograms '(2)/NLO ratio'
unset label
unset format
set yrange [5.6282e-01:8.6343e-01]
set origin 0.0000e+00, 2.0000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x
unset logscale y
set ylabel "(2)/NLO"
set label "(2)/NLO" font ",9" at graph 0.03, graph 0.13
plot \
1.0 ls 999 title '',\
'HistoOut.HwU' index 18 using (($1+$2)/2):3 ls 2 title '',\
'HistoOut.HwU' index 18 using (($1+$2)/2):5 ls 12 title '',\
'HistoOut.HwU' index 18 using (($1+$2)/2):6 ls 12 title '',\
'HistoOut.HwU' index 18 using (($1+$2)/2):7 ls 22 title '',\
'HistoOut.HwU' index 18 using (($1+$2)/2):8 ls 22 title ''

unset label

################################################################################

################################################################################
### Rendering of the plot titled 'total rate K-factor'
################################################################################

set multiplot
set label "total rate K-factor" font ",13" at graph 0.04, graph 1.05
set xrange [5.0000e-01:1.5000e+00]
set bmargin 0 
set tmargin 0
set xtics nomirror
set ytics nomirror
set mytics 10
set xtics auto
set key horizontal noreverse maxcols 1 width -4 
set label front 'MadGraph5\_aMC\@NLO' font "Courier,11" rotate by 90 at graph 1.02, graph 0.04

#-- rendering subhistograms 'single diagram output'

set format y '10^{%%T}'
set yrange [1.0953e+00:1.7947e+01]
set origin 0.0000e+00, 5.0000e-01
set size 1.0000e+00, 4.0000e-01
set mytics 10
set ytics auto
set format x ''
set logscale y
set ylabel "{/Symbol s} per bin [pb]"

plot \
'HistoOut.HwU' index 19 using (($1+$2)/2):3 ls 1 title 'total rate K-factor, NLO',\
'HistoOut.HwU' index 19 using (($1+$2)/2):5 ls 11 title 'NLO scale variation',\
'HistoOut.HwU' index 19 using (($1+$2)/2):6 ls 11 title '',\
'HistoOut.HwU' index 19 using (($1+$2)/2):7 ls 21 title 'NLO PDF variation',\
'HistoOut.HwU' index 19 using (($1+$2)/2):8 ls 21 title ''
#-- rendering subhistograms 'Relative scale and PDF uncertainty'
unset label
unset format
set yrange [-1.9712e-01:2.3171e-01]
set origin 0.0000e+00, 3.5000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x
unset logscale y
set ylabel "NLO rel.unc."
set label "Relative uncertainties" font ",9" at graph 0.03, graph 0.13
plot \
0.0 ls 999 title '',\
'HistoOut.HwU' index 19 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 19 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 19 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 19 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 21 title ''

unset label

################################################################################

################################################################################
### Rendering of the plot titled 'trans. mass'
################################################################################

set multiplot
set label "trans. mass" font ",13" at graph 0.04, graph 1.05
set xrange [0.0000e+00:2.0000e+02]
set bmargin 0 
set tmargin 0
set xtics nomirror
set ytics nomirror
set mytics 10
set xtics auto
set key horizontal noreverse maxcols 1 width -4 
set label front 'MadGraph5\_aMC\@NLO' font "Courier,11" rotate by 90 at graph 1.02, graph 0.04

#-- rendering subhistograms 'NLO and LO results'

set format y '10^{%%T}'
set yrange [1.0896e-02:2.3105e+04]
set origin 0.0000e+00, 5.0000e-01
set size 1.0000e+00, 4.0000e-01
set mytics 10
set ytics auto
set format x ''
set logscale y
set ylabel "{/Symbol s} per bin [pb]"

plot \
'HistoOut.HwU' index 20 using (($1+$2)/2):3 ls 1 title 'trans. mass, NLO',\
'HistoOut.HwU' index 20 using (($1+$2)/2):5 ls 11 title 'NLO scale variation',\
'HistoOut.HwU' index 20 using (($1+$2)/2):6 ls 11 title '',\
'HistoOut.HwU' index 20 using (($1+$2)/2):7 ls 21 title 'NLO PDF variation',\
'HistoOut.HwU' index 20 using (($1+$2)/2):8 ls 21 title '',\
'HistoOut.HwU' index 21 using (($1+$2)/2):3 ls 2 title 'LO',\
'HistoOut.HwU' index 21 using (($1+$2)/2):5 ls 12 title 'LO scale variation',\
'HistoOut.HwU' index 21 using (($1+$2)/2):6 ls 12 title '',\
'HistoOut.HwU' index 21 using (($1+$2)/2):7 ls 22 title 'LO PDF variation',\
'HistoOut.HwU' index 21 using (($1+$2)/2):8 ls 22 title ''
#-- rendering subhistograms 'Relative scale and PDF uncertainty'
unset label
unset format
set yrange [-2.6889e-01:1.9686e-01]
set origin 0.0000e+00, 3.5000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x ''
unset logscale y
set ylabel "NLO rel.unc."
set label "Relative uncertainties" font ",9" at graph 0.03, graph 0.13
plot \
0.0 ls 999 title '',\
'HistoOut.HwU' index 20 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 20 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 20 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 20 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 21 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 12 title '',\
'HistoOut.HwU' index 21 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 12 title '',\
'HistoOut.HwU' index 21 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 22 title '',\
'HistoOut.HwU' index 21 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 22 title ''
#-- rendering subhistograms '(2)/NLO ratio'
unset label
unset format
set yrange [-4.7376e-01:3.2679e+00]
set origin 0.0000e+00, 2.0000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x
unset logscale y
set ylabel "(2)/NLO"
set label "(2)/NLO" font ",9" at graph 0.03, graph 0.13
plot \
1.0 ls 999 title '',\
'HistoOut.HwU' index 22 using (($1+$2)/2):3 ls 2 title '',\
'HistoOut.HwU' index 22 using (($1+$2)/2):5 ls 12 title '',\
'HistoOut.HwU' index 22 using (($1+$2)/2):6 ls 12 title '',\
'HistoOut.HwU' index 22 using (($1+$2)/2):7 ls 22 title '',\
'HistoOut.HwU' index 22 using (($1+$2)/2):8 ls 22 title ''

unset label

################################################################################

################################################################################
### Rendering of the plot titled 'trans. mass K-factor'
################################################################################

set multiplot
set label "trans. mass K-factor" font ",13" at graph 0.04, graph 1.05
set xrange [0.0000e+00:2.0000e+02]
set bmargin 0 
set tmargin 0
set xtics nomirror
set ytics nomirror
set mytics 10
set xtics auto
set key horizontal noreverse maxcols 1 width -4 
set label front 'MadGraph5\_aMC\@NLO' font "Courier,11" rotate by 90 at graph 1.02, graph 0.04

#-- rendering subhistograms 'single diagram output'

set format y '10^{%%T}'
set yrange [2.3685e-02:3.1413e+01]
set origin 0.0000e+00, 5.0000e-01
set size 1.0000e+00, 4.0000e-01
set mytics 10
set ytics auto
set format x ''
set logscale y
set ylabel "{/Symbol s} per bin [pb]"

plot \
'HistoOut.HwU' index 23 using (($1+$2)/2):3 ls 1 title 'trans. mass K-factor, NLO',\
'HistoOut.HwU' index 23 using (($1+$2)/2):5 ls 11 title 'NLO scale variation',\
'HistoOut.HwU' index 23 using (($1+$2)/2):6 ls 11 title '',\
'HistoOut.HwU' index 23 using (($1+$2)/2):7 ls 21 title 'NLO PDF variation',\
'HistoOut.HwU' index 23 using (($1+$2)/2):8 ls 21 title ''
#-- rendering subhistograms 'Relative scale and PDF uncertainty'
unset label
unset format
set yrange [-3.2968e-01:3.6794e-01]
set origin 0.0000e+00, 3.5000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x
unset logscale y
set ylabel "NLO rel.unc."
set label "Relative uncertainties" font ",9" at graph 0.03, graph 0.13
plot \
0.0 ls 999 title '',\
'HistoOut.HwU' index 23 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 23 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 23 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 23 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 21 title ''

unset label

################################################################################

################################################################################
### Rendering of the plot titled 'w pt'
################################################################################

set multiplot
set label "w pt" font ",13" at graph 0.04, graph 1.05
set xrange [0.0000e+00:2.0000e+02]
set bmargin 0 
set tmargin 0
set xtics nomirror
set ytics nomirror
set mytics 10
set xtics auto
set key horizontal noreverse maxcols 1 width -4 
set label front 'MadGraph5\_aMC\@NLO' font "Courier,11" rotate by 90 at graph 1.02, graph 0.04

#-- rendering subhistograms 'NLO and LO results'

set format y '10^{%%T}'
set yrange [2.3067e+00:9.9691e+04]
set origin 0.0000e+00, 5.0000e-01
set size 1.0000e+00, 4.0000e-01
set mytics 10
set ytics auto
set format x ''
set logscale y
set ylabel "{/Symbol s} per bin [pb]"

plot \
'HistoOut.HwU' index 24 using (($1+$2)/2):3 ls 1 title 'w pt, NLO',\
'HistoOut.HwU' index 24 using (($1+$2)/2):5 ls 11 title 'NLO scale variation',\
'HistoOut.HwU' index 24 using (($1+$2)/2):6 ls 11 title '',\
'HistoOut.HwU' index 24 using (($1+$2)/2):7 ls 21 title 'NLO PDF variation',\
'HistoOut.HwU' index 24 using (($1+$2)/2):8 ls 21 title '',\
'HistoOut.HwU' index 25 using (($1+$2)/2):3 ls 2 title 'LO',\
'HistoOut.HwU' index 25 using (($1+$2)/2):5 ls 12 title 'LO scale variation',\
'HistoOut.HwU' index 25 using (($1+$2)/2):6 ls 12 title '',\
'HistoOut.HwU' index 25 using (($1+$2)/2):7 ls 22 title 'LO PDF variation',\
'HistoOut.HwU' index 25 using (($1+$2)/2):8 ls 22 title ''
#-- rendering subhistograms 'Relative scale and PDF uncertainty'
unset label
unset format
set yrange [-3.6492e-01:3.8950e-01]
set origin 0.0000e+00, 3.5000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x ''
unset logscale y
set ylabel "NLO rel.unc."
set label "Relative uncertainties" font ",9" at graph 0.03, graph 0.13
plot \
0.0 ls 999 title '',\
'HistoOut.HwU' index 24 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 24 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 24 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 24 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 25 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 12 title '',\
'HistoOut.HwU' index 25 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 12 title '',\
'HistoOut.HwU' index 25 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 22 title '',\
'HistoOut.HwU' index 25 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 22 title ''
#-- rendering subhistograms '(2)/NLO ratio'
unset label
unset format
set yrange [9.2557e-01:1.7009e+00]
set origin 0.0000e+00, 2.0000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x
unset logscale y
set ylabel "(2)/NLO"
set label "(2)/NLO" font ",9" at graph 0.03, graph 0.13
plot \
1.0 ls 999 title '',\
'HistoOut.HwU' index 26 using (($1+$2)/2):3 ls 2 title '',\
'HistoOut.HwU' index 26 using (($1+$2)/2):5 ls 12 title '',\
'HistoOut.HwU' index 26 using (($1+$2)/2):6 ls 12 title '',\
'HistoOut.HwU' index 26 using (($1+$2)/2):7 ls 22 title '',\
'HistoOut.HwU' index 26 using (($1+$2)/2):8 ls 22 title ''

unset label

################################################################################

################################################################################
### Rendering of the plot titled 'w pt K-factor'
################################################################################

set multiplot
set label "w pt K-factor" font ",13" at graph 0.04, graph 1.05
set xrange [0.0000e+00:1.0000e+01]
set bmargin 0 
set tmargin 0
set xtics nomirror
set ytics nomirror
set mytics 10
set xtics auto
set key horizontal noreverse maxcols 1 width -4 
set label front 'MadGraph5\_aMC\@NLO' font "Courier,11" rotate by 90 at graph 1.02, graph 0.04

#-- rendering subhistograms 'single diagram output'

set format y '10^{%%T}'
set yrange [5.6491e-01:1.0429e+01]
set origin 0.0000e+00, 5.0000e-01
set size 1.0000e+00, 4.0000e-01
set mytics 10
set ytics auto
set format x ''
set logscale y
set ylabel "{/Symbol s} per bin [pb]"

plot \
'HistoOut.HwU' index 27 using (($1+$2)/2):3 ls 1 title 'w pt K-factor, NLO',\
'HistoOut.HwU' index 27 using (($1+$2)/2):5 ls 11 title 'NLO scale variation',\
'HistoOut.HwU' index 27 using (($1+$2)/2):6 ls 11 title '',\
'HistoOut.HwU' index 27 using (($1+$2)/2):7 ls 21 title 'NLO PDF variation',\
'HistoOut.HwU' index 27 using (($1+$2)/2):8 ls 21 title ''
#-- rendering subhistograms 'Relative scale and PDF uncertainty'
unset label
unset format
set yrange [-3.1760e-01:2.5399e-01]
set origin 0.0000e+00, 3.5000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x
unset logscale y
set ylabel "NLO rel.unc."
set label "Relative uncertainties" font ",9" at graph 0.03, graph 0.13
plot \
0.0 ls 999 title '',\
'HistoOut.HwU' index 27 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 27 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 27 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 27 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 21 title ''

unset label

################################################################################

################################################################################
### Rendering of the plot titled 'w rapidity'
################################################################################

set multiplot
set label "w rapidity" font ",13" at graph 0.04, graph 1.05
set xrange [-5.0000e+00:5.0000e+00]
set bmargin 0 
set tmargin 0
set xtics nomirror
set ytics nomirror
set mytics 10
set xtics auto
set key horizontal noreverse maxcols 1 width -4 
set label front 'MadGraph5\_aMC\@NLO' font "Courier,11" rotate by 90 at graph 1.02, graph 0.04

#-- rendering subhistograms 'NLO and LO results'

set format y '10^{%%T}'
set yrange [2.5977e+01:8.4886e+03]
set origin 0.0000e+00, 5.0000e-01
set size 1.0000e+00, 4.0000e-01
set mytics 10
set ytics auto
set format x ''
set logscale y
set ylabel "{/Symbol s} per bin [pb]"

plot \
'HistoOut.HwU' index 28 using (($1+$2)/2):3 ls 1 title 'w rapidity, NLO',\
'HistoOut.HwU' index 28 using (($1+$2)/2):5 ls 11 title 'NLO scale variation',\
'HistoOut.HwU' index 28 using (($1+$2)/2):6 ls 11 title '',\
'HistoOut.HwU' index 28 using (($1+$2)/2):7 ls 21 title 'NLO PDF variation',\
'HistoOut.HwU' index 28 using (($1+$2)/2):8 ls 21 title '',\
'HistoOut.HwU' index 29 using (($1+$2)/2):3 ls 2 title 'LO',\
'HistoOut.HwU' index 29 using (($1+$2)/2):5 ls 12 title 'LO scale variation',\
'HistoOut.HwU' index 29 using (($1+$2)/2):6 ls 12 title '',\
'HistoOut.HwU' index 29 using (($1+$2)/2):7 ls 22 title 'LO PDF variation',\
'HistoOut.HwU' index 29 using (($1+$2)/2):8 ls 22 title ''
#-- rendering subhistograms 'Relative scale and PDF uncertainty'
unset label
unset format
set yrange [-1.8557e-01:1.4433e-01]
set origin 0.0000e+00, 3.5000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x ''
unset logscale y
set ylabel "NLO rel.unc."
set label "Relative uncertainties" font ",9" at graph 0.03, graph 0.13
plot \
0.0 ls 999 title '',\
'HistoOut.HwU' index 28 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 28 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 28 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 28 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 29 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 12 title '',\
'HistoOut.HwU' index 29 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 12 title '',\
'HistoOut.HwU' index 29 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 22 title '',\
'HistoOut.HwU' index 29 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 22 title ''
#-- rendering subhistograms '(2)/NLO ratio'
unset label
unset format
set yrange [3.8790e-01:1.3698e+00]
set origin 0.0000e+00, 2.0000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x
unset logscale y
set ylabel "(2)/NLO"
set label "(2)/NLO" font ",9" at graph 0.03, graph 0.13
plot \
1.0 ls 999 title '',\
'HistoOut.HwU' index 30 using (($1+$2)/2):3 ls 2 title '',\
'HistoOut.HwU' index 30 using (($1+$2)/2):5 ls 12 title '',\
'HistoOut.HwU' index 30 using (($1+$2)/2):6 ls 12 title '',\
'HistoOut.HwU' index 30 using (($1+$2)/2):7 ls 22 title '',\
'HistoOut.HwU' index 30 using (($1+$2)/2):8 ls 22 title ''

unset label

################################################################################

################################################################################
### Rendering of the plot titled 'w rapidity K-factor'
################################################################################

set multiplot
set label "w rapidity K-factor" font ",13" at graph 0.04, graph 1.05
set xrange [-5.0000e+00:5.0000e+00]
set bmargin 0 
set tmargin 0
set xtics nomirror
set ytics nomirror
set mytics 10
set xtics auto
set key horizontal noreverse maxcols 1 width -4 
set label front 'MadGraph5\_aMC\@NLO' font "Courier,11" rotate by 90 at graph 1.02, graph 0.04

#-- rendering subhistograms 'single diagram output'

set format y '10^{%%T}'
set yrange [7.2966e-01:1.9944e+01]
set origin 0.0000e+00, 5.0000e-01
set size 1.0000e+00, 4.0000e-01
set mytics 10
set ytics auto
set format x ''
set logscale y
set ylabel "{/Symbol s} per bin [pb]"

plot \
'HistoOut.HwU' index 31 using (($1+$2)/2):3 ls 1 title 'w rapidity K-factor, NLO',\
'HistoOut.HwU' index 31 using (($1+$2)/2):5 ls 11 title 'NLO scale variation',\
'HistoOut.HwU' index 31 using (($1+$2)/2):6 ls 11 title '',\
'HistoOut.HwU' index 31 using (($1+$2)/2):7 ls 21 title 'NLO PDF variation',\
'HistoOut.HwU' index 31 using (($1+$2)/2):8 ls 21 title ''
#-- rendering subhistograms 'Relative scale and PDF uncertainty'
unset label
unset format
set yrange [-2.6403e-01:3.2176e-01]
set origin 0.0000e+00, 3.5000e-01
set size 1.0000e+00, 1.5000e-01
set mytics 2
set ytics auto
set format x
unset logscale y
set ylabel "NLO rel.unc."
set label "Relative uncertainties" font ",9" at graph 0.03, graph 0.13
plot \
0.0 ls 999 title '',\
'HistoOut.HwU' index 31 using (($1+$2)/2):(safe($5,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 31 using (($1+$2)/2):(safe($6,$3,1.0)-1.0) ls 11 title '',\
'HistoOut.HwU' index 31 using (($1+$2)/2):(safe($7,$3,1.0)-1.0) ls 21 title '',\
'HistoOut.HwU' index 31 using (($1+$2)/2):(safe($8,$3,1.0)-1.0) ls 21 title ''

unset label

################################################################################
unset multiplot
!ps2pdf "HistoOut.ps" &> /dev/null
!open "HistoOut.pdf" &> /dev/null