      SUBROUTINE SMATRIX(P,ANS)
C     
C     Generated by MadGraph5_aMC@NLO v. %(version)s, %(date)s
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     MadGraph5_aMC@NLO StandAlone Version
C     
C     Returns amplitude squared summed/avg over colors
C     and helicities
C     for the point in phase space P(0:3,NEXTERNAL)
C     
C     Process: g g > w- t b~ QED=1 QCD=2 [ virt = QCD ] WEIGHTED=10
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=5)
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=48)
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,NEXTERNAL),ANS
C     
C     LOCAL VARIABLES 
C     
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY
      REAL*8 T
      REAL*8 MATRIX
      INTEGER IHEL,IDEN, I
      INTEGER JC(NEXTERNAL)
      LOGICAL GOODHEL(NCOMB)
      DATA NTRY/0/
      DATA GOODHEL/NCOMB*.FALSE./
      DATA (NHEL(I,   1),I=1,5) /-1,-1,-1,-1,-1/
      DATA (NHEL(I,   2),I=1,5) /-1,-1,-1,-1, 1/
      DATA (NHEL(I,   3),I=1,5) /-1,-1,-1, 1,-1/
      DATA (NHEL(I,   4),I=1,5) /-1,-1,-1, 1, 1/
      DATA (NHEL(I,   5),I=1,5) /-1,-1, 0,-1,-1/
      DATA (NHEL(I,   6),I=1,5) /-1,-1, 0,-1, 1/
      DATA (NHEL(I,   7),I=1,5) /-1,-1, 0, 1,-1/
      DATA (NHEL(I,   8),I=1,5) /-1,-1, 0, 1, 1/
      DATA (NHEL(I,   9),I=1,5) /-1,-1, 1,-1,-1/
      DATA (NHEL(I,  10),I=1,5) /-1,-1, 1,-1, 1/
      DATA (NHEL(I,  11),I=1,5) /-1,-1, 1, 1,-1/
      DATA (NHEL(I,  12),I=1,5) /-1,-1, 1, 1, 1/
      DATA (NHEL(I,  13),I=1,5) /-1, 1,-1,-1,-1/
      DATA (NHEL(I,  14),I=1,5) /-1, 1,-1,-1, 1/
      DATA (NHEL(I,  15),I=1,5) /-1, 1,-1, 1,-1/
      DATA (NHEL(I,  16),I=1,5) /-1, 1,-1, 1, 1/
      DATA (NHEL(I,  17),I=1,5) /-1, 1, 0,-1,-1/
      DATA (NHEL(I,  18),I=1,5) /-1, 1, 0,-1, 1/
      DATA (NHEL(I,  19),I=1,5) /-1, 1, 0, 1,-1/
      DATA (NHEL(I,  20),I=1,5) /-1, 1, 0, 1, 1/
      DATA (NHEL(I,  21),I=1,5) /-1, 1, 1,-1,-1/
      DATA (NHEL(I,  22),I=1,5) /-1, 1, 1,-1, 1/
      DATA (NHEL(I,  23),I=1,5) /-1, 1, 1, 1,-1/
      DATA (NHEL(I,  24),I=1,5) /-1, 1, 1, 1, 1/
      DATA (NHEL(I,  25),I=1,5) / 1,-1,-1,-1,-1/
      DATA (NHEL(I,  26),I=1,5) / 1,-1,-1,-1, 1/
      DATA (NHEL(I,  27),I=1,5) / 1,-1,-1, 1,-1/
      DATA (NHEL(I,  28),I=1,5) / 1,-1,-1, 1, 1/
      DATA (NHEL(I,  29),I=1,5) / 1,-1, 0,-1,-1/
      DATA (NHEL(I,  30),I=1,5) / 1,-1, 0,-1, 1/
      DATA (NHEL(I,  31),I=1,5) / 1,-1, 0, 1,-1/
      DATA (NHEL(I,  32),I=1,5) / 1,-1, 0, 1, 1/
      DATA (NHEL(I,  33),I=1,5) / 1,-1, 1,-1,-1/
      DATA (NHEL(I,  34),I=1,5) / 1,-1, 1,-1, 1/
      DATA (NHEL(I,  35),I=1,5) / 1,-1, 1, 1,-1/
      DATA (NHEL(I,  36),I=1,5) / 1,-1, 1, 1, 1/
      DATA (NHEL(I,  37),I=1,5) / 1, 1,-1,-1,-1/
      DATA (NHEL(I,  38),I=1,5) / 1, 1,-1,-1, 1/
      DATA (NHEL(I,  39),I=1,5) / 1, 1,-1, 1,-1/
      DATA (NHEL(I,  40),I=1,5) / 1, 1,-1, 1, 1/
      DATA (NHEL(I,  41),I=1,5) / 1, 1, 0,-1,-1/
      DATA (NHEL(I,  42),I=1,5) / 1, 1, 0,-1, 1/
      DATA (NHEL(I,  43),I=1,5) / 1, 1, 0, 1,-1/
      DATA (NHEL(I,  44),I=1,5) / 1, 1, 0, 1, 1/
      DATA (NHEL(I,  45),I=1,5) / 1, 1, 1,-1,-1/
      DATA (NHEL(I,  46),I=1,5) / 1, 1, 1,-1, 1/
      DATA (NHEL(I,  47),I=1,5) / 1, 1, 1, 1,-1/
      DATA (NHEL(I,  48),I=1,5) / 1, 1, 1, 1, 1/
      DATA IDEN/256/
C     ----------
C     BEGIN CODE
C     ----------
      NTRY=NTRY+1
      DO IHEL=1,NEXTERNAL
        JC(IHEL) = +1
      ENDDO
      ANS = 0D0
      DO IHEL=1,NCOMB
        IF (GOODHEL(IHEL) .OR. NTRY .LT. 20) THEN
          T=MATRIX(P ,NHEL(1,IHEL),JC(1))
          ANS=ANS+T
          IF (T .NE. 0D0 .AND. .NOT.    GOODHEL(IHEL)) THEN
            GOODHEL(IHEL)=.TRUE.
          ENDIF
        ENDIF
      ENDDO
      ANS=ANS/DBLE(IDEN)
      END


      REAL*8 FUNCTION MATRIX(P,NHEL,IC)
C     
C     Generated by MadGraph5_aMC@NLO v. %(version)s, %(date)s
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Returns amplitude squared summed/avg over colors
C     for the point with external lines W(0:6,NEXTERNAL)
C     
C     Process: g g > w- t b~ QED=1 QCD=2 [ virt = QCD ] WEIGHTED=10
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=8)
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=5)
      INTEGER    NWAVEFUNCS, NCOLOR
      PARAMETER (NWAVEFUNCS=9, NCOLOR=2)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
      COMPLEX*16 IMAG1
      PARAMETER (IMAG1=(0D0,1D0))
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,NEXTERNAL)
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,J
      COMPLEX*16 ZTEMP
      REAL*8 DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)
      COMPLEX*16 W(18,NWAVEFUNCS)
      COMPLEX*16 DUM0,DUM1
      DATA DUM0, DUM1/(0D0, 0D0), (1D0, 0D0)/
C     
C     GLOBAL VARIABLES
C     
      INCLUDE 'coupl.inc'

C     
C     COLOR DATA
C     
      DATA DENOM(1)/3/
      DATA (CF(I,  1),I=  1,  2) /   16,   -2/
C     1 T(1,2,4,5)
      DATA DENOM(2)/3/
      DATA (CF(I,  2),I=  1,  2) /   -2,   16/
C     1 T(2,1,4,5)
C     ----------
C     BEGIN CODE
C     ----------
      CALL VXXXXX(P(0,1),ZERO,NHEL(1),-1*IC(1),W(1,1))
      CALL VXXXXX(P(0,2),ZERO,NHEL(2),-1*IC(2),W(1,2))
      CALL VXXXXX(P(0,3),MDL_MW,NHEL(3),+1*IC(3),W(1,3))
      CALL OXXXXX(P(0,4),MDL_MT,NHEL(4),+1*IC(4),W(1,4))
      CALL IXXXXX(P(0,5),MDL_MB,NHEL(5),-1*IC(5),W(1,5))
      CALL VVV1P0_1(W(1,1),W(1,2),GC_4,ZERO,ZERO,W(1,6))
      CALL FFV2_1(W(1,4),W(1,3),GC_47,MDL_MB,ZERO,W(1,7))
C     Amplitude(s) for diagram number 1
      CALL FFV1_0(W(1,5),W(1,7),W(1,6),GC_5,AMP(1))
      CALL FFV2_2(W(1,5),W(1,3),GC_47,MDL_MT,MDL_WT,W(1,8))
C     Amplitude(s) for diagram number 2
      CALL FFV1_0(W(1,8),W(1,4),W(1,6),GC_5,AMP(2))
      CALL FFV1_1(W(1,4),W(1,1),GC_5,MDL_MT,MDL_WT,W(1,6))
      CALL FFV1_2(W(1,5),W(1,2),GC_5,MDL_MB,ZERO,W(1,9))
C     Amplitude(s) for diagram number 3
      CALL FFV2_0(W(1,9),W(1,6),W(1,3),GC_47,AMP(3))
C     Amplitude(s) for diagram number 4
      CALL FFV1_0(W(1,8),W(1,6),W(1,2),GC_5,AMP(4))
      CALL FFV1_2(W(1,5),W(1,1),GC_5,MDL_MB,ZERO,W(1,6))
      CALL FFV1_1(W(1,4),W(1,2),GC_5,MDL_MT,MDL_WT,W(1,5))
C     Amplitude(s) for diagram number 5
      CALL FFV2_0(W(1,6),W(1,5),W(1,3),GC_47,AMP(5))
C     Amplitude(s) for diagram number 6
      CALL FFV1_0(W(1,6),W(1,7),W(1,2),GC_5,AMP(6))
C     Amplitude(s) for diagram number 7
      CALL FFV1_0(W(1,8),W(1,5),W(1,1),GC_5,AMP(7))
C     Amplitude(s) for diagram number 8
      CALL FFV1_0(W(1,9),W(1,7),W(1,1),GC_5,AMP(8))
      JAMP(1)=+IMAG1*AMP(1)+IMAG1*AMP(2)-AMP(3)-AMP(4)-AMP(8)
      JAMP(2)=-IMAG1*AMP(1)-IMAG1*AMP(2)-AMP(5)-AMP(6)-AMP(7)

      MATRIX = 0.D0
      DO I = 1, NCOLOR
        ZTEMP = (0.D0,0.D0)
        DO J = 1, NCOLOR
          ZTEMP = ZTEMP + CF(J,I)*JAMP(J)
        ENDDO
        MATRIX = MATRIX+ZTEMP*DCONJG(JAMP(I))/DENOM(I)
      ENDDO

      END
