      SUBROUTINE ML5_0_MP_COEF_CONSTRUCTION_1(P,NHEL,H,IC)
C     
      USE ML5_0_POLYNOMIAL_CONSTANTS
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=5)
      INTEGER    NCOMB
      PARAMETER (NCOMB=48)

      INTEGER NBORNAMPS
      PARAMETER (NBORNAMPS=8)
      INTEGER    NLOOPS, NLOOPGROUPS, NCTAMPS
      PARAMETER (NLOOPS=144, NLOOPGROUPS=77, NCTAMPS=252)
      INTEGER    NLOOPAMPS
      PARAMETER (NLOOPAMPS=396)
      INTEGER    NWAVEFUNCS,NLOOPWAVEFUNCS
      PARAMETER (NWAVEFUNCS=28,NLOOPWAVEFUNCS=267)
      REAL*16     ZERO
      PARAMETER (ZERO=0.0E0_16)
      COMPLEX*32     IZERO
      PARAMETER (IZERO=CMPLX(0.0E0_16,0.0E0_16,KIND=16))
C     These are constants related to the split orders
      INTEGER    NSO, NSQUAREDSO, NAMPSO
      PARAMETER (NSO=0, NSQUAREDSO=0, NAMPSO=0)
C     
C     ARGUMENTS
C     
      REAL*16 P(0:3,NEXTERNAL)
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
      INTEGER H
C     
C     LOCAL VARIABLES
C     
      INTEGER I,J,K
      COMPLEX*32 COEFS(MAXLWFSIZE,0:VERTEXMAXCOEFS-1,MAXLWFSIZE)
C     
C     GLOBAL VARIABLES
C     
      INCLUDE 'mp_coupl_same_name.inc'

      INTEGER GOODHEL(NCOMB)
      LOGICAL GOODAMP(NSQUAREDSO,NLOOPGROUPS)
      COMMON/ML5_0_FILTERS/GOODAMP,GOODHEL

      INTEGER SQSO_TARGET
      COMMON/ML5_0_SOCHOICE/SQSO_TARGET

      LOGICAL UVCT_REQ_SO_DONE,MP_UVCT_REQ_SO_DONE,CT_REQ_SO_DONE
     $ ,MP_CT_REQ_SO_DONE,LOOP_REQ_SO_DONE,MP_LOOP_REQ_SO_DONE
     $ ,CTCALL_REQ_SO_DONE,FILTER_SO
      COMMON/ML5_0_SO_REQS/UVCT_REQ_SO_DONE,MP_UVCT_REQ_SO_DONE
     $ ,CT_REQ_SO_DONE,MP_CT_REQ_SO_DONE,LOOP_REQ_SO_DONE
     $ ,MP_LOOP_REQ_SO_DONE,CTCALL_REQ_SO_DONE,FILTER_SO

      COMPLEX*32 AMP(NBORNAMPS)
      COMMON/ML5_0_MP_AMPS/AMP
      COMPLEX*32 W(20,NWAVEFUNCS)
      COMMON/ML5_0_MP_W/W

      COMPLEX*32 WL(MAXLWFSIZE,0:LOOPMAXCOEFS-1,MAXLWFSIZE,
     $ -1:NLOOPWAVEFUNCS)
      COMPLEX*32 PL(0:3,-1:NLOOPWAVEFUNCS)
      COMMON/ML5_0_MP_WL/WL,PL

      COMPLEX*32 AMPL(3,NCTAMPS)
      COMMON/ML5_0_MP_AMPL/AMPL

C     
C     ----------
C     BEGIN CODE
C     ----------

C     The target squared split order contribution is already reached
C      if true.
      IF (FILTER_SO.AND.MP_LOOP_REQ_SO_DONE) THEN
        GOTO 1001
      ENDIF

C     Coefficient construction for loop diagram with ID 9
      CALL MP_FFV1L1P0_3(PL(0,0),W(1,7),GC_5,ZERO,ZERO,PL(0,1),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,1))
      CALL MP_FFV1L3_2(PL(0,1),W(1,13),GC_5,MDL_MB,ZERO,PL(0,2),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,1),4,COEFS,4,4,WL(1,0,1,2))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,2),1,4,1,1,1,253,H)
C     Coefficient construction for loop diagram with ID 10
      CALL MP_VVV1L2P0_1(PL(0,0),W(1,6),GC_4,ZERO,ZERO,PL(0,3),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,3))
      CALL MP_VVV1L2P0_1(PL(0,3),W(1,14),GC_4,ZERO,ZERO,PL(0,4),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,3),4,COEFS,4,4,WL(1,0,1,4))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,4),2,4,2,2,1,254,H)
C     Coefficient construction for loop diagram with ID 11
      CALL MP_FFV1L2P0_3(PL(0,0),W(1,5),GC_5,ZERO,ZERO,PL(0,5),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,5))
      CALL MP_VVV1L2P0_1(PL(0,5),W(1,6),GC_4,ZERO,ZERO,PL(0,6),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,5),4,COEFS,4,4,WL(1,0,1,6))
      CALL MP_FFV1L3_1(PL(0,6),W(1,7),GC_5,MDL_MB,ZERO,PL(0,7),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,6),4,COEFS,4,4,WL(1,0,1,7))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,7),2,4,3,1,1,255,H)
C     Coefficient construction for loop diagram with ID 12
      CALL MP_FFV1L3_2(PL(0,0),W(1,5),GC_5,MDL_MB,ZERO,PL(0,8),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,8))
      CALL MP_FFV1L1_2(PL(0,8),W(1,6),GC_5,MDL_MB,ZERO,PL(0,9),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,8),4,COEFS,4,4,WL(1,0,1,9))
      CALL MP_FFV1L1P0_3(PL(0,9),W(1,7),GC_5,ZERO,ZERO,PL(0,10),COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,9),4,COEFS,4,4,WL(1,0,1,10))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,10),2,4,4,1,1,256,H)
C     Coefficient construction for loop diagram with ID 13
      CALL MP_FFV1L2P0_3(PL(0,0),W(1,8),GC_5,ZERO,ZERO,PL(0,11),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,11))
      CALL MP_FFV1L3_1(PL(0,11),W(1,15),GC_5,MDL_MT,MDL_WT,PL(0,12)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,11),4,COEFS,4,4,WL(1,0,1,12)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,12),1,4,5,1,1,257,H)
C     Coefficient construction for loop diagram with ID 14
      CALL MP_VVV1L2P0_1(PL(0,3),W(1,16),GC_4,ZERO,ZERO,PL(0,13),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,3),4,COEFS,4,4,WL(1,0,1,13))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,13),2,4,2,2,1,258,H)
C     Coefficient construction for loop diagram with ID 15
      CALL MP_FFV1L1P0_3(PL(0,0),W(1,4),GC_5,ZERO,ZERO,PL(0,14),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,14))
      CALL MP_VVV1L2P0_1(PL(0,14),W(1,6),GC_4,ZERO,ZERO,PL(0,15),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,14),4,COEFS,4,4,WL(1,0,1,15)
     $ )
      CALL MP_FFV1L3_2(PL(0,15),W(1,8),GC_5,MDL_MT,MDL_WT,PL(0,16)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,15),4,COEFS,4,4,WL(1,0,1,16)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,16),2,4,6,1,1,259,H)
C     Coefficient construction for loop diagram with ID 16
      CALL MP_FFV1L3_1(PL(0,0),W(1,4),GC_5,MDL_MT,MDL_WT,PL(0,17)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,17))
      CALL MP_FFV1L2_1(PL(0,17),W(1,6),GC_5,MDL_MT,MDL_WT,PL(0,18)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,17),4,COEFS,4,4,WL(1,0,1,18)
     $ )
      CALL MP_FFV1L2P0_3(PL(0,18),W(1,8),GC_5,ZERO,ZERO,PL(0,19),COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,18),4,COEFS,4,4,WL(1,0,1,19)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,19),2,4,7,1,1,260,H)
C     Coefficient construction for loop diagram with ID 17
      CALL MP_FFV2L1_2(PL(0,0),W(1,3),GC_47,MDL_MT,MDL_WT,PL(0,20)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,20))
      CALL MP_FFV1L1P0_3(PL(0,20),W(1,4),GC_5,ZERO,ZERO,PL(0,21),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,20),4,COEFS,4,4,WL(1,0,1,21)
     $ )
      CALL MP_FFV1L3_2(PL(0,21),W(1,13),GC_5,MDL_MB,ZERO,PL(0,22)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,21),4,COEFS,4,4,WL(1,0,1,22)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,22),2,4,8,1,1,261,H)
C     Coefficient construction for loop diagram with ID 18
      CALL MP_VVV1L2P0_1(PL(0,21),W(1,6),GC_4,ZERO,ZERO,PL(0,23),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,21),4,COEFS,4,4,WL(1,0,1,23)
     $ )
      CALL MP_FFV1L3_2(PL(0,23),W(1,5),GC_5,MDL_MB,ZERO,PL(0,24),COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,23),4,COEFS,4,4,WL(1,0,1,24)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,24),3,4,9,1,1,262,H)
C     Coefficient construction for loop diagram with ID 19
      CALL MP_FFV2L2_1(PL(0,0),W(1,3),GC_47,MDL_MB,ZERO,PL(0,25),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,25))
      CALL MP_FFV1L2P0_3(PL(0,25),W(1,5),GC_5,ZERO,ZERO,PL(0,26),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,25),4,COEFS,4,4,WL(1,0,1,26)
     $ )
      CALL MP_FFV1L3_1(PL(0,26),W(1,4),GC_5,MDL_MT,MDL_WT,PL(0,27)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,26),4,COEFS,4,4,WL(1,0,1,27)
     $ )
      CALL MP_FFV1L2_1(PL(0,27),W(1,6),GC_5,MDL_MT,MDL_WT,PL(0,28)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,27),4,COEFS,4,4,WL(1,0,1,28)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,28),3,4,10,1,1,263,H)
C     Coefficient construction for loop diagram with ID 20
      CALL MP_FFV1L3_2(PL(0,21),W(1,5),GC_5,MDL_MB,ZERO,PL(0,29),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,21),4,COEFS,4,4,WL(1,0,1,29)
     $ )
      CALL MP_FFV1L1_2(PL(0,29),W(1,6),GC_5,MDL_MB,ZERO,PL(0,30),COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,29),4,COEFS,4,4,WL(1,0,1,30)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,30),3,4,11,1,1,264,H)
C     Coefficient construction for loop diagram with ID 21
      CALL MP_FFV1L3_1(PL(0,26),W(1,15),GC_5,MDL_MT,MDL_WT,PL(0,31)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,26),4,COEFS,4,4,WL(1,0,1,31)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,31),2,4,12,1,1,265,H)
C     Coefficient construction for loop diagram with ID 22
      CALL MP_FFV1L2P0_3(PL(0,0),W(1,10),GC_5,ZERO,ZERO,PL(0,32),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,32))
      CALL MP_FFV1L3_1(PL(0,32),W(1,17),GC_5,MDL_MB,ZERO,PL(0,33)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,32),4,COEFS,4,4,WL(1,0,1,33)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,33),1,4,13,1,1,266,H)
C     Coefficient construction for loop diagram with ID 23
      CALL MP_FFV1L1P0_3(PL(0,0),W(1,9),GC_5,ZERO,ZERO,PL(0,34),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,34))
      CALL MP_FFV1L3_2(PL(0,34),W(1,18),GC_5,MDL_MT,MDL_WT,PL(0,35)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,34),4,COEFS,4,4,WL(1,0,1,35)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,35),1,4,14,1,1,267,H)
C     Coefficient construction for loop diagram with ID 24
      CALL MP_FFV1L1P0_3(PL(0,20),W(1,9),GC_5,ZERO,ZERO,PL(0,36),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,20),4,COEFS,4,4,WL(1,0,1,36)
     $ )
      CALL MP_FFV1L3_2(PL(0,36),W(1,10),GC_5,MDL_MB,ZERO,PL(0,37)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,36),4,COEFS,4,4,WL(1,0,1,37)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,37),2,4,15,1,1,268,H)
C     Coefficient construction for loop diagram with ID 25
      CALL MP_VVV1L2P0_1(PL(0,0),W(1,2),GC_4,ZERO,ZERO,PL(0,38),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,38))
      CALL MP_FFV1L3_2(PL(0,38),W(1,5),GC_5,MDL_MB,ZERO,PL(0,39),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,38),4,COEFS,4,4,WL(1,0,1,39)
     $ )
      CALL MP_FFV1L1P0_3(PL(0,39),W(1,17),GC_5,ZERO,ZERO,PL(0,40)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,39),4,COEFS,4,4,WL(1,0,1,40)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,40),2,4,16,1,1,269,H)
C     Coefficient construction for loop diagram with ID 26
      CALL MP_FFV2L1_2(PL(0,39),W(1,3),GC_47,MDL_MT,MDL_WT,PL(0,41)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,39),4,COEFS,4,4,WL(1,0,1,41)
     $ )
      CALL MP_FFV1L1P0_3(PL(0,41),W(1,9),GC_5,ZERO,ZERO,PL(0,42),COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_0(WL(1,0,1,41),4,COEFS,4,4,WL(1,0,1,42)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,42),3,4,17,1,1,270,H)
C     Coefficient construction for loop diagram with ID 27
      CALL MP_FFV1L3_1(PL(0,38),W(1,9),GC_5,MDL_MT,MDL_WT,PL(0,43)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,38),4,COEFS,4,4,WL(1,0,1,43)
     $ )
      CALL MP_FFV1L2P0_3(PL(0,43),W(1,8),GC_5,ZERO,ZERO,PL(0,44),COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,43),4,COEFS,4,4,WL(1,0,1,44)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,44),2,4,18,1,1,271,H)
C     Coefficient construction for loop diagram with ID 28
      CALL MP_FFV1L3_1(PL(0,11),W(1,19),GC_5,MDL_MT,MDL_WT,PL(0,45)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,11),4,COEFS,4,4,WL(1,0,1,45)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,45),1,4,5,1,1,272,H)
C     Coefficient construction for loop diagram with ID 29
      CALL MP_FFV1L3_2(PL(0,34),W(1,20),GC_5,MDL_MT,MDL_WT,PL(0,46)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,34),4,COEFS,4,4,WL(1,0,1,46)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,46),1,4,14,1,1,273,H)
C     Coefficient construction for loop diagram with ID 30
      CALL MP_FFV1L1_2(PL(0,0),W(1,2),GC_5,MDL_MT,MDL_WT,PL(0,47)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,47))
      CALL MP_FFV1L1P0_3(PL(0,47),W(1,9),GC_5,ZERO,ZERO,PL(0,48),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,47),4,COEFS,4,4,WL(1,0,1,48)
     $ )
      CALL MP_FFV1L3_2(PL(0,48),W(1,8),GC_5,MDL_MT,MDL_WT,PL(0,49)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,48),4,COEFS,4,4,WL(1,0,1,49)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,49),2,4,19,1,1,274,H)
C     Coefficient construction for loop diagram with ID 31
      CALL MP_FFV1L3_1(PL(0,26),W(1,19),GC_5,MDL_MT,MDL_WT,PL(0,50)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,26),4,COEFS,4,4,WL(1,0,1,50)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,50),2,4,12,1,1,275,H)
C     Coefficient construction for loop diagram with ID 32
      CALL MP_FFV1L2_1(PL(0,0),W(1,2),GC_5,MDL_MB,ZERO,PL(0,51),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,51))
      CALL MP_FFV1L2P0_3(PL(0,51),W(1,5),GC_5,ZERO,ZERO,PL(0,52),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,51),4,COEFS,4,4,WL(1,0,1,52)
     $ )
      CALL MP_FFV1L3_1(PL(0,52),W(1,17),GC_5,MDL_MB,ZERO,PL(0,53)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,52),4,COEFS,4,4,WL(1,0,1,53)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,53),2,4,20,1,1,276,H)
C     Coefficient construction for loop diagram with ID 33
      CALL MP_FFV1L1_2(PL(0,0),W(1,2),GC_5,MDL_MB,ZERO,PL(0,54),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,54))
      CALL MP_FFV2L1_2(PL(0,54),W(1,3),GC_47,MDL_MT,MDL_WT,PL(0,55)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,54),4,COEFS,4,4,WL(1,0,1,55)
     $ )
      CALL MP_FFV1L1P0_3(PL(0,55),W(1,9),GC_5,ZERO,ZERO,PL(0,56),COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,55),4,COEFS,4,4,WL(1,0,1,56)
     $ )
      CALL MP_FFV1L3_2(PL(0,56),W(1,5),GC_5,MDL_MB,ZERO,PL(0,57),COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,56),4,COEFS,4,4,WL(1,0,1,57)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,57),3,4,21,1,1,277,H)
C     Coefficient construction for loop diagram with ID 34
      CALL MP_FFV1L2_1(PL(0,0),W(1,2),GC_5,MDL_MT,MDL_WT,PL(0,58)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,58))
      CALL MP_FFV2L2_1(PL(0,58),W(1,3),GC_47,MDL_MB,ZERO,PL(0,59)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,58),4,COEFS,4,4,WL(1,0,1,59)
     $ )
      CALL MP_FFV1L2P0_3(PL(0,59),W(1,5),GC_5,ZERO,ZERO,PL(0,60),COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,59),4,COEFS,4,4,WL(1,0,1,60)
     $ )
      CALL MP_FFV1L3_1(PL(0,60),W(1,9),GC_5,MDL_MT,MDL_WT,PL(0,61)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,60),4,COEFS,4,4,WL(1,0,1,61)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,61),3,4,22,1,1,278,H)
C     Coefficient construction for loop diagram with ID 35
      CALL MP_FFV1L1P0_3(PL(0,0),W(1,12),GC_5,ZERO,ZERO,PL(0,62),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,62))
      CALL MP_FFV1L3_2(PL(0,62),W(1,21),GC_5,MDL_MT,MDL_WT,PL(0,63)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,62),4,COEFS,4,4,WL(1,0,1,63)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,63),1,4,23,1,1,279,H)
C     Coefficient construction for loop diagram with ID 36
      CALL MP_FFV1L2P0_3(PL(0,0),W(1,11),GC_5,ZERO,ZERO,PL(0,64),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,64))
      CALL MP_FFV1L3_1(PL(0,64),W(1,22),GC_5,MDL_MB,ZERO,PL(0,65)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,64),4,COEFS,4,4,WL(1,0,1,65)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,65),1,4,24,1,1,280,H)
C     Coefficient construction for loop diagram with ID 37
      CALL MP_FFV1L1P0_3(PL(0,20),W(1,12),GC_5,ZERO,ZERO,PL(0,66)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,20),4,COEFS,4,4,WL(1,0,1,66)
     $ )
      CALL MP_FFV1L3_2(PL(0,66),W(1,11),GC_5,MDL_MB,ZERO,PL(0,67)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,66),4,COEFS,4,4,WL(1,0,1,67)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,67),2,4,25,1,1,281,H)
C     Coefficient construction for loop diagram with ID 38
      CALL MP_FFV1L3_1(PL(0,38),W(1,4),GC_5,MDL_MT,MDL_WT,PL(0,68)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,38),4,COEFS,4,4,WL(1,0,1,68)
     $ )
      CALL MP_FFV1L2P0_3(PL(0,68),W(1,21),GC_5,ZERO,ZERO,PL(0,69)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,68),4,COEFS,4,4,WL(1,0,1,69)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,69),2,4,26,1,1,282,H)
C     Coefficient construction for loop diagram with ID 39
      CALL MP_FFV2L2_1(PL(0,68),W(1,3),GC_47,MDL_MB,ZERO,PL(0,70)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,68),4,COEFS,4,4,WL(1,0,1,70)
     $ )
      CALL MP_FFV1L2P0_3(PL(0,70),W(1,11),GC_5,ZERO,ZERO,PL(0,71)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_0(WL(1,0,1,70),4,COEFS,4,4,WL(1,0,1,71)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,71),3,4,27,1,1,283,H)
C     Coefficient construction for loop diagram with ID 40
      CALL MP_FFV1L3_1(PL(0,38),W(1,7),GC_5,MDL_MB,ZERO,PL(0,72),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,38),4,COEFS,4,4,WL(1,0,1,72)
     $ )
      CALL MP_FFV1L2P0_3(PL(0,72),W(1,11),GC_5,ZERO,ZERO,PL(0,73)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,72),4,COEFS,4,4,WL(1,0,1,73)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,73),2,4,28,1,1,284,H)
C     Coefficient construction for loop diagram with ID 41
      CALL MP_FFV1L3_2(PL(0,1),W(1,23),GC_5,MDL_MB,ZERO,PL(0,74),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,1),4,COEFS,4,4,WL(1,0,1,74))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,74),1,4,1,1,1,285,H)
C     Coefficient construction for loop diagram with ID 42
      CALL MP_FFV1L3_1(PL(0,64),W(1,24),GC_5,MDL_MB,ZERO,PL(0,75)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,64),4,COEFS,4,4,WL(1,0,1,75)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,75),1,4,24,1,1,286,H)
C     Coefficient construction for loop diagram with ID 43
      CALL MP_FFV1L1P0_3(PL(0,54),W(1,7),GC_5,ZERO,ZERO,PL(0,76),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,54),4,COEFS,4,4,WL(1,0,1,76)
     $ )
      CALL MP_FFV1L3_2(PL(0,76),W(1,11),GC_5,MDL_MB,ZERO,PL(0,77)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,76),4,COEFS,4,4,WL(1,0,1,77)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,77),2,4,29,1,1,287,H)
C     Coefficient construction for loop diagram with ID 44
      CALL MP_FFV1L3_2(PL(0,21),W(1,23),GC_5,MDL_MB,ZERO,PL(0,78)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,21),4,COEFS,4,4,WL(1,0,1,78)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,78),2,4,8,1,1,288,H)
C     Coefficient construction for loop diagram with ID 45
      CALL MP_FFV1L1P0_3(PL(0,47),W(1,4),GC_5,ZERO,ZERO,PL(0,79),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,47),4,COEFS,4,4,WL(1,0,1,79)
     $ )
      CALL MP_FFV1L3_2(PL(0,79),W(1,21),GC_5,MDL_MT,MDL_WT,PL(0,80)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,79),4,COEFS,4,4,WL(1,0,1,80)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,80),2,4,30,1,1,289,H)
C     Coefficient construction for loop diagram with ID 46
      CALL MP_FFV1L2P0_3(PL(0,59),W(1,11),GC_5,ZERO,ZERO,PL(0,81)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,59),4,COEFS,4,4,WL(1,0,1,81)
     $ )
      CALL MP_FFV1L3_1(PL(0,81),W(1,4),GC_5,MDL_MT,MDL_WT,PL(0,82)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,81),4,COEFS,4,4,WL(1,0,1,82)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,82),3,4,31,1,1,290,H)
C     Coefficient construction for loop diagram with ID 47
      CALL MP_FFV1L1P0_3(PL(0,55),W(1,4),GC_5,ZERO,ZERO,PL(0,83),COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,55),4,COEFS,4,4,WL(1,0,1,83)
     $ )
      CALL MP_FFV1L3_2(PL(0,83),W(1,11),GC_5,MDL_MB,ZERO,PL(0,84)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,83),4,COEFS,4,4,WL(1,0,1,84)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,84),3,4,32,1,1,291,H)
C     Coefficient construction for loop diagram with ID 48
      CALL MP_VVV1L2P0_1(PL(0,0),W(1,1),GC_4,ZERO,ZERO,PL(0,85),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,85))
      CALL MP_FFV1L3_2(PL(0,85),W(1,5),GC_5,MDL_MB,ZERO,PL(0,86),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,85),4,COEFS,4,4,WL(1,0,1,86)
     $ )
      CALL MP_FFV1L1P0_3(PL(0,86),W(1,22),GC_5,ZERO,ZERO,PL(0,87)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,86),4,COEFS,4,4,WL(1,0,1,87)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,87),2,4,33,1,1,292,H)
C     Coefficient construction for loop diagram with ID 49
      CALL MP_FFV2L1_2(PL(0,86),W(1,3),GC_47,MDL_MT,MDL_WT,PL(0,88)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,86),4,COEFS,4,4,WL(1,0,1,88)
     $ )
      CALL MP_FFV1L1P0_3(PL(0,88),W(1,12),GC_5,ZERO,ZERO,PL(0,89)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_0(WL(1,0,1,88),4,COEFS,4,4,WL(1,0,1,89)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,89),3,4,34,1,1,293,H)
C     Coefficient construction for loop diagram with ID 50
      CALL MP_FFV1L3_1(PL(0,85),W(1,12),GC_5,MDL_MT,MDL_WT,PL(0,90)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,85),4,COEFS,4,4,WL(1,0,1,90)
     $ )
      CALL MP_FFV1L2P0_3(PL(0,90),W(1,8),GC_5,ZERO,ZERO,PL(0,91),COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,90),4,COEFS,4,4,WL(1,0,1,91)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,91),2,4,35,1,1,294,H)
C     Coefficient construction for loop diagram with ID 51
      CALL MP_FFV1L3_1(PL(0,85),W(1,4),GC_5,MDL_MT,MDL_WT,PL(0,92)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,85),4,COEFS,4,4,WL(1,0,1,92)
     $ )
      CALL MP_FFV1L2P0_3(PL(0,92),W(1,18),GC_5,ZERO,ZERO,PL(0,93)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,92),4,COEFS,4,4,WL(1,0,1,93)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,93),2,4,36,1,1,295,H)
C     Coefficient construction for loop diagram with ID 52
      CALL MP_FFV2L2_1(PL(0,92),W(1,3),GC_47,MDL_MB,ZERO,PL(0,94)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,92),4,COEFS,4,4,WL(1,0,1,94)
     $ )
      CALL MP_FFV1L2P0_3(PL(0,94),W(1,10),GC_5,ZERO,ZERO,PL(0,95)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_0(WL(1,0,1,94),4,COEFS,4,4,WL(1,0,1,95)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,95),3,4,37,1,1,296,H)
C     Coefficient construction for loop diagram with ID 53
      CALL MP_FFV1L3_1(PL(0,85),W(1,7),GC_5,MDL_MB,ZERO,PL(0,96),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,85),4,COEFS,4,4,WL(1,0,1,96)
     $ )
      CALL MP_FFV1L2P0_3(PL(0,96),W(1,10),GC_5,ZERO,ZERO,PL(0,97)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,96),4,COEFS,4,4,WL(1,0,1,97)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,97),2,4,38,1,1,297,H)
C     Coefficient construction for loop diagram with ID 54
      CALL MP_VVV1L2P0_1(PL(0,85),W(1,2),GC_4,ZERO,ZERO,PL(0,98),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,85),4,COEFS,4,4,WL(1,0,1,98)
     $ )
      CALL MP_FFV1L3_2(PL(0,98),W(1,5),GC_5,MDL_MB,ZERO,PL(0,99),COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,98),4,COEFS,4,4,WL(1,0,1,99)
     $ )
      CALL MP_FFV2L1_2(PL(0,99),W(1,3),GC_47,MDL_MT,MDL_WT,PL(0,100)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_1(WL(1,0,1,99),4,COEFS,4,4,WL(1,0,1
     $ ,100))
      CALL MP_FFV1L1P0_3(PL(0,100),W(1,4),GC_5,ZERO,ZERO,PL(0,101)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_4_0(WL(1,0,1,100),4,COEFS,4,4,WL(1,0,1
     $ ,101))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,101),4,4,39,1,1,298,H)
C     Coefficient construction for loop diagram with ID 55
      CALL MP_FFV1L3_1(PL(0,98),W(1,4),GC_5,MDL_MT,MDL_WT,PL(0,102)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,98),4,COEFS,4,4,WL(1,0,1
     $ ,102))
      CALL MP_FFV2L2_1(PL(0,102),W(1,3),GC_47,MDL_MB,ZERO,PL(0,103)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_1(WL(1,0,1,102),4,COEFS,4,4,WL(1,0,1
     $ ,103))
      CALL MP_FFV1L2P0_3(PL(0,103),W(1,5),GC_5,ZERO,ZERO,PL(0,104)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_4_0(WL(1,0,1,103),4,COEFS,4,4,WL(1,0,1
     $ ,104))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,104),4,4,40,1,1,299,H)
C     Coefficient construction for loop diagram with ID 56
      CALL MP_VVV1L2P0_1(PL(0,98),W(1,14),GC_4,ZERO,ZERO,PL(0,105)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,98),4,COEFS,4,4,WL(1,0,1
     $ ,105))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,105),3,4,41,1,1,300,H)
C     Coefficient construction for loop diagram with ID 57
      CALL MP_FFV1L1P0_3(PL(0,99),W(1,7),GC_5,ZERO,ZERO,PL(0,106)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_0(WL(1,0,1,99),4,COEFS,4,4,WL(1,0,1
     $ ,106))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,106),3,4,42,1,1,301,H)
C     Coefficient construction for loop diagram with ID 58
      CALL MP_FFV1L3_1(PL(0,98),W(1,7),GC_5,MDL_MB,ZERO,PL(0,107)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,98),4,COEFS,4,4,WL(1,0,1
     $ ,107))
      CALL MP_FFV1L2P0_3(PL(0,107),W(1,5),GC_5,ZERO,ZERO,PL(0,108)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_0(WL(1,0,1,107),4,COEFS,4,4,WL(1,0,1
     $ ,108))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,108),3,4,43,1,1,302,H)
C     Coefficient construction for loop diagram with ID 59
      CALL MP_VVV1L2P0_1(PL(0,98),W(1,16),GC_4,ZERO,ZERO,PL(0,109)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,98),4,COEFS,4,4,WL(1,0,1
     $ ,109))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,109),3,4,41,1,1,303,H)
C     Coefficient construction for loop diagram with ID 60
      CALL MP_FFV1L2P0_3(PL(0,102),W(1,8),GC_5,ZERO,ZERO,PL(0,110)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_0(WL(1,0,1,102),4,COEFS,4,4,WL(1,0,1
     $ ,110))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,110),3,4,44,1,1,304,H)
C     Coefficient construction for loop diagram with ID 61
      CALL MP_FFV1L3_2(PL(0,98),W(1,8),GC_5,MDL_MT,MDL_WT,PL(0,111)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,98),4,COEFS,4,4,WL(1,0,1
     $ ,111))
      CALL MP_FFV1L1P0_3(PL(0,111),W(1,4),GC_5,ZERO,ZERO,PL(0,112)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_0(WL(1,0,1,111),4,COEFS,4,4,WL(1,0,1
     $ ,112))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,112),3,4,45,1,1,305,H)
C     Coefficient construction for loop diagram with ID 62
      CALL MP_FFV1L1P0_3(PL(0,86),W(1,24),GC_5,ZERO,ZERO,PL(0,113)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,86),4,COEFS,4,4,WL(1,0,1
     $ ,113))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,113),2,4,33,1,1,306,H)
C     Coefficient construction for loop diagram with ID 63
      CALL MP_FFV1L1_2(PL(0,86),W(1,2),GC_5,MDL_MB,ZERO,PL(0,114)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,86),4,COEFS,4,4,WL(1,0,1
     $ ,114))
      CALL MP_FFV1L1P0_3(PL(0,114),W(1,7),GC_5,ZERO,ZERO,PL(0,115)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_0(WL(1,0,1,114),4,COEFS,4,4,WL(1,0,1
     $ ,115))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,115),3,4,46,1,1,307,H)
C     Coefficient construction for loop diagram with ID 64
      CALL MP_VVVV1L2P0_1(PL(0,85),W(1,14),W(1,2),GC_6,ZERO,ZERO,PL(0
     $ ,116),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,85),4,COEFS,4,4,WL(1,0,1
     $ ,116))
      CALL MP_VVVV3L2P0_1(PL(0,85),W(1,14),W(1,2),GC_6,ZERO,ZERO,PL(0
     $ ,117),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,85),4,COEFS,4,4,WL(1,0,1
     $ ,117))
      CALL MP_VVVV4L2P0_1(PL(0,85),W(1,14),W(1,2),GC_6,ZERO,ZERO,PL(0
     $ ,118),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,85),4,COEFS,4,4,WL(1,0,1
     $ ,118))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,116),1,4,47,2,1,308,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,117),1,4,47,2,1,309,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,118),1,4,47,2,1,310,H)
C     Coefficient construction for loop diagram with ID 65
      CALL MP_FFV1L2P0_3(PL(0,92),W(1,20),GC_5,ZERO,ZERO,PL(0,119)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,92),4,COEFS,4,4,WL(1,0,1
     $ ,119))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,119),2,4,36,1,1,311,H)
C     Coefficient construction for loop diagram with ID 66
      CALL MP_FFV1L2_1(PL(0,92),W(1,2),GC_5,MDL_MT,MDL_WT,PL(0,120)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,92),4,COEFS,4,4,WL(1,0,1
     $ ,120))
      CALL MP_FFV1L2P0_3(PL(0,120),W(1,8),GC_5,ZERO,ZERO,PL(0,121)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_0(WL(1,0,1,120),4,COEFS,4,4,WL(1,0,1
     $ ,121))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,121),3,4,48,1,1,312,H)
C     Coefficient construction for loop diagram with ID 67
      CALL MP_VVVV1L2P0_1(PL(0,85),W(1,16),W(1,2),GC_6,ZERO,ZERO,PL(0
     $ ,122),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,85),4,COEFS,4,4,WL(1,0,1
     $ ,122))
      CALL MP_VVVV3L2P0_1(PL(0,85),W(1,16),W(1,2),GC_6,ZERO,ZERO,PL(0
     $ ,123),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,85),4,COEFS,4,4,WL(1,0,1
     $ ,123))
      CALL MP_VVVV4L2P0_1(PL(0,85),W(1,16),W(1,2),GC_6,ZERO,ZERO,PL(0
     $ ,124),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,85),4,COEFS,4,4,WL(1,0,1
     $ ,124))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,122),1,4,47,2,1,313,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,123),1,4,47,2,1,314,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,124),1,4,47,2,1,315,H)
C     Coefficient construction for loop diagram with ID 68
      CALL MP_FFV2L2_1(PL(0,120),W(1,3),GC_47,MDL_MB,ZERO,PL(0,125)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_1(WL(1,0,1,120),4,COEFS,4,4,WL(1,0,1
     $ ,125))
      CALL MP_FFV1L2P0_3(PL(0,125),W(1,5),GC_5,ZERO,ZERO,PL(0,126)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_4_0(WL(1,0,1,125),4,COEFS,4,4,WL(1,0,1
     $ ,126))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,126),4,4,49,1,1,316,H)
C     Coefficient construction for loop diagram with ID 69
      CALL MP_FFV1L2_1(PL(0,94),W(1,2),GC_5,MDL_MB,ZERO,PL(0,127)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_1(WL(1,0,1,94),4,COEFS,4,4,WL(1,0,1
     $ ,127))
      CALL MP_FFV1L2P0_3(PL(0,127),W(1,5),GC_5,ZERO,ZERO,PL(0,128)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_4_0(WL(1,0,1,127),4,COEFS,4,4,WL(1,0,1
     $ ,128))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,128),4,4,50,1,1,317,H)
C     Coefficient construction for loop diagram with ID 70
      CALL MP_FFV1L3_1(PL(0,11),W(1,25),GC_5,MDL_MT,MDL_WT,PL(0,129)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,11),4,COEFS,4,4,WL(1,0,1
     $ ,129))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,129),1,4,5,1,1,318,H)
C     Coefficient construction for loop diagram with ID 71
      CALL MP_FFV1L3_2(PL(0,62),W(1,26),GC_5,MDL_MT,MDL_WT,PL(0,130)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,62),4,COEFS,4,4,WL(1,0,1
     $ ,130))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,130),1,4,23,1,1,319,H)
C     Coefficient construction for loop diagram with ID 72
      CALL MP_FFV1L1_2(PL(0,0),W(1,1),GC_5,MDL_MT,MDL_WT,PL(0,131)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,131)
     $ )
      CALL MP_FFV1L1P0_3(PL(0,131),W(1,12),GC_5,ZERO,ZERO,PL(0,132)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,131),4,COEFS,4,4,WL(1,0,1
     $ ,132))
      CALL MP_FFV1L3_2(PL(0,132),W(1,8),GC_5,MDL_MT,MDL_WT,PL(0,133)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,132),4,COEFS,4,4,WL(1,0,1
     $ ,133))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,133),2,4,51,1,1,320,H)
C     Coefficient construction for loop diagram with ID 73
      CALL MP_FFV1L3_1(PL(0,26),W(1,25),GC_5,MDL_MT,MDL_WT,PL(0,134)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,26),4,COEFS,4,4,WL(1,0,1
     $ ,134))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,134),2,4,12,1,1,321,H)
C     Coefficient construction for loop diagram with ID 74
      CALL MP_FFV1L2_1(PL(0,0),W(1,1),GC_5,MDL_MB,ZERO,PL(0,135),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,135)
     $ )
      CALL MP_FFV1L2P0_3(PL(0,135),W(1,5),GC_5,ZERO,ZERO,PL(0,136)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,135),4,COEFS,4,4,WL(1,0,1
     $ ,136))
      CALL MP_FFV1L3_1(PL(0,136),W(1,22),GC_5,MDL_MB,ZERO,PL(0,137)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,136),4,COEFS,4,4,WL(1,0,1
     $ ,137))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,137),2,4,52,1,1,322,H)
C     Coefficient construction for loop diagram with ID 75
      CALL MP_FFV1L1_2(PL(0,0),W(1,1),GC_5,MDL_MB,ZERO,PL(0,138),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,138)
     $ )
      CALL MP_FFV2L1_2(PL(0,138),W(1,3),GC_47,MDL_MT,MDL_WT,PL(0,139)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,138),4,COEFS,4,4,WL(1,0,1
     $ ,139))
      CALL MP_FFV1L1P0_3(PL(0,139),W(1,12),GC_5,ZERO,ZERO,PL(0,140)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,139),4,COEFS,4,4,WL(1,0,1
     $ ,140))
      CALL MP_FFV1L3_2(PL(0,140),W(1,5),GC_5,MDL_MB,ZERO,PL(0,141)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,140),4,COEFS,4,4,WL(1,0,1
     $ ,141))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,141),3,4,53,1,1,323,H)
C     Coefficient construction for loop diagram with ID 76
      CALL MP_FFV1L2_1(PL(0,0),W(1,1),GC_5,MDL_MT,MDL_WT,PL(0,142)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,142)
     $ )
      CALL MP_FFV2L2_1(PL(0,142),W(1,3),GC_47,MDL_MB,ZERO,PL(0,143)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,142),4,COEFS,4,4,WL(1,0,1
     $ ,143))
      CALL MP_FFV1L2P0_3(PL(0,143),W(1,5),GC_5,ZERO,ZERO,PL(0,144)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,143),4,COEFS,4,4,WL(1,0,1
     $ ,144))
      CALL MP_FFV1L3_1(PL(0,144),W(1,12),GC_5,MDL_MT,MDL_WT,PL(0,145)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,144),4,COEFS,4,4,WL(1,0,1
     $ ,145))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,145),3,4,54,1,1,324,H)
C     Coefficient construction for loop diagram with ID 77
      CALL MP_FFV1L3_2(PL(0,1),W(1,27),GC_5,MDL_MB,ZERO,PL(0,146)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,1),4,COEFS,4,4,WL(1,0,1,146)
     $ )
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,146),1,4,1,1,1,325,H)
C     Coefficient construction for loop diagram with ID 78
      CALL MP_FFV1L3_1(PL(0,32),W(1,28),GC_5,MDL_MB,ZERO,PL(0,147)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,32),4,COEFS,4,4,WL(1,0,1
     $ ,147))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,147),1,4,13,1,1,326,H)
C     Coefficient construction for loop diagram with ID 79
      CALL MP_FFV1L1P0_3(PL(0,138),W(1,7),GC_5,ZERO,ZERO,PL(0,148)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,138),4,COEFS,4,4,WL(1,0,1
     $ ,148))
      CALL MP_FFV1L3_2(PL(0,148),W(1,10),GC_5,MDL_MB,ZERO,PL(0,149)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,148),4,COEFS,4,4,WL(1,0,1
     $ ,149))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,149),2,4,55,1,1,327,H)
C     Coefficient construction for loop diagram with ID 80
      CALL MP_FFV1L3_2(PL(0,21),W(1,27),GC_5,MDL_MB,ZERO,PL(0,150)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,21),4,COEFS,4,4,WL(1,0,1
     $ ,150))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,150),2,4,8,1,1,328,H)
C     Coefficient construction for loop diagram with ID 81
      CALL MP_FFV1L1P0_3(PL(0,131),W(1,4),GC_5,ZERO,ZERO,PL(0,151)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,131),4,COEFS,4,4,WL(1,0,1
     $ ,151))
      CALL MP_FFV1L3_2(PL(0,151),W(1,18),GC_5,MDL_MT,MDL_WT,PL(0,152)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,151),4,COEFS,4,4,WL(1,0,1
     $ ,152))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,152),2,4,56,1,1,329,H)
C     Coefficient construction for loop diagram with ID 82
      CALL MP_FFV1L2P0_3(PL(0,143),W(1,10),GC_5,ZERO,ZERO,PL(0,153)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,143),4,COEFS,4,4,WL(1,0,1
     $ ,153))
      CALL MP_FFV1L3_1(PL(0,153),W(1,4),GC_5,MDL_MT,MDL_WT,PL(0,154)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,153),4,COEFS,4,4,WL(1,0,1
     $ ,154))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,154),3,4,57,1,1,330,H)
C     Coefficient construction for loop diagram with ID 83
      CALL MP_FFV1L1P0_3(PL(0,139),W(1,4),GC_5,ZERO,ZERO,PL(0,155)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,139),4,COEFS,4,4,WL(1,0,1
     $ ,155))
      CALL MP_FFV1L3_2(PL(0,155),W(1,10),GC_5,MDL_MB,ZERO,PL(0,156)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,155),4,COEFS,4,4,WL(1,0,1
     $ ,156))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,156),3,4,58,1,1,331,H)
C     Coefficient construction for loop diagram with ID 84
      CALL MP_FFV1L1P0_3(PL(0,39),W(1,28),GC_5,ZERO,ZERO,PL(0,157)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,39),4,COEFS,4,4,WL(1,0,1
     $ ,157))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,157),2,4,16,1,1,332,H)
C     Coefficient construction for loop diagram with ID 85
      CALL MP_VVV1L2P0_1(PL(0,136),W(1,2),GC_4,ZERO,ZERO,PL(0,158)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,136),4,COEFS,4,4,WL(1,0,1
     $ ,158))
      CALL MP_FFV1L3_1(PL(0,158),W(1,7),GC_5,MDL_MB,ZERO,PL(0,159)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,158),4,COEFS,4,4,WL(1,0,1
     $ ,159))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,159),3,4,59,1,1,333,H)
C     Coefficient construction for loop diagram with ID 86
      CALL MP_VVVV1L2P0_1(PL(0,38),W(1,14),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,160),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,38),4,COEFS,4,4,WL(1,0,1
     $ ,160))
      CALL MP_VVVV3L2P0_1(PL(0,38),W(1,14),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,161),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,38),4,COEFS,4,4,WL(1,0,1
     $ ,161))
      CALL MP_VVVV4L2P0_1(PL(0,38),W(1,14),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,162),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,38),4,COEFS,4,4,WL(1,0,1
     $ ,162))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,160),1,4,60,2,1,334,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,161),1,4,60,2,1,335,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,162),1,4,60,2,1,336,H)
C     Coefficient construction for loop diagram with ID 87
      CALL MP_FFV1L2P0_3(PL(0,68),W(1,26),GC_5,ZERO,ZERO,PL(0,163)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,68),4,COEFS,4,4,WL(1,0,1
     $ ,163))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,163),2,4,26,1,1,337,H)
C     Coefficient construction for loop diagram with ID 88
      CALL MP_VVV1L2P0_1(PL(0,151),W(1,2),GC_4,ZERO,ZERO,PL(0,164)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,151),4,COEFS,4,4,WL(1,0,1
     $ ,164))
      CALL MP_FFV1L3_2(PL(0,164),W(1,8),GC_5,MDL_MT,MDL_WT,PL(0,165)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,164),4,COEFS,4,4,WL(1,0,1
     $ ,165))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,165),3,4,61,1,1,338,H)
C     Coefficient construction for loop diagram with ID 89
      CALL MP_VVVV1L2P0_1(PL(0,38),W(1,16),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,166),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,38),4,COEFS,4,4,WL(1,0,1
     $ ,166))
      CALL MP_VVVV3L2P0_1(PL(0,38),W(1,16),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,167),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,38),4,COEFS,4,4,WL(1,0,1
     $ ,167))
      CALL MP_VVVV4L2P0_1(PL(0,38),W(1,16),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,168),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,38),4,COEFS,4,4,WL(1,0,1
     $ ,168))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,166),1,4,60,2,1,339,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,167),1,4,60,2,1,340,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,168),1,4,60,2,1,341,H)
C     Coefficient construction for loop diagram with ID 90
      CALL MP_VVV1L2P0_1(PL(0,144),W(1,2),GC_4,ZERO,ZERO,PL(0,169)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,144),4,COEFS,4,4,WL(1,0,1
     $ ,169))
      CALL MP_FFV1L3_1(PL(0,169),W(1,4),GC_5,MDL_MT,MDL_WT,PL(0,170)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_1(WL(1,0,1,169),4,COEFS,4,4,WL(1,0,1
     $ ,170))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,170),4,4,62,1,1,342,H)
C     Coefficient construction for loop diagram with ID 91
      CALL MP_VVV1L2P0_1(PL(0,155),W(1,2),GC_4,ZERO,ZERO,PL(0,171)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,155),4,COEFS,4,4,WL(1,0,1
     $ ,171))
      CALL MP_FFV1L3_2(PL(0,171),W(1,5),GC_5,MDL_MB,ZERO,PL(0,172)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_1(WL(1,0,1,171),4,COEFS,4,4,WL(1,0,1
     $ ,172))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,172),4,4,63,1,1,343,H)
C     Coefficient construction for loop diagram with ID 92
      CALL MP_FFV1L3_1(PL(0,52),W(1,28),GC_5,MDL_MB,ZERO,PL(0,173)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,52),4,COEFS,4,4,WL(1,0,1
     $ ,173))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,173),2,4,20,1,1,344,H)
C     Coefficient construction for loop diagram with ID 93
      CALL MP_FFV1L3_1(PL(0,136),W(1,24),GC_5,MDL_MB,ZERO,PL(0,174)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,136),4,COEFS,4,4,WL(1,0,1
     $ ,174))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,174),2,4,52,1,1,345,H)
C     Coefficient construction for loop diagram with ID 94
      CALL MP_FFV1L1_2(PL(0,138),W(1,2),GC_5,MDL_MB,ZERO,PL(0,175)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,138),4,COEFS,4,4,WL(1,0,1
     $ ,175))
      CALL MP_FFV1L1P0_3(PL(0,175),W(1,7),GC_5,ZERO,ZERO,PL(0,176)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,175),4,COEFS,4,4,WL(1,0,1
     $ ,176))
      CALL MP_FFV1L3_2(PL(0,176),W(1,5),GC_5,MDL_MB,ZERO,PL(0,177)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,176),4,COEFS,4,4,WL(1,0,1
     $ ,177))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,177),3,4,64,1,1,346,H)
C     Coefficient construction for loop diagram with ID 95
      CALL MP_FFV1L2_1(PL(0,135),W(1,2),GC_5,MDL_MB,ZERO,PL(0,178)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,135),4,COEFS,4,4,WL(1,0,1
     $ ,178))
      CALL MP_FFV1L2P0_3(PL(0,178),W(1,5),GC_5,ZERO,ZERO,PL(0,179)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,178),4,COEFS,4,4,WL(1,0,1
     $ ,179))
      CALL MP_FFV1L3_1(PL(0,179),W(1,7),GC_5,MDL_MB,ZERO,PL(0,180)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,179),4,COEFS,4,4,WL(1,0,1
     $ ,180))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,180),3,4,65,1,1,347,H)
C     Coefficient construction for loop diagram with ID 96
      CALL MP_FFV1L3_2(PL(0,79),W(1,26),GC_5,MDL_MT,MDL_WT,PL(0,181)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,79),4,COEFS,4,4,WL(1,0,1
     $ ,181))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,181),2,4,30,1,1,348,H)
C     Coefficient construction for loop diagram with ID 97
      CALL MP_FFV1L3_2(PL(0,151),W(1,20),GC_5,MDL_MT,MDL_WT,PL(0,182)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,151),4,COEFS,4,4,WL(1,0,1
     $ ,182))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,182),2,4,56,1,1,349,H)
C     Coefficient construction for loop diagram with ID 98
      CALL MP_FFV1L2_1(PL(0,142),W(1,2),GC_5,MDL_MT,MDL_WT,PL(0,183)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,142),4,COEFS,4,4,WL(1,0,1
     $ ,183))
      CALL MP_FFV1L2P0_3(PL(0,183),W(1,8),GC_5,ZERO,ZERO,PL(0,184)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,183),4,COEFS,4,4,WL(1,0,1
     $ ,184))
      CALL MP_FFV1L3_1(PL(0,184),W(1,4),GC_5,MDL_MT,MDL_WT,PL(0,185)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,184),4,COEFS,4,4,WL(1,0,1
     $ ,185))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,185),3,4,66,1,1,350,H)
C     Coefficient construction for loop diagram with ID 99
      CALL MP_FFV1L1_2(PL(0,131),W(1,2),GC_5,MDL_MT,MDL_WT,PL(0,186)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,131),4,COEFS,4,4,WL(1,0,1
     $ ,186))
      CALL MP_FFV1L1P0_3(PL(0,186),W(1,4),GC_5,ZERO,ZERO,PL(0,187)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_0(WL(1,0,1,186),4,COEFS,4,4,WL(1,0,1
     $ ,187))
      CALL MP_FFV1L3_2(PL(0,187),W(1,8),GC_5,MDL_MT,MDL_WT,PL(0,188)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,187),4,COEFS,4,4,WL(1,0,1
     $ ,188))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,188),3,4,67,1,1,351,H)
C     Coefficient construction for loop diagram with ID 100
      CALL MP_FFV1L2_1(PL(0,143),W(1,2),GC_5,MDL_MB,ZERO,PL(0,189)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,143),4,COEFS,4,4,WL(1,0,1
     $ ,189))
      CALL MP_FFV1L2P0_3(PL(0,189),W(1,5),GC_5,ZERO,ZERO,PL(0,190)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_0(WL(1,0,1,189),4,COEFS,4,4,WL(1,0,1
     $ ,190))
      CALL MP_FFV1L3_1(PL(0,190),W(1,4),GC_5,MDL_MT,MDL_WT,PL(0,191)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_1(WL(1,0,1,190),4,COEFS,4,4,WL(1,0,1
     $ ,191))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,191),4,4,68,1,1,352,H)
C     Coefficient construction for loop diagram with ID 101
      CALL MP_FFV2L2_1(PL(0,183),W(1,3),GC_47,MDL_MB,ZERO,PL(0,192)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,183),4,COEFS,4,4,WL(1,0,1
     $ ,192))
      CALL MP_FFV1L2P0_3(PL(0,192),W(1,5),GC_5,ZERO,ZERO,PL(0,193)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_0(WL(1,0,1,192),4,COEFS,4,4,WL(1,0,1
     $ ,193))
      CALL MP_FFV1L3_1(PL(0,193),W(1,4),GC_5,MDL_MT,MDL_WT,PL(0,194)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_1(WL(1,0,1,193),4,COEFS,4,4,WL(1,0,1
     $ ,194))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,194),4,4,69,1,1,353,H)
C     Coefficient construction for loop diagram with ID 102
      CALL MP_FFV1L1_2(PL(0,139),W(1,2),GC_5,MDL_MT,MDL_WT,PL(0,195)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,139),4,COEFS,4,4,WL(1,0,1
     $ ,195))
      CALL MP_FFV1L1P0_3(PL(0,195),W(1,4),GC_5,ZERO,ZERO,PL(0,196)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_0(WL(1,0,1,195),4,COEFS,4,4,WL(1,0,1
     $ ,196))
      CALL MP_FFV1L3_2(PL(0,196),W(1,5),GC_5,MDL_MB,ZERO,PL(0,197)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_1(WL(1,0,1,196),4,COEFS,4,4,WL(1,0,1
     $ ,197))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,197),4,4,70,1,1,354,H)
C     Coefficient construction for loop diagram with ID 103
      CALL MP_FFV2L1_2(PL(0,175),W(1,3),GC_47,MDL_MT,MDL_WT,PL(0,198)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,175),4,COEFS,4,4,WL(1,0,1
     $ ,198))
      CALL MP_FFV1L1P0_3(PL(0,198),W(1,4),GC_5,ZERO,ZERO,PL(0,199)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_0(WL(1,0,1,198),4,COEFS,4,4,WL(1,0,1
     $ ,199))
      CALL MP_FFV1L3_2(PL(0,199),W(1,5),GC_5,MDL_MB,ZERO,PL(0,200)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_1(WL(1,0,1,199),4,COEFS,4,4,WL(1,0,1
     $ ,200))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,200),4,4,71,1,1,355,H)
C     Coefficient construction for loop diagram with ID 104
      CALL MP_FFV1L3_2(PL(0,187),W(1,5),GC_5,MDL_MB,ZERO,PL(0,201)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,187),4,COEFS,4,4,WL(1,0,1
     $ ,201))
      CALL MP_FFV2L1_2(PL(0,201),W(1,3),GC_47,MDL_MT,MDL_WT,PL(0,202)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_1(WL(1,0,1,201),4,COEFS,4,4,WL(1,0,1
     $ ,202))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,202),4,4,72,1,1,356,H)
C     Coefficient construction for loop diagram with ID 105
      CALL MP_FFV1L3_1(PL(0,179),W(1,4),GC_5,MDL_MT,MDL_WT,PL(0,203)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,179),4,COEFS,4,4,WL(1,0,1
     $ ,203))
      CALL MP_FFV2L2_1(PL(0,203),W(1,3),GC_47,MDL_MB,ZERO,PL(0,204)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_3_1(WL(1,0,1,203),4,COEFS,4,4,WL(1,0,1
     $ ,204))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,204),4,4,73,1,1,357,H)
C     Coefficient construction for loop diagram with ID 106
      CALL MP_VVVV1L2P0_1(PL(0,5),W(1,2),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,205),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,5),4,COEFS,4,4,WL(1,0,1,205)
     $ )
      CALL MP_VVVV3L2P0_1(PL(0,5),W(1,2),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,206),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,5),4,COEFS,4,4,WL(1,0,1,206)
     $ )
      CALL MP_VVVV4L2P0_1(PL(0,5),W(1,2),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,207),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,5),4,COEFS,4,4,WL(1,0,1,207)
     $ )
      CALL MP_FFV1L3_1(PL(0,205),W(1,7),GC_5,MDL_MB,ZERO,PL(0,208)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,205),4,COEFS,4,4,WL(1,0,1
     $ ,208))
      CALL MP_FFV1L3_1(PL(0,206),W(1,7),GC_5,MDL_MB,ZERO,PL(0,209)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,206),4,COEFS,4,4,WL(1,0,1
     $ ,209))
      CALL MP_FFV1L3_1(PL(0,207),W(1,7),GC_5,MDL_MB,ZERO,PL(0,210)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,207),4,COEFS,4,4,WL(1,0,1
     $ ,210))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,208),1,4,3,1,1,358,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,209),1,4,3,1,1,359,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,210),1,4,3,1,1,360,H)
C     Coefficient construction for loop diagram with ID 107
      CALL MP_VVVV1L2P0_1(PL(0,0),W(1,2),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,211),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,211)
     $ )
      CALL MP_VVVV3L2P0_1(PL(0,0),W(1,2),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,212),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,212)
     $ )
      CALL MP_VVVV4L2P0_1(PL(0,0),W(1,2),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,213),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,213)
     $ )
      CALL MP_VVV1L2P0_1(PL(0,211),W(1,14),GC_4,ZERO,ZERO,PL(0,214)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,211),4,COEFS,4,4,WL(1,0,1
     $ ,214))
      CALL MP_VVV1L2P0_1(PL(0,212),W(1,14),GC_4,ZERO,ZERO,PL(0,215)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,212),4,COEFS,4,4,WL(1,0,1
     $ ,215))
      CALL MP_VVV1L2P0_1(PL(0,213),W(1,14),GC_4,ZERO,ZERO,PL(0,216)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,213),4,COEFS,4,4,WL(1,0,1
     $ ,216))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,214),1,4,2,2,1,361,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,215),1,4,2,2,1,362,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,216),1,4,2,2,1,363,H)
C     Coefficient construction for loop diagram with ID 108
      CALL MP_VVVV1L2P0_1(PL(0,14),W(1,2),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,217),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,14),4,COEFS,4,4,WL(1,0,1
     $ ,217))
      CALL MP_VVVV3L2P0_1(PL(0,14),W(1,2),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,218),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,14),4,COEFS,4,4,WL(1,0,1
     $ ,218))
      CALL MP_VVVV4L2P0_1(PL(0,14),W(1,2),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,219),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_0(WL(1,0,1,14),4,COEFS,4,4,WL(1,0,1
     $ ,219))
      CALL MP_FFV1L3_2(PL(0,217),W(1,8),GC_5,MDL_MT,MDL_WT,PL(0,220)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,217),4,COEFS,4,4,WL(1,0,1
     $ ,220))
      CALL MP_FFV1L3_2(PL(0,218),W(1,8),GC_5,MDL_MT,MDL_WT,PL(0,221)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,218),4,COEFS,4,4,WL(1,0,1
     $ ,221))
      CALL MP_FFV1L3_2(PL(0,219),W(1,8),GC_5,MDL_MT,MDL_WT,PL(0,222)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,219),4,COEFS,4,4,WL(1,0,1
     $ ,222))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,220),1,4,6,1,1,364,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,221),1,4,6,1,1,365,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,222),1,4,6,1,1,366,H)
C     Coefficient construction for loop diagram with ID 109
      CALL MP_VVV1L2P0_1(PL(0,211),W(1,16),GC_4,ZERO,ZERO,PL(0,223)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,211),4,COEFS,4,4,WL(1,0,1
     $ ,223))
      CALL MP_VVV1L2P0_1(PL(0,212),W(1,16),GC_4,ZERO,ZERO,PL(0,224)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,212),4,COEFS,4,4,WL(1,0,1
     $ ,224))
      CALL MP_VVV1L2P0_1(PL(0,213),W(1,16),GC_4,ZERO,ZERO,PL(0,225)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,213),4,COEFS,4,4,WL(1,0,1
     $ ,225))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,223),1,4,2,2,1,367,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,224),1,4,2,2,1,368,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,225),1,4,2,2,1,369,H)
C     Coefficient construction for loop diagram with ID 110
      CALL MP_VVVV1L2P0_1(PL(0,21),W(1,2),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,226),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,21),4,COEFS,4,4,WL(1,0,1
     $ ,226))
      CALL MP_VVVV3L2P0_1(PL(0,21),W(1,2),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,227),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,21),4,COEFS,4,4,WL(1,0,1
     $ ,227))
      CALL MP_VVVV4L2P0_1(PL(0,21),W(1,2),W(1,1),GC_6,ZERO,ZERO,PL(0
     $ ,228),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_0(WL(1,0,1,21),4,COEFS,4,4,WL(1,0,1
     $ ,228))
      CALL MP_FFV1L3_2(PL(0,226),W(1,5),GC_5,MDL_MB,ZERO,PL(0,229)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,226),4,COEFS,4,4,WL(1,0,1
     $ ,229))
      CALL MP_FFV1L3_2(PL(0,227),W(1,5),GC_5,MDL_MB,ZERO,PL(0,230)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,227),4,COEFS,4,4,WL(1,0,1
     $ ,230))
      CALL MP_FFV1L3_2(PL(0,228),W(1,5),GC_5,MDL_MB,ZERO,PL(0,231)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,228),4,COEFS,4,4,WL(1,0,1
     $ ,231))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,229),2,4,9,1,1,370,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,230),2,4,9,1,1,371,H)
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,231),2,4,9,1,1,372,H)
C     Coefficient construction for loop diagram with ID 111
      CALL MP_GHGHGL2_1(PL(0,0),W(1,6),GC_4,ZERO,ZERO,PL(0,232),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,232)
     $ )
      CALL MP_GHGHGL2_1(PL(0,232),W(1,14),GC_4,ZERO,ZERO,PL(0,233)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,232),1,COEFS,1,1,WL(1,0,1
     $ ,233))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,233),2,1,2,1,1,373,H)
C     Coefficient construction for loop diagram with ID 112
      CALL MP_GHGHGL2_1(PL(0,232),W(1,16),GC_4,ZERO,ZERO,PL(0,234)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,232),1,COEFS,1,1,WL(1,0,1
     $ ,234))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,234),2,1,2,1,1,374,H)
C     Coefficient construction for loop diagram with ID 113
      CALL MP_GHGHGL1_2(PL(0,0),W(1,1),GC_4,ZERO,ZERO,PL(0,235),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,235)
     $ )
      CALL MP_GHGHGL1_2(PL(0,235),W(1,2),GC_4,ZERO,ZERO,PL(0,236)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,235),1,COEFS,1,1,WL(1,0,1
     $ ,236))
      CALL MP_GHGHGL1_2(PL(0,236),W(1,14),GC_4,ZERO,ZERO,PL(0,237)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,236),1,COEFS,1,1,WL(1,0,1
     $ ,237))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,237),3,1,41,1,1,375,H)
C     Coefficient construction for loop diagram with ID 114
      CALL MP_GHGHGL1_2(PL(0,236),W(1,16),GC_4,ZERO,ZERO,PL(0,238)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,236),1,COEFS,1,1,WL(1,0,1
     $ ,238))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,238),3,1,41,1,1,376,H)
C     Coefficient construction for loop diagram with ID 115
      CALL MP_GHGHGL2_1(PL(0,0),W(1,1),GC_4,ZERO,ZERO,PL(0,239),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),1,COEFS,1,1,WL(1,0,1,239)
     $ )
      CALL MP_GHGHGL2_1(PL(0,239),W(1,2),GC_4,ZERO,ZERO,PL(0,240)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,239),1,COEFS,1,1,WL(1,0,1
     $ ,240))
      CALL MP_GHGHGL2_1(PL(0,240),W(1,14),GC_4,ZERO,ZERO,PL(0,241)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,240),1,COEFS,1,1,WL(1,0,1
     $ ,241))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,241),3,1,41,1,1,377,H)
C     Coefficient construction for loop diagram with ID 116
      CALL MP_GHGHGL2_1(PL(0,240),W(1,16),GC_4,ZERO,ZERO,PL(0,242)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,240),1,COEFS,1,1,WL(1,0,1
     $ ,242))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,242),3,1,41,1,1,378,H)
C     Coefficient construction for loop diagram with ID 117
      CALL MP_FFV1L2_1(PL(0,0),W(1,6),GC_5,ZERO,ZERO,PL(0,243),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,243)
     $ )
      CALL MP_FFV1L2_1(PL(0,243),W(1,14),GC_5,ZERO,ZERO,PL(0,244)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,243),4,COEFS,4,4,WL(1,0,1
     $ ,244))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,244),2,4,2,1,4,379,H)
C     Coefficient construction for loop diagram with ID 118
      CALL MP_FFV1L2_1(PL(0,243),W(1,16),GC_5,ZERO,ZERO,PL(0,245)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,243),4,COEFS,4,4,WL(1,0,1
     $ ,245))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,245),2,4,2,1,4,380,H)
C     Coefficient construction for loop diagram with ID 119
      CALL MP_FFV1L1_2(PL(0,0),W(1,1),GC_5,ZERO,ZERO,PL(0,246),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,246)
     $ )
      CALL MP_FFV1L1_2(PL(0,246),W(1,2),GC_5,ZERO,ZERO,PL(0,247),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,246),4,COEFS,4,4,WL(1,0,1
     $ ,247))
      CALL MP_FFV1L1_2(PL(0,247),W(1,14),GC_5,ZERO,ZERO,PL(0,248)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,247),4,COEFS,4,4,WL(1,0,1
     $ ,248))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,248),3,4,41,1,4,381,H)
C     Coefficient construction for loop diagram with ID 120
      CALL MP_FFV1L1_2(PL(0,247),W(1,16),GC_5,ZERO,ZERO,PL(0,249)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,247),4,COEFS,4,4,WL(1,0,1
     $ ,249))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,249),3,4,41,1,4,382,H)
C     Coefficient construction for loop diagram with ID 121
      CALL MP_FFV1L2_1(PL(0,0),W(1,1),GC_5,ZERO,ZERO,PL(0,250),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,250)
     $ )
      CALL MP_FFV1L2_1(PL(0,250),W(1,2),GC_5,ZERO,ZERO,PL(0,251),COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,250),4,COEFS,4,4,WL(1,0,1
     $ ,251))
      CALL MP_FFV1L2_1(PL(0,251),W(1,14),GC_5,ZERO,ZERO,PL(0,252)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,251),4,COEFS,4,4,WL(1,0,1
     $ ,252))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,252),3,4,41,1,4,383,H)
C     Coefficient construction for loop diagram with ID 122
      CALL MP_FFV1L2_1(PL(0,251),W(1,16),GC_5,ZERO,ZERO,PL(0,253)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,251),4,COEFS,4,4,WL(1,0,1
     $ ,253))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,253),3,4,41,1,4,384,H)
C     Coefficient construction for loop diagram with ID 123
      CALL MP_FFV1L2_1(PL(0,0),W(1,6),GC_5,MDL_MB,ZERO,PL(0,254),COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,254)
     $ )
      CALL MP_FFV1L2_1(PL(0,254),W(1,14),GC_5,MDL_MB,ZERO,PL(0,255)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,254),4,COEFS,4,4,WL(1,0,1
     $ ,255))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,255),2,4,74,1,1,385,H)
C     Coefficient construction for loop diagram with ID 124
      CALL MP_FFV1L2_1(PL(0,254),W(1,16),GC_5,MDL_MB,ZERO,PL(0,256)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,254),4,COEFS,4,4,WL(1,0,1
     $ ,256))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,256),2,4,74,1,1,386,H)
C     Coefficient construction for loop diagram with ID 125
      CALL MP_FFV1L1_2(PL(0,175),W(1,14),GC_5,MDL_MB,ZERO,PL(0,257)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,175),4,COEFS,4,4,WL(1,0,1
     $ ,257))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,257),3,4,75,1,1,387,H)
C     Coefficient construction for loop diagram with ID 126
      CALL MP_FFV1L1_2(PL(0,175),W(1,16),GC_5,MDL_MB,ZERO,PL(0,258)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,175),4,COEFS,4,4,WL(1,0,1
     $ ,258))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,258),3,4,75,1,1,388,H)
C     Coefficient construction for loop diagram with ID 127
      CALL MP_FFV1L2_1(PL(0,178),W(1,14),GC_5,MDL_MB,ZERO,PL(0,259)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,178),4,COEFS,4,4,WL(1,0,1
     $ ,259))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,259),3,4,75,1,1,389,H)
C     Coefficient construction for loop diagram with ID 128
      CALL MP_FFV1L2_1(PL(0,178),W(1,16),GC_5,MDL_MB,ZERO,PL(0,260)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,178),4,COEFS,4,4,WL(1,0,1
     $ ,260))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,260),3,4,75,1,1,390,H)
C     Coefficient construction for loop diagram with ID 129
      CALL MP_FFV1L2_1(PL(0,0),W(1,6),GC_5,MDL_MT,MDL_WT,PL(0,261)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_0_1(WL(1,0,1,0),4,COEFS,4,4,WL(1,0,1,261)
     $ )
      CALL MP_FFV1L2_1(PL(0,261),W(1,14),GC_5,MDL_MT,MDL_WT,PL(0,262)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,261),4,COEFS,4,4,WL(1,0,1
     $ ,262))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,262),2,4,76,1,1,391,H)
C     Coefficient construction for loop diagram with ID 130
      CALL MP_FFV1L2_1(PL(0,261),W(1,16),GC_5,MDL_MT,MDL_WT,PL(0,263)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_1_1(WL(1,0,1,261),4,COEFS,4,4,WL(1,0,1
     $ ,263))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,263),2,4,76,1,1,392,H)
C     Coefficient construction for loop diagram with ID 131
      CALL MP_FFV1L1_2(PL(0,186),W(1,14),GC_5,MDL_MT,MDL_WT,PL(0,264)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,186),4,COEFS,4,4,WL(1,0,1
     $ ,264))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,264),3,4,77,1,1,393,H)
C     Coefficient construction for loop diagram with ID 132
      CALL MP_FFV1L1_2(PL(0,186),W(1,16),GC_5,MDL_MT,MDL_WT,PL(0,265)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,186),4,COEFS,4,4,WL(1,0,1
     $ ,265))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,265),3,4,77,1,1,394,H)
C     Coefficient construction for loop diagram with ID 133
      CALL MP_FFV1L2_1(PL(0,183),W(1,14),GC_5,MDL_MT,MDL_WT,PL(0,266)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,183),4,COEFS,4,4,WL(1,0,1
     $ ,266))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,266),3,4,77,1,1,395,H)
C     Coefficient construction for loop diagram with ID 134
      CALL MP_FFV1L2_1(PL(0,183),W(1,16),GC_5,MDL_MT,MDL_WT,PL(0,267)
     $ ,COEFS)
      CALL MP_ML5_0_UPDATE_WL_2_1(WL(1,0,1,183),4,COEFS,4,4,WL(1,0,1
     $ ,267))
      CALL MP_ML5_0_CREATE_LOOP_COEFS(WL(1,0,1,267),3,4,77,1,1,396,H)

      GOTO 1001
 4000 CONTINUE
      MP_LOOP_REQ_SO_DONE=.TRUE.
 1001 CONTINUE
      END

